//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Aed0automationelectricdesign

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libAed0automationelectricdesign

#if !defined(LIBAED0AUTOMATIONELECTRICDESIGN) && !defined(IPLIB)
#   error IPLIB or LIBAED0AUTOMATIONELECTRICDESIGN is not defined
#endif

/* Handwritten code should use AED0AUTOMATIONELECTRICDESIGN_API, not AED0AUTOMATIONELECTRICDESIGNEXPORT */

#define AED0AUTOMATIONELECTRICDESIGN_API AED0AUTOMATIONELECTRICDESIGNEXPORT

#if IPLIB==libAed0automationelectricdesign || defined(LIBAED0AUTOMATIONELECTRICDESIGN)
#   if defined(__lint)
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT       __export(Aed0automationelectricdesign)
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern __global(Aed0automationelectricdesign)
#       define AED0AUTOMATIONELECTRICDESIGNPRIVATE      extern __private(Aed0automationelectricdesign)
#   elif defined(_WIN32)
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT       __declspec(dllexport)
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern __declspec(dllexport)
#       define AED0AUTOMATIONELECTRICDESIGNPRIVATE      extern
#   else
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern
#       define AED0AUTOMATIONELECTRICDESIGNPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT       __export(Aed0automationelectricdesign)
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern __global(Aed0automationelectricdesign)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT      __declspec(dllimport)
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern __declspec(dllimport)
#   else
#       define AED0AUTOMATIONELECTRICDESIGNEXPORT
#       define AED0AUTOMATIONELECTRICDESIGNGLOBAL       extern
#   endif
#endif
