//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Ap0advanceplanner

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libAp0advanceplanner

#if !defined(LIBAP0ADVANCEPLANNER) && !defined(IPLIB)
#   error IPLIB or LIBAP0ADVANCEPLANNER is not defined
#endif

/* Handwritten code should use AP0ADVANCEPLANNER_API, not AP0ADVANCEPLANNEREXPORT */

#define AP0ADVANCEPLANNER_API AP0ADVANCEPLANNEREXPORT

#if IPLIB==libAp0advanceplanner || defined(LIBAP0ADVANCEPLANNER)
#   if defined(__lint)
#       define AP0ADVANCEPLANNEREXPORT       __export(Ap0advanceplanner)
#       define AP0ADVANCEPLANNERGLOBAL       extern __global(Ap0advanceplanner)
#       define AP0ADVANCEPLANNERPRIVATE      extern __private(Ap0advanceplanner)
#   elif defined(_WIN32)
#       define AP0ADVANCEPLANNEREXPORT       __declspec(dllexport)
#       define AP0ADVANCEPLANNERGLOBAL       extern __declspec(dllexport)
#       define AP0ADVANCEPLANNERPRIVATE      extern
#   else
#       define AP0ADVANCEPLANNEREXPORT
#       define AP0ADVANCEPLANNERGLOBAL       extern
#       define AP0ADVANCEPLANNERPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AP0ADVANCEPLANNEREXPORT       __export(Ap0advanceplanner)
#       define AP0ADVANCEPLANNERGLOBAL       extern __global(Ap0advanceplanner)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AP0ADVANCEPLANNEREXPORT      __declspec(dllimport)
#       define AP0ADVANCEPLANNERGLOBAL       extern __declspec(dllimport)
#   else
#       define AP0ADVANCEPLANNEREXPORT
#       define AP0ADVANCEPLANNERGLOBAL       extern
#   endif
#endif
