//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Bom0plantbommgmt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libBom0plantbommgmt

#if !defined(LIBBOM0PLANTBOMMGMT) && !defined(IPLIB)
#   error IPLIB or LIBBOM0PLANTBOMMGMT is not defined
#endif

/* Handwritten code should use BOM0PLANTBOMMGMT_API, not BOM0PLANTBOMMGMTEXPORT */

#define BOM0PLANTBOMMGMT_API BOM0PLANTBOMMGMTEXPORT

#if IPLIB==libBom0plantbommgmt || defined(LIBBOM0PLANTBOMMGMT)
#   if defined(__lint)
#       define BOM0PLANTBOMMGMTEXPORT       __export(Bom0plantbommgmt)
#       define BOM0PLANTBOMMGMTGLOBAL       extern __global(Bom0plantbommgmt)
#       define BOM0PLANTBOMMGMTPRIVATE      extern __private(Bom0plantbommgmt)
#   elif defined(_WIN32)
#       define BOM0PLANTBOMMGMTEXPORT       __declspec(dllexport)
#       define BOM0PLANTBOMMGMTGLOBAL       extern __declspec(dllexport)
#       define BOM0PLANTBOMMGMTPRIVATE      extern
#   else
#       define BOM0PLANTBOMMGMTEXPORT
#       define BOM0PLANTBOMMGMTGLOBAL       extern
#       define BOM0PLANTBOMMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BOM0PLANTBOMMGMTEXPORT       __export(Bom0plantbommgmt)
#       define BOM0PLANTBOMMGMTGLOBAL       extern __global(Bom0plantbommgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BOM0PLANTBOMMGMTEXPORT      __declspec(dllimport)
#       define BOM0PLANTBOMMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define BOM0PLANTBOMMGMTEXPORT
#       define BOM0PLANTBOMMGMTGLOBAL       extern
#   endif
#endif
