//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Bom0psdalignment

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libBom0psdalignment

#if !defined(LIBBOM0PSDALIGNMENT) && !defined(IPLIB)
#   error IPLIB or LIBBOM0PSDALIGNMENT is not defined
#endif

/* Handwritten code should use BOM0PSDALIGNMENT_API, not BOM0PSDALIGNMENTEXPORT */

#define BOM0PSDALIGNMENT_API BOM0PSDALIGNMENTEXPORT

#if IPLIB==libBom0psdalignment || defined(LIBBOM0PSDALIGNMENT)
#   if defined(__lint)
#       define BOM0PSDALIGNMENTEXPORT       __export(Bom0psdalignment)
#       define BOM0PSDALIGNMENTGLOBAL       extern __global(Bom0psdalignment)
#       define BOM0PSDALIGNMENTPRIVATE      extern __private(Bom0psdalignment)
#   elif defined(_WIN32)
#       define BOM0PSDALIGNMENTEXPORT       __declspec(dllexport)
#       define BOM0PSDALIGNMENTGLOBAL       extern __declspec(dllexport)
#       define BOM0PSDALIGNMENTPRIVATE      extern
#   else
#       define BOM0PSDALIGNMENTEXPORT
#       define BOM0PSDALIGNMENTGLOBAL       extern
#       define BOM0PSDALIGNMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BOM0PSDALIGNMENTEXPORT       __export(Bom0psdalignment)
#       define BOM0PSDALIGNMENTGLOBAL       extern __global(Bom0psdalignment)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BOM0PSDALIGNMENTEXPORT      __declspec(dllimport)
#       define BOM0PSDALIGNMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define BOM0PSDALIGNMENTEXPORT
#       define BOM0PSDALIGNMENTGLOBAL       extern
#   endif
#endif
