//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Cbm0colorbompmm

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libCbm0colorbompmm

#if !defined(LIBCBM0COLORBOMPMM) && !defined(IPLIB)
#   error IPLIB or LIBCBM0COLORBOMPMM is not defined
#endif

/* Handwritten code should use CBM0COLORBOMPMM_API, not CBM0COLORBOMPMMEXPORT */

#define CBM0COLORBOMPMM_API CBM0COLORBOMPMMEXPORT

#if IPLIB==libCbm0colorbompmm || defined(LIBCBM0COLORBOMPMM)
#   if defined(__lint)
#       define CBM0COLORBOMPMMEXPORT       __export(Cbm0colorbompmm)
#       define CBM0COLORBOMPMMGLOBAL       extern __global(Cbm0colorbompmm)
#       define CBM0COLORBOMPMMPRIVATE      extern __private(Cbm0colorbompmm)
#   elif defined(_WIN32)
#       define CBM0COLORBOMPMMEXPORT       __declspec(dllexport)
#       define CBM0COLORBOMPMMGLOBAL       extern __declspec(dllexport)
#       define CBM0COLORBOMPMMPRIVATE      extern
#   else
#       define CBM0COLORBOMPMMEXPORT
#       define CBM0COLORBOMPMMGLOBAL       extern
#       define CBM0COLORBOMPMMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CBM0COLORBOMPMMEXPORT       __export(Cbm0colorbompmm)
#       define CBM0COLORBOMPMMGLOBAL       extern __global(Cbm0colorbompmm)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CBM0COLORBOMPMMEXPORT      __declspec(dllimport)
#       define CBM0COLORBOMPMMGLOBAL       extern __declspec(dllimport)
#   else
#       define CBM0COLORBOMPMMEXPORT
#       define CBM0COLORBOMPMMGLOBAL       extern
#   endif
#endif
