//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Ssm0systemsynthesismodeling

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libSsm0systemsynthesismodeling

#if !defined(LIBSSM0SYSTEMSYNTHESISMODELING) && !defined(IPLIB)
#   error IPLIB or LIBSSM0SYSTEMSYNTHESISMODELING is not defined
#endif

/* Handwritten code should use SSM0SYSTEMSYNTHESISMODELING_API, not SSM0SYSTEMSYNTHESISMODELINGEXPORT */

#define SSM0SYSTEMSYNTHESISMODELING_API SSM0SYSTEMSYNTHESISMODELINGEXPORT

#if IPLIB==libSsm0systemsynthesismodeling || defined(LIBSSM0SYSTEMSYNTHESISMODELING)
#   if defined(__lint)
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT       __export(Ssm0systemsynthesismodeling)
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern __global(Ssm0systemsynthesismodeling)
#       define SSM0SYSTEMSYNTHESISMODELINGPRIVATE      extern __private(Ssm0systemsynthesismodeling)
#   elif defined(_WIN32)
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT       __declspec(dllexport)
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern __declspec(dllexport)
#       define SSM0SYSTEMSYNTHESISMODELINGPRIVATE      extern
#   else
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern
#       define SSM0SYSTEMSYNTHESISMODELINGPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT       __export(Ssm0systemsynthesismodeling)
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern __global(Ssm0systemsynthesismodeling)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT      __declspec(dllimport)
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern __declspec(dllimport)
#   else
#       define SSM0SYSTEMSYNTHESISMODELINGEXPORT
#       define SSM0SYSTEMSYNTHESISMODELINGGLOBAL       extern
#   endif
#endif
