//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  adschangemanagementdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libadschangemanagementdispatch

#if !defined(LIBADSCHANGEMANAGEMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBADSCHANGEMANAGEMENTDISPATCH is not defined
#endif

/* Handwritten code should use ADSCHANGEMANAGEMENTDISPATCH_API, not ADSCHANGEMANAGEMENTDISPATCHEXPORT */

#define ADSCHANGEMANAGEMENTDISPATCH_API ADSCHANGEMANAGEMENTDISPATCHEXPORT

#if IPLIB==libadschangemanagementdispatch || defined(LIBADSCHANGEMANAGEMENTDISPATCH)
#   if defined(__lint)
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT       __export(adschangemanagementdispatch)
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern __global(adschangemanagementdispatch)
#       define ADSCHANGEMANAGEMENTDISPATCHPRIVATE      extern __private(adschangemanagementdispatch)
#   elif defined(_WIN32)
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT       __declspec(dllexport)
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ADSCHANGEMANAGEMENTDISPATCHPRIVATE      extern
#   else
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern
#       define ADSCHANGEMANAGEMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT       __export(adschangemanagementdispatch)
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern __global(adschangemanagementdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT      __declspec(dllimport)
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ADSCHANGEMANAGEMENTDISPATCHEXPORT
#       define ADSCHANGEMANAGEMENTDISPATCHGLOBAL       extern
#   endif
#endif
