//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ap0advanceplannerdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libap0advanceplannerdispatch

#if !defined(LIBAP0ADVANCEPLANNERDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBAP0ADVANCEPLANNERDISPATCH is not defined
#endif

/* Handwritten code should use AP0ADVANCEPLANNERDISPATCH_API, not AP0ADVANCEPLANNERDISPATCHEXPORT */

#define AP0ADVANCEPLANNERDISPATCH_API AP0ADVANCEPLANNERDISPATCHEXPORT

#if IPLIB==libap0advanceplannerdispatch || defined(LIBAP0ADVANCEPLANNERDISPATCH)
#   if defined(__lint)
#       define AP0ADVANCEPLANNERDISPATCHEXPORT       __export(ap0advanceplannerdispatch)
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern __global(ap0advanceplannerdispatch)
#       define AP0ADVANCEPLANNERDISPATCHPRIVATE      extern __private(ap0advanceplannerdispatch)
#   elif defined(_WIN32)
#       define AP0ADVANCEPLANNERDISPATCHEXPORT       __declspec(dllexport)
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern __declspec(dllexport)
#       define AP0ADVANCEPLANNERDISPATCHPRIVATE      extern
#   else
#       define AP0ADVANCEPLANNERDISPATCHEXPORT
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern
#       define AP0ADVANCEPLANNERDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AP0ADVANCEPLANNERDISPATCHEXPORT       __export(ap0advanceplannerdispatch)
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern __global(ap0advanceplannerdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AP0ADVANCEPLANNERDISPATCHEXPORT      __declspec(dllimport)
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define AP0ADVANCEPLANNERDISPATCHEXPORT
#       define AP0ADVANCEPLANNERDISPATCHGLOBAL       extern
#   endif
#endif
