//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cbm0colorbompmmdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcbm0colorbompmmdispatch

#if !defined(LIBCBM0COLORBOMPMMDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCBM0COLORBOMPMMDISPATCH is not defined
#endif

/* Handwritten code should use CBM0COLORBOMPMMDISPATCH_API, not CBM0COLORBOMPMMDISPATCHEXPORT */

#define CBM0COLORBOMPMMDISPATCH_API CBM0COLORBOMPMMDISPATCHEXPORT

#if IPLIB==libcbm0colorbompmmdispatch || defined(LIBCBM0COLORBOMPMMDISPATCH)
#   if defined(__lint)
#       define CBM0COLORBOMPMMDISPATCHEXPORT       __export(cbm0colorbompmmdispatch)
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern __global(cbm0colorbompmmdispatch)
#       define CBM0COLORBOMPMMDISPATCHPRIVATE      extern __private(cbm0colorbompmmdispatch)
#   elif defined(_WIN32)
#       define CBM0COLORBOMPMMDISPATCHEXPORT       __declspec(dllexport)
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CBM0COLORBOMPMMDISPATCHPRIVATE      extern
#   else
#       define CBM0COLORBOMPMMDISPATCHEXPORT
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern
#       define CBM0COLORBOMPMMDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CBM0COLORBOMPMMDISPATCHEXPORT       __export(cbm0colorbompmmdispatch)
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern __global(cbm0colorbompmmdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CBM0COLORBOMPMMDISPATCHEXPORT      __declspec(dllimport)
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CBM0COLORBOMPMMDISPATCHEXPORT
#       define CBM0COLORBOMPMMDISPATCHGLOBAL       extern
#   endif
#endif
