//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cdm0contractmanagementdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcdm0contractmanagementdispatch

#if !defined(LIBCDM0CONTRACTMANAGEMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCDM0CONTRACTMANAGEMENTDISPATCH is not defined
#endif

/* Handwritten code should use CDM0CONTRACTMANAGEMENTDISPATCH_API, not CDM0CONTRACTMANAGEMENTDISPATCHEXPORT */

#define CDM0CONTRACTMANAGEMENTDISPATCH_API CDM0CONTRACTMANAGEMENTDISPATCHEXPORT

#if IPLIB==libcdm0contractmanagementdispatch || defined(LIBCDM0CONTRACTMANAGEMENTDISPATCH)
#   if defined(__lint)
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT       __export(cdm0contractmanagementdispatch)
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern __global(cdm0contractmanagementdispatch)
#       define CDM0CONTRACTMANAGEMENTDISPATCHPRIVATE      extern __private(cdm0contractmanagementdispatch)
#   elif defined(_WIN32)
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT       __declspec(dllexport)
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CDM0CONTRACTMANAGEMENTDISPATCHPRIVATE      extern
#   else
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern
#       define CDM0CONTRACTMANAGEMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT       __export(cdm0contractmanagementdispatch)
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern __global(cdm0contractmanagementdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT      __declspec(dllimport)
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CDM0CONTRACTMANAGEMENTDISPATCHEXPORT
#       define CDM0CONTRACTMANAGEMENTDISPATCHGLOBAL       extern
#   endif
#endif
