//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cfg0configuratordispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcfg0configuratordispatch

#if !defined(LIBCFG0CONFIGURATORDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCFG0CONFIGURATORDISPATCH is not defined
#endif

/* Handwritten code should use CFG0CONFIGURATORDISPATCH_API, not CFG0CONFIGURATORDISPATCHEXPORT */

#define CFG0CONFIGURATORDISPATCH_API CFG0CONFIGURATORDISPATCHEXPORT

#if IPLIB==libcfg0configuratordispatch || defined(LIBCFG0CONFIGURATORDISPATCH)
#   if defined(__lint)
#       define CFG0CONFIGURATORDISPATCHEXPORT       __export(cfg0configuratordispatch)
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern __global(cfg0configuratordispatch)
#       define CFG0CONFIGURATORDISPATCHPRIVATE      extern __private(cfg0configuratordispatch)
#   elif defined(_WIN32)
#       define CFG0CONFIGURATORDISPATCHEXPORT       __declspec(dllexport)
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CFG0CONFIGURATORDISPATCHPRIVATE      extern
#   else
#       define CFG0CONFIGURATORDISPATCHEXPORT
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern
#       define CFG0CONFIGURATORDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CFG0CONFIGURATORDISPATCHEXPORT       __export(cfg0configuratordispatch)
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern __global(cfg0configuratordispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CFG0CONFIGURATORDISPATCHEXPORT      __declspec(dllimport)
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CFG0CONFIGURATORDISPATCHEXPORT
#       define CFG0CONFIGURATORDISPATCHGLOBAL       extern
#   endif
#endif
