//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  clr0colorappearancedispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libclr0colorappearancedispatch

#if !defined(LIBCLR0COLORAPPEARANCEDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCLR0COLORAPPEARANCEDISPATCH is not defined
#endif

/* Handwritten code should use CLR0COLORAPPEARANCEDISPATCH_API, not CLR0COLORAPPEARANCEDISPATCHEXPORT */

#define CLR0COLORAPPEARANCEDISPATCH_API CLR0COLORAPPEARANCEDISPATCHEXPORT

#if IPLIB==libclr0colorappearancedispatch || defined(LIBCLR0COLORAPPEARANCEDISPATCH)
#   if defined(__lint)
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT       __export(clr0colorappearancedispatch)
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern __global(clr0colorappearancedispatch)
#       define CLR0COLORAPPEARANCEDISPATCHPRIVATE      extern __private(clr0colorappearancedispatch)
#   elif defined(_WIN32)
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT       __declspec(dllexport)
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CLR0COLORAPPEARANCEDISPATCHPRIVATE      extern
#   else
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern
#       define CLR0COLORAPPEARANCEDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT       __export(clr0colorappearancedispatch)
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern __global(clr0colorappearancedispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT      __declspec(dllimport)
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CLR0COLORAPPEARANCEDISPATCHEXPORT
#       define CLR0COLORAPPEARANCEDISPATCHGLOBAL       extern
#   endif
#endif
