//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  fnd0absactionitem

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libfnd0absactionitem

#if !defined(LIBFND0ABSACTIONITEM) && !defined(IPLIB)
#   error IPLIB or LIBFND0ABSACTIONITEM is not defined
#endif

/* Handwritten code should use FND0ABSACTIONITEM_API, not FND0ABSACTIONITEMEXPORT */

#define FND0ABSACTIONITEM_API FND0ABSACTIONITEMEXPORT

#if IPLIB==libfnd0absactionitem || defined(LIBFND0ABSACTIONITEM)
#   if defined(__lint)
#       define FND0ABSACTIONITEMEXPORT       __export(fnd0absactionitem)
#       define FND0ABSACTIONITEMGLOBAL       extern __global(fnd0absactionitem)
#       define FND0ABSACTIONITEMPRIVATE      extern __private(fnd0absactionitem)
#   elif defined(_WIN32)
#       define FND0ABSACTIONITEMEXPORT       __declspec(dllexport)
#       define FND0ABSACTIONITEMGLOBAL       extern __declspec(dllexport)
#       define FND0ABSACTIONITEMPRIVATE      extern
#   else
#       define FND0ABSACTIONITEMEXPORT
#       define FND0ABSACTIONITEMGLOBAL       extern
#       define FND0ABSACTIONITEMPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0ABSACTIONITEMEXPORT       __export(fnd0absactionitem)
#       define FND0ABSACTIONITEMGLOBAL       extern __global(fnd0absactionitem)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0ABSACTIONITEMEXPORT      __declspec(dllimport)
#       define FND0ABSACTIONITEMGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0ABSACTIONITEMEXPORT
#       define FND0ABSACTIONITEMGLOBAL       extern
#   endif
#endif
