//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mci0mfgcharacteristicsdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmci0mfgcharacteristicsdispatch

#if !defined(LIBMCI0MFGCHARACTERISTICSDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBMCI0MFGCHARACTERISTICSDISPATCH is not defined
#endif

/* Handwritten code should use MCI0MFGCHARACTERISTICSDISPATCH_API, not MCI0MFGCHARACTERISTICSDISPATCHEXPORT */

#define MCI0MFGCHARACTERISTICSDISPATCH_API MCI0MFGCHARACTERISTICSDISPATCHEXPORT

#if IPLIB==libmci0mfgcharacteristicsdispatch || defined(LIBMCI0MFGCHARACTERISTICSDISPATCH)
#   if defined(__lint)
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT       __export(mci0mfgcharacteristicsdispatch)
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern __global(mci0mfgcharacteristicsdispatch)
#       define MCI0MFGCHARACTERISTICSDISPATCHPRIVATE      extern __private(mci0mfgcharacteristicsdispatch)
#   elif defined(_WIN32)
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT       __declspec(dllexport)
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern __declspec(dllexport)
#       define MCI0MFGCHARACTERISTICSDISPATCHPRIVATE      extern
#   else
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern
#       define MCI0MFGCHARACTERISTICSDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT       __export(mci0mfgcharacteristicsdispatch)
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern __global(mci0mfgcharacteristicsdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT      __declspec(dllimport)
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define MCI0MFGCHARACTERISTICSDISPATCHEXPORT
#       define MCI0MFGCHARACTERISTICSDISPATCHGLOBAL       extern
#   endif
#endif
