/*==================================================================================================

                    Copyright (c) 2007 UGS
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: Object.hxx
    Module  : metaframework

    This is the root class contains the generic methods of Teamcenter Object. Currently, 
    only Teamcenter memory management(placement of new and delete) is implemneted. 
    All the in memory Teamcenter Objects that need to be managed by Teamcenter memory management 
    utility must inherit from Object.

====================================================================================================
   Date      Name                    Description of Change
$HISTORY$
==================================================================================================*/
#ifndef TEAMCENTER__OBJECT_HXX
#define TEAMCENTER__OBJECT_HXX
#include <cstddef>
#include <base_utils/NewOperator.hxx>
#include <metaframework/libmetaframework_exports.h>

namespace Teamcenter
{
    class Object;
}
class METAFRAMEWORK_API Teamcenter::Object
{
public:
    Object();
    virtual ~Object();

    TC_SM_MEMORY_CLASS_NEW_DELETE_OPERATOR_DECLARATIONS
};
#include <metaframework/libmetaframework_undef.h>
#endif

