//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  penetrationmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpenetrationmgmtdispatch

#if !defined(LIBPENETRATIONMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPENETRATIONMGMTDISPATCH is not defined
#endif

/* Handwritten code should use PENETRATIONMGMTDISPATCH_API, not PENETRATIONMGMTDISPATCHEXPORT */

#define PENETRATIONMGMTDISPATCH_API PENETRATIONMGMTDISPATCHEXPORT

#if IPLIB==libpenetrationmgmtdispatch || defined(LIBPENETRATIONMGMTDISPATCH)
#   if defined(__lint)
#       define PENETRATIONMGMTDISPATCHEXPORT       __export(penetrationmgmtdispatch)
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern __global(penetrationmgmtdispatch)
#       define PENETRATIONMGMTDISPATCHPRIVATE      extern __private(penetrationmgmtdispatch)
#   elif defined(_WIN32)
#       define PENETRATIONMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PENETRATIONMGMTDISPATCHPRIVATE      extern
#   else
#       define PENETRATIONMGMTDISPATCHEXPORT
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern
#       define PENETRATIONMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PENETRATIONMGMTDISPATCHEXPORT       __export(penetrationmgmtdispatch)
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern __global(penetrationmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PENETRATIONMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PENETRATIONMGMTDISPATCHEXPORT
#       define PENETRATIONMGMTDISPATCHGLOBAL       extern
#   endif
#endif
