//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  plp0prodlineplan

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libplp0prodlineplan

#if !defined(LIBPLP0PRODLINEPLAN) && !defined(IPLIB)
#   error IPLIB or LIBPLP0PRODLINEPLAN is not defined
#endif

/* Handwritten code should use PLP0PRODLINEPLAN_API, not PLP0PRODLINEPLANEXPORT */

#define PLP0PRODLINEPLAN_API PLP0PRODLINEPLANEXPORT

#if IPLIB==libplp0prodlineplan || defined(LIBPLP0PRODLINEPLAN)
#   if defined(__lint)
#       define PLP0PRODLINEPLANEXPORT       __export(plp0prodlineplan)
#       define PLP0PRODLINEPLANGLOBAL       extern __global(plp0prodlineplan)
#       define PLP0PRODLINEPLANPRIVATE      extern __private(plp0prodlineplan)
#   elif defined(_WIN32)
#       define PLP0PRODLINEPLANEXPORT       __declspec(dllexport)
#       define PLP0PRODLINEPLANGLOBAL       extern __declspec(dllexport)
#       define PLP0PRODLINEPLANPRIVATE      extern
#   else
#       define PLP0PRODLINEPLANEXPORT
#       define PLP0PRODLINEPLANGLOBAL       extern
#       define PLP0PRODLINEPLANPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PLP0PRODLINEPLANEXPORT       __export(plp0prodlineplan)
#       define PLP0PRODLINEPLANGLOBAL       extern __global(plp0prodlineplan)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PLP0PRODLINEPLANEXPORT      __declspec(dllimport)
#       define PLP0PRODLINEPLANGLOBAL       extern __declspec(dllimport)
#   else
#       define PLP0PRODLINEPLANEXPORT
#       define PLP0PRODLINEPLANGLOBAL       extern
#   endif
#endif
