//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  plp0prodlineplandispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libplp0prodlineplandispatch

#if !defined(LIBPLP0PRODLINEPLANDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPLP0PRODLINEPLANDISPATCH is not defined
#endif

/* Handwritten code should use PLP0PRODLINEPLANDISPATCH_API, not PLP0PRODLINEPLANDISPATCHEXPORT */

#define PLP0PRODLINEPLANDISPATCH_API PLP0PRODLINEPLANDISPATCHEXPORT

#if IPLIB==libplp0prodlineplandispatch || defined(LIBPLP0PRODLINEPLANDISPATCH)
#   if defined(__lint)
#       define PLP0PRODLINEPLANDISPATCHEXPORT       __export(plp0prodlineplandispatch)
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern __global(plp0prodlineplandispatch)
#       define PLP0PRODLINEPLANDISPATCHPRIVATE      extern __private(plp0prodlineplandispatch)
#   elif defined(_WIN32)
#       define PLP0PRODLINEPLANDISPATCHEXPORT       __declspec(dllexport)
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PLP0PRODLINEPLANDISPATCHPRIVATE      extern
#   else
#       define PLP0PRODLINEPLANDISPATCHEXPORT
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern
#       define PLP0PRODLINEPLANDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PLP0PRODLINEPLANDISPATCHEXPORT       __export(plp0prodlineplandispatch)
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern __global(plp0prodlineplandispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PLP0PRODLINEPLANDISPATCHEXPORT      __declspec(dllimport)
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PLP0PRODLINEPLANDISPATCHEXPORT
#       define PLP0PRODLINEPLANDISPATCHGLOBAL       extern
#   endif
#endif
