//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pmg0cpmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpmg0cpmgmtdispatch

#if !defined(LIBPMG0CPMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPMG0CPMGMTDISPATCH is not defined
#endif

/* Handwritten code should use PMG0CPMGMTDISPATCH_API, not PMG0CPMGMTDISPATCHEXPORT */

#define PMG0CPMGMTDISPATCH_API PMG0CPMGMTDISPATCHEXPORT

#if IPLIB==libpmg0cpmgmtdispatch || defined(LIBPMG0CPMGMTDISPATCH)
#   if defined(__lint)
#       define PMG0CPMGMTDISPATCHEXPORT       __export(pmg0cpmgmtdispatch)
#       define PMG0CPMGMTDISPATCHGLOBAL       extern __global(pmg0cpmgmtdispatch)
#       define PMG0CPMGMTDISPATCHPRIVATE      extern __private(pmg0cpmgmtdispatch)
#   elif defined(_WIN32)
#       define PMG0CPMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define PMG0CPMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PMG0CPMGMTDISPATCHPRIVATE      extern
#   else
#       define PMG0CPMGMTDISPATCHEXPORT
#       define PMG0CPMGMTDISPATCHGLOBAL       extern
#       define PMG0CPMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PMG0CPMGMTDISPATCHEXPORT       __export(pmg0cpmgmtdispatch)
#       define PMG0CPMGMTDISPATCHGLOBAL       extern __global(pmg0cpmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PMG0CPMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define PMG0CPMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PMG0CPMGMTDISPATCHEXPORT
#       define PMG0CPMGMTDISPATCHGLOBAL       extern
#   endif
#endif
