//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceeventmanagementdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceeventmanagementdispatch

#if !defined(LIBSERVICEEVENTMANAGEMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEEVENTMANAGEMENTDISPATCH is not defined
#endif

/* Handwritten code should use SERVICEEVENTMANAGEMENTDISPATCH_API, not SERVICEEVENTMANAGEMENTDISPATCHEXPORT */

#define SERVICEEVENTMANAGEMENTDISPATCH_API SERVICEEVENTMANAGEMENTDISPATCHEXPORT

#if IPLIB==libserviceeventmanagementdispatch || defined(LIBSERVICEEVENTMANAGEMENTDISPATCH)
#   if defined(__lint)
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT       __export(serviceeventmanagementdispatch)
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern __global(serviceeventmanagementdispatch)
#       define SERVICEEVENTMANAGEMENTDISPATCHPRIVATE      extern __private(serviceeventmanagementdispatch)
#   elif defined(_WIN32)
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT       __declspec(dllexport)
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SERVICEEVENTMANAGEMENTDISPATCHPRIVATE      extern
#   else
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern
#       define SERVICEEVENTMANAGEMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT       __export(serviceeventmanagementdispatch)
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern __global(serviceeventmanagementdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT      __declspec(dllimport)
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEEVENTMANAGEMENTDISPATCHEXPORT
#       define SERVICEEVENTMANAGEMENTDISPATCHGLOBAL       extern
#   endif
#endif
