//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  servicerequestdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libservicerequestdispatch

#if !defined(LIBSERVICEREQUESTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEREQUESTDISPATCH is not defined
#endif

/* Handwritten code should use SERVICEREQUESTDISPATCH_API, not SERVICEREQUESTDISPATCHEXPORT */

#define SERVICEREQUESTDISPATCH_API SERVICEREQUESTDISPATCHEXPORT

#if IPLIB==libservicerequestdispatch || defined(LIBSERVICEREQUESTDISPATCH)
#   if defined(__lint)
#       define SERVICEREQUESTDISPATCHEXPORT       __export(servicerequestdispatch)
#       define SERVICEREQUESTDISPATCHGLOBAL       extern __global(servicerequestdispatch)
#       define SERVICEREQUESTDISPATCHPRIVATE      extern __private(servicerequestdispatch)
#   elif defined(_WIN32)
#       define SERVICEREQUESTDISPATCHEXPORT       __declspec(dllexport)
#       define SERVICEREQUESTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SERVICEREQUESTDISPATCHPRIVATE      extern
#   else
#       define SERVICEREQUESTDISPATCHEXPORT
#       define SERVICEREQUESTDISPATCHGLOBAL       extern
#       define SERVICEREQUESTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEREQUESTDISPATCHEXPORT       __export(servicerequestdispatch)
#       define SERVICEREQUESTDISPATCHGLOBAL       extern __global(servicerequestdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEREQUESTDISPATCHEXPORT      __declspec(dllimport)
#       define SERVICEREQUESTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEREQUESTDISPATCHEXPORT
#       define SERVICEREQUESTDISPATCHGLOBAL       extern
#   endif
#endif
