//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  smc0psmcfgsupportdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsmc0psmcfgsupportdispatch

#if !defined(LIBSMC0PSMCFGSUPPORTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSMC0PSMCFGSUPPORTDISPATCH is not defined
#endif

/* Handwritten code should use SMC0PSMCFGSUPPORTDISPATCH_API, not SMC0PSMCFGSUPPORTDISPATCHEXPORT */

#define SMC0PSMCFGSUPPORTDISPATCH_API SMC0PSMCFGSUPPORTDISPATCHEXPORT

#if IPLIB==libsmc0psmcfgsupportdispatch || defined(LIBSMC0PSMCFGSUPPORTDISPATCH)
#   if defined(__lint)
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT       __export(smc0psmcfgsupportdispatch)
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern __global(smc0psmcfgsupportdispatch)
#       define SMC0PSMCFGSUPPORTDISPATCHPRIVATE      extern __private(smc0psmcfgsupportdispatch)
#   elif defined(_WIN32)
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT       __declspec(dllexport)
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SMC0PSMCFGSUPPORTDISPATCHPRIVATE      extern
#   else
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern
#       define SMC0PSMCFGSUPPORTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT       __export(smc0psmcfgsupportdispatch)
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern __global(smc0psmcfgsupportdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT      __declspec(dllimport)
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SMC0PSMCFGSUPPORTDISPATCHEXPORT
#       define SMC0PSMCFGSUPPORTDISPATCHGLOBAL       extern
#   endif
#endif
