//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  smd0systemmodelingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsmd0systemmodelingdispatch

#if !defined(LIBSMD0SYSTEMMODELINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSMD0SYSTEMMODELINGDISPATCH is not defined
#endif

/* Handwritten code should use SMD0SYSTEMMODELINGDISPATCH_API, not SMD0SYSTEMMODELINGDISPATCHEXPORT */

#define SMD0SYSTEMMODELINGDISPATCH_API SMD0SYSTEMMODELINGDISPATCHEXPORT

#if IPLIB==libsmd0systemmodelingdispatch || defined(LIBSMD0SYSTEMMODELINGDISPATCH)
#   if defined(__lint)
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT       __export(smd0systemmodelingdispatch)
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern __global(smd0systemmodelingdispatch)
#       define SMD0SYSTEMMODELINGDISPATCHPRIVATE      extern __private(smd0systemmodelingdispatch)
#   elif defined(_WIN32)
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT       __declspec(dllexport)
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SMD0SYSTEMMODELINGDISPATCHPRIVATE      extern
#   else
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern
#       define SMD0SYSTEMMODELINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT       __export(smd0systemmodelingdispatch)
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern __global(smd0systemmodelingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT      __declspec(dllimport)
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SMD0SYSTEMMODELINGDISPATCHEXPORT
#       define SMD0SYSTEMMODELINGDISPATCHGLOBAL       extern
#   endif
#endif
