//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  sspspralignmentdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsspspralignmentdispatch

#if !defined(LIBSSPSPRALIGNMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSSPSPRALIGNMENTDISPATCH is not defined
#endif

/* Handwritten code should use SSPSPRALIGNMENTDISPATCH_API, not SSPSPRALIGNMENTDISPATCHEXPORT */

#define SSPSPRALIGNMENTDISPATCH_API SSPSPRALIGNMENTDISPATCHEXPORT

#if IPLIB==libsspspralignmentdispatch || defined(LIBSSPSPRALIGNMENTDISPATCH)
#   if defined(__lint)
#       define SSPSPRALIGNMENTDISPATCHEXPORT       __export(sspspralignmentdispatch)
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern __global(sspspralignmentdispatch)
#       define SSPSPRALIGNMENTDISPATCHPRIVATE      extern __private(sspspralignmentdispatch)
#   elif defined(_WIN32)
#       define SSPSPRALIGNMENTDISPATCHEXPORT       __declspec(dllexport)
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SSPSPRALIGNMENTDISPATCHPRIVATE      extern
#   else
#       define SSPSPRALIGNMENTDISPATCHEXPORT
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern
#       define SSPSPRALIGNMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SSPSPRALIGNMENTDISPATCHEXPORT       __export(sspspralignmentdispatch)
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern __global(sspspralignmentdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SSPSPRALIGNMENTDISPATCHEXPORT      __declspec(dllimport)
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SSPSPRALIGNMENTDISPATCHEXPORT
#       define SSPSPRALIGNMENTDISPATCHGLOBAL       extern
#   endif
#endif
