//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  systemsengineeringdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libsystemsengineeringdispatch

#if !defined(LIBSYSTEMSENGINEERINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSYSTEMSENGINEERINGDISPATCH is not defined
#endif

/* Handwritten code should use SYSTEMSENGINEERINGDISPATCH_API, not SYSTEMSENGINEERINGDISPATCHEXPORT */

#define SYSTEMSENGINEERINGDISPATCH_API SYSTEMSENGINEERINGDISPATCHEXPORT

#if IPLIB==libsystemsengineeringdispatch || defined(LIBSYSTEMSENGINEERINGDISPATCH)
#   if defined(__lint)
#       define SYSTEMSENGINEERINGDISPATCHEXPORT       __export(systemsengineeringdispatch)
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern __global(systemsengineeringdispatch)
#       define SYSTEMSENGINEERINGDISPATCHPRIVATE      extern __private(systemsengineeringdispatch)
#   elif defined(_WIN32)
#       define SYSTEMSENGINEERINGDISPATCHEXPORT       __declspec(dllexport)
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SYSTEMSENGINEERINGDISPATCHPRIVATE      extern
#   else
#       define SYSTEMSENGINEERINGDISPATCHEXPORT
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern
#       define SYSTEMSENGINEERINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SYSTEMSENGINEERINGDISPATCHEXPORT       __export(systemsengineeringdispatch)
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern __global(systemsengineeringdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SYSTEMSENGINEERINGDISPATCHEXPORT      __declspec(dllimport)
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SYSTEMSENGINEERINGDISPATCHEXPORT
#       define SYSTEMSENGINEERINGDISPATCHGLOBAL       extern
#   endif
#endif
