//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  tgm0targetmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libtgm0targetmgmtdispatch

#if !defined(LIBTGM0TARGETMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBTGM0TARGETMGMTDISPATCH is not defined
#endif

/* Handwritten code should use TGM0TARGETMGMTDISPATCH_API, not TGM0TARGETMGMTDISPATCHEXPORT */

#define TGM0TARGETMGMTDISPATCH_API TGM0TARGETMGMTDISPATCHEXPORT

#if IPLIB==libtgm0targetmgmtdispatch || defined(LIBTGM0TARGETMGMTDISPATCH)
#   if defined(__lint)
#       define TGM0TARGETMGMTDISPATCHEXPORT       __export(tgm0targetmgmtdispatch)
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern __global(tgm0targetmgmtdispatch)
#       define TGM0TARGETMGMTDISPATCHPRIVATE      extern __private(tgm0targetmgmtdispatch)
#   elif defined(_WIN32)
#       define TGM0TARGETMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define TGM0TARGETMGMTDISPATCHPRIVATE      extern
#   else
#       define TGM0TARGETMGMTDISPATCHEXPORT
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern
#       define TGM0TARGETMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define TGM0TARGETMGMTDISPATCHEXPORT       __export(tgm0targetmgmtdispatch)
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern __global(tgm0targetmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define TGM0TARGETMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define TGM0TARGETMGMTDISPATCHEXPORT
#       define TGM0TARGETMGMTDISPATCHGLOBAL       extern
#   endif
#endif
