//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  val1cfgvalidationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libval1cfgvalidationdispatch

#if !defined(LIBVAL1CFGVALIDATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBVAL1CFGVALIDATIONDISPATCH is not defined
#endif

/* Handwritten code should use VAL1CFGVALIDATIONDISPATCH_API, not VAL1CFGVALIDATIONDISPATCHEXPORT */

#define VAL1CFGVALIDATIONDISPATCH_API VAL1CFGVALIDATIONDISPATCHEXPORT

#if IPLIB==libval1cfgvalidationdispatch || defined(LIBVAL1CFGVALIDATIONDISPATCH)
#   if defined(__lint)
#       define VAL1CFGVALIDATIONDISPATCHEXPORT       __export(val1cfgvalidationdispatch)
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern __global(val1cfgvalidationdispatch)
#       define VAL1CFGVALIDATIONDISPATCHPRIVATE      extern __private(val1cfgvalidationdispatch)
#   elif defined(_WIN32)
#       define VAL1CFGVALIDATIONDISPATCHEXPORT       __declspec(dllexport)
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define VAL1CFGVALIDATIONDISPATCHPRIVATE      extern
#   else
#       define VAL1CFGVALIDATIONDISPATCHEXPORT
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern
#       define VAL1CFGVALIDATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VAL1CFGVALIDATIONDISPATCHEXPORT       __export(val1cfgvalidationdispatch)
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern __global(val1cfgvalidationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VAL1CFGVALIDATIONDISPATCHEXPORT      __declspec(dllimport)
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define VAL1CFGVALIDATIONDISPATCHEXPORT
#       define VAL1CFGVALIDATIONDISPATCHGLOBAL       extern
#   endif
#endif
