#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ChangeObjectDesc(EPM_action_message_t msg)
{
	printf("========================= Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);
	bool isRelease = false;

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "";
	//ȡ
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i < arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "release") == 0)
			{
				isRelease = true;
			}
		}
	}

	//ȡMeling_voltageѡֵ
	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("Meling_voltage", &pref_cnt, &pref_vals);

	char resultString[2048] = "";
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;
		AOM_ask_value_string(attachments[i], "object_type", &itemType);

		char *itemObjectDesc = NULL;
		AOM_ask_value_string(attachments[i], "object_desc", &itemObjectDesc);
		
		



		//˵ǰ汾Ķ
		if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
			|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0))
		{
			int releaseCount = 0;
			tag_t * releaseTag = NULL_TAG;
			//жӼǷ񷢲
			AOM_ask_value_tags(attachments[i], "release_status_list", &releaseCount, &releaseTag);
			if (releaseCount > 0 && !isRelease)
			{
				DOFREE(releaseTag);
				continue;
			}
			DOFREE(releaseTag);
			//ȡ
			tag_t item = NULLTAG;
			ITEM_ask_item_of_rev(attachments[i], &item);
			char * itemObjectType = NULL;
			AOM_ask_value_string(item, "object_type", &itemObjectType);

			//ȡͨûʶ
			char * generalIdentify = NULL;
			AOM_ask_value_string(attachments[i], "ml8_GeneralIdentify", &generalIdentify);
			if (strcmp(generalIdentify, "׼") == 0)
			{
				DOFREE(itemObjectType);
				DOFREE(generalIdentify);
				continue;
			}
			//ȡ۷ʽ
			char * propertyValue = NULL;
			AOM_ask_value_string(attachments[i], "ml8_SalesMode", &propertyValue);

			if (propertyValue == NULL)
			{
				DOFREE(itemObjectType);
				DOFREE(propertyValue);
				continue;
			}

			//ȡƴҪ
			int projectFormNum = 0;
			tag_t * projectForm = NULLTAG;
			char * itemId = NULL;//
			char * objectName = NULL;//Ʒ
			char * productType = NULL;//Ʒͺ
			char * colour = NULL;//ɫ
			char * domesticSales = NULL;//ͻ
			char * place = NULL;//
			char * productCode = NULL;//Ʒ
			AOM_ask_value_string(attachments[i], "item_id", &itemId);
			AOM_ask_value_string(attachments[i], "object_name", &objectName);
			//AOM_ask_value_string(attachments[i], "ml8_ProductType", &productType);
			AOM_ask_value_string(attachments[i], "ml8_Colour", &colour);
			AOM_ask_value_string(attachments[i], "ml8_DomesticSales", &domesticSales);
			AOM_ask_value_string(attachments[i], "ml8_Place", &place);
			//AOM_ask_value_string(attachments[i], "ml8_ProductCode", &productCode);
			AOM_ask_value_tags(attachments[i], "ML8_ProjectRelation", &projectFormNum, &projectForm);
			if (projectFormNum > 0)
			{
				AOM_ask_value_string(projectForm[0], "ml8_ProductType", &productType);
				AOM_ask_value_string(projectForm[0], "ml8_ProductCode", &productCode);

			}

			printf("propertyValue:%s Start===================\n", propertyValue);
			char objectDesc[100] = "";
			//ж۷ʽǷΪڻ͡չ
			if ((strcmp(propertyValue, "") == 0) || (strcmp(propertyValue, "ڻ") == 0)
				|| (strcmp(propertyValue, "չ") == 0))
			{
				string err = "";
				if (objectName != NULL && strcmp(objectName, "") != 0 && strcmp(objectName, "/") != 0)
				{
					strcat(objectDesc, objectName);
				}
				else if(objectName == NULL || strcmp(objectName, "") == 0)
				{
					printf("ƷΪ\n");
					err += "ƷΪ  ";
				}

				if (productType != NULL && strcmp(productType, "") != 0 && strcmp(productType, "/") != 0)
				{
					strcat(objectDesc, productType);
				}
				else if(productType == NULL || strcmp(productType, "")==0)
				{
					printf("ƷͺΪ\n");
					err += "ƷͺΪ ";
				}

				if (productCode != NULL && strcmp(productCode, "") != 0 && strcmp(productCode, "/") != 0)
				{

					strcat(objectDesc, "(");
					strcat(objectDesc, productCode);
					strcat(objectDesc, ")");
					////Ʒ״̬⴦
					//if (strstr(productCode, "CKD") != NULL)
					//{
					//	strcat(objectDesc, "/");
					//	strcat(objectDesc, "ɢ");
					//}
					//else if (strstr(productCode, "CKD") != NULL)
					//{
					//	strcat(objectDesc, "/");
					//	strcat(objectDesc, "ɢ");
					//}
				}
				else if(productCode == NULL || strcmp(productCode, "") == 0)
				{
					printf("ƷΪ\n");
					err += "ƷΪ ";
				}


				if (colour != NULL && strcmp(colour, "") != 0 && strcmp(colour, "/") != 0)
				{
					//ɫ⴦ȡɫPCMʰ_˿(ML-C1072)
					if (strstr(colour, "(") != NULL)
					{
						//_в֡
						int valueCount = 0;
						char ** valueChar = new char *[64];
						//ַָ
						split(colour, "(", valueChar, &valueCount);

						//ڶַ_
						if (strstr(valueChar[0], "_") != NULL)
						{
							//_в֡
							int colorNameCount = 0;
							char ** colorNameChar = new char *[64];
							//ַָ
							split(valueChar[0], "_", colorNameChar, &colorNameCount);

							colour = colorNameChar[1];
						}
					}
					strcat(objectDesc, colour);
				}
				else if(colour == NULL || strcmp(colour, "") == 0)
				{
					printf("ɫΪ\n");
					err += "ɫΪ";
				}

				if (domesticSales != NULL && strcmp(domesticSales, "") != 0 && strcmp(domesticSales, "/") != 0)
				{
					strcat(objectDesc, "(");
					strcat(objectDesc, domesticSales);
					strcat(objectDesc, ")");
				}
				if (place != NULL && strcmp(place, "") != 0 && strcmp(place, "/") != 0 && (strcmp(place, "") == 0 || strcmp(place, "") == 0))
				{
					strcat(objectDesc, "(");
					strcat(objectDesc, place);
					strcat(objectDesc, ")");
				}
				else if(place == NULL || strcmp(place, "") == 0)
				{
					printf("غΪ\n");
					err += "Ϊ";
				}

				
				

				printf("objectDesc:%s Start===================\n", objectDesc);
				//жǷ񳬹40ַ
				/*int len = gbk_strlen(objectDesc);
				if (len > 40)
				{
				strcat(resultString, "");
				strcat(resultString, objectDesc);
				strcat(resultString, "ѳ40ַ");
				strcat(resultString, "/n");

				goto loop;
				}*/
				printf("err%s\n", err.c_str());
				//ǿжʾ
				if (strcmp(err.c_str(), "") != 0) {
					EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
					return 1;
				}
				////жǷҪ
				//if (strcmp(itemObjectDesc, objectDesc) == 0)
				//{
				//	goto loop;
				//}
				
				//
				int n_entries = 1;
				char *qry_entries[1] = { "" }, *qry_values[1] = { objectDesc };
				int n_found = 0;
				tag_t * dba_mbrs = NULLTAG;
				char queryName[256] = "";
				//strcat(queryName, itemObjectType);
				strcat(queryName, "ѯ");
				TCFindItem(queryName, n_entries, qry_entries, qry_values, &n_found, &dba_mbrs);
				printf("ҵ%dظѯ\n", n_found);
				bool isHaveItem = false;
				for (int ii = 0; ii < n_found; ii++)
				{
					char* checkId;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &checkId);
					//idк"-"
					if (strstr(checkId, "-") != NULL)
					{
						continue;
					}

					int releaseCount = 0;
					tag_t* releaseTag = NULL_TAG;
					//ȡӼķ״̬
					AOM_ask_value_tags(dba_mbrs[ii], "release_status_list", &releaseCount, &releaseTag);
					if (releaseCount > 0) {
						bool flag = false;
						for (int a = 0; a < releaseCount; a++) {
							char* releaseName;
							AOM_ask_value_string(releaseTag[a], "object_name", &releaseName);
							if (strcmp(releaseName, "ȡ") == 0 || strcmp(releaseName, "ML8_Replaced") == 0) {
								//һѭ
								flag = true;
								break;
							}
						}
						if (flag) {
							isHaveItem = false;
							continue;
						}
					}

					char * otherItemId = NULL;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &otherItemId);
					printf("ԱItem_id:%s---%s Start===================\n", otherItemId, itemId);
					if (strcmp(otherItemId, itemId) == 0)
					{
						DOFREE(otherItemId);
						isHaveItem = false;
						continue;
					}
					//idк"-"
					if (strstr(otherItemId, "-") != NULL)
					{
						printf("idа-Ķ\n");
						DOFREE(otherItemId);
						isHaveItem = false;
						continue;
					}
					isHaveItem = true;
					strcat(resultString, otherItemId);
					strcat(resultString, "");
					strcat(resultString, "Ѵ");
					strcat(resultString, objectDesc);
					strcat(resultString, "\n");
					DOFREE(otherItemId);
					//break;
				}

				/*
								if (n_found > 0)
								{
									strcat(resultString, "ϵͳѴ");
									strcat(resultString, objectDesc);
									strcat(resultString, "/n");

									goto result;
								}*/
								//ͱ׼
				if (strlen(resultString) == 0) {
					AOM_lock(attachments[i]);
					AOM_set_value_string(attachments[i], "object_desc", objectDesc);
					AOM_set_value_string(attachments[i], "ml8_StdDesc", objectDesc);
					AOM_save(attachments[i]);
					AOM_unlock(attachments[i]);
					AOM_refresh(attachments[i], false);
				}
				

			result:
				DOFREE(itemObjectType);
			}
			else if ((strcmp(propertyValue, "ڶ") == 0))
			{
				string err = "";
				//char * voltage = NULL;//ѹ
				//char * frequency = NULL;//Ƶ
				char * exportCode = NULL;//ڹ
				//AOM_ask_value_string(attachments[i], "ml8_Voltage", &voltage);
				//AOM_ask_value_string(attachments[i], "ml8_Frequency", &frequency);
				AOM_ask_value_string(attachments[i], "ml8_ExportCode", &exportCode);

				//Ƶ
				/*if (strcmp(frequency, "50Hz") == 0)
				{
					frequency = "";
				}
				else if (strcmp(frequency, "60Hz") == 0)
				{
					frequency = "60";
				}
				else if (strcmp(frequency, "50/60Hz") == 0)
				{
					frequency = "50/60";
				}*/
				//ȡѹ
				//bool isHave = false;
				//for (int j = 0; j < pref_cnt; j++)
				//{
				//	if (strstr(pref_vals[j], "=") != NULL)
				//	{
				//		//_в֡
				//		int valueCount = 0;
				//		char ** valueChar = new char *[64];
				//		//ַָ
				//		split(pref_vals[j], "=", valueChar, &valueCount);

				//		if (strcmp(voltage, valueChar[0]) == 0)
				//		{
				//			isHave = true;
				//			voltage = valueChar[1];
				//		}
				//	}
				//}
				//if (!isHave)
				//{
				//	voltage = "";
				//	/*strcat(resultString, "δҵƥĵѹֵ");
				//	strcat(resultString, voltage);
				//	strcat(resultString, "\n");

				//	goto result2;*/
				//}

				if (objectName != NULL && strcmp(objectName, "") != 0 && strcmp(objectName, "/") != 0)
				{
					strcat(objectDesc, objectName);
				}
				else if(objectName == NULL || strcmp(objectName, "") == 0)
				{
					printf("ƷΪ\n");
					err += "ƷΪ ";
				}

				if (productType != NULL && strcmp(productType, "") != 0 && strcmp(productType, "/") != 0)
				{
					strcat(objectDesc, productType);
				}
				else if(productType == NULL || strcmp(productType, "") == 0)
				{
					printf("ͺΪ\n");
					err += "ͺΪ ";
				}

				if (productCode != NULL && strcmp(productCode, "") != 0 && strcmp(productCode, "/") != 0)
				{
					strcat(objectDesc, "(");
					strcat(objectDesc, (productCode + 5));
					strcat(objectDesc, ")");
				}
				else if(productCode == NULL || strcmp(productCode, "") == 0)
				{
					printf("ƷΪ\n");
					err += "ƷΪ ";
				}

				if (colour != NULL && strcmp(colour, "") != 0 && strcmp(colour, "/") != 0)
				{
					//ɫ⴦ȡɫPCMʰ_˿(ML-C1072)
					if (strstr(colour, "(") != NULL)
					{
						//_в֡
						int valueCount = 0;
						char ** valueChar = new char *[64];
						//ַָ
						split(colour, "(", valueChar, &valueCount);
						//ڶַ(
						if (strstr(valueChar[1], ")") != NULL)
						{
							//_в֡
							int colorNameCount = 0;
							char ** colorNameChar = new char *[64];
							//ַָ
							split(valueChar[1], ")", colorNameChar, &colorNameCount);
							if (strstr(colorNameChar[0], "-") != NULL)
							{
								//_в֡
								int colorName = 0;
								char ** colorChar = new char *[64];
								//ַָ
								split(colorNameChar[0], "-", colorChar, &colorName);
								char colorChars[256] = "";
								for (int kkk = 0; kkk < colorName; kkk++)
								{
									if (kkk == 0 && strcmp(colorChar[kkk], "ML") == 0)
									{
										continue;
									}
									strcat(colorChars, colorChar[kkk]);
									if (kkk < (colorName - 1))
									{
										strcat(colorChars, "-");
									}
								}
								colour = colorChars;
							}
							else
							{
								colour = colorNameChar[0];
							}
						}
					}
					strcat(objectDesc, colour);
				}else if (colour == NULL || strcmp(colour, "") == 0)
				{
					printf("ɫΪ\n");
					err += "ɫΪ ";
				}
				/*if (voltage != NULL && strcmp(voltage, "") != 0 && strcmp(voltage, "/") != 0)
				{
					strcat(objectDesc, voltage);
				}
				if (frequency != NULL && strcmp(frequency, "") != 0 && strcmp(frequency, "/") != 0)
				{
					strcat(objectDesc, frequency);
				}*/
				if (exportCode != NULL && strcmp(exportCode, "") != 0 && strcmp(exportCode, "/") != 0)
				{
					strcat(objectDesc, "(");
					strcat(objectDesc, exportCode);
					//strcat(objectDesc, ")");//ڹȥ
				}
				////жǷ񳬹40ַ
				//int len = gbk_strlen(objectDesc);
				//if (len > 40)
				//{
				//	strcat(resultString, "");
				//	strcat(resultString, objectDesc);
				//	strcat(resultString, "ѳ40ַ");
				//	strcat(resultString, "/n");

				//	goto result2;
				//}
				printf("err%s\n", err.c_str());
				//ǿжʾ
				if (strcmp(err.c_str(), "") != 0) {
					EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
					return 1;
				}

				

				char * desc = NULL;
				char * stdDesc = NULL;

				AOM_ask_value_string(attachments[i], "object_desc", &desc);
				AOM_ask_value_string(attachments[i], "ml8_StdDesc", &stdDesc);

				////жǷҪ
				//if (strcmp(itemObjectDesc, objectDesc) == 0 && desc != NULL && stdDesc != NULL && strcmp(desc, "") != 0 && strcmp(stdDesc, "") != 0)
				//{
				//	DOFREE(desc);
				//	DOFREE(stdDesc);
				//	goto result2;
				//}
				DOFREE(desc);
				DOFREE(stdDesc);
				
				//
				
				int n_entries = 1;
				char *qry_entries[1] = { "" }, *qry_values[1] = { objectDesc };
				int n_found = 0;
				tag_t * dba_mbrs = NULLTAG;
				char queryName[256] = "";
				//strcat(queryName, itemObjectType);
				strcat(queryName, "ѯ");
				TCFindItem(queryName, n_entries, qry_entries, qry_values, &n_found, &dba_mbrs);
				printf("ҵ%dظѯ\n", n_found);
				//˵ǰ
				bool isHaveItem = false;
				for (int ii = 0; ii < n_found; ii++)
				{
					char* checkId;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &checkId);
					//idк"-"
					if (strstr(checkId, "-") != NULL)
					{
						continue;
					}

					int releaseCount = 0;
					tag_t* releaseTag = NULL_TAG;
					//ȡӼķ״̬
					AOM_ask_value_tags(dba_mbrs[ii], "release_status_list", &releaseCount, &releaseTag);
					if (releaseCount > 0) {
						bool flag = false;
						for (int a = 0; a < releaseCount; a++) {
							char* releaseName;
							AOM_ask_value_string(releaseTag[a], "object_name", &releaseName);
							if (strcmp(releaseName, "ȡ") == 0 || strcmp(releaseName, "ML8_Replaced") == 0) {
								//һѭ
								flag = true;
								break;
							}
						}
						if (flag) {
							isHaveItem = false;
							continue;
						}
					}


					char * otherItemId = NULL;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &otherItemId);
					printf("ԱItem_id:%s---%s Start===================\n", otherItemId, itemId);
					if (strcmp(otherItemId, itemId) == 0)
					{
						DOFREE(otherItemId);
						continue;
					}
					isHaveItem = true;
					strcat(resultString, otherItemId);
					strcat(resultString, "");
					strcat(resultString, "Ѵ");
					strcat(resultString, objectDesc);
					strcat(resultString, "\n");
					DOFREE(otherItemId);
					//break;
				}

				/*if (isHaveItem)
				{
					strcat(resultString, "ϵͳѴ");
					strcat(resultString, objectDesc);
					strcat(resultString, "\n");

					DOFREE(dba_mbrs);
					goto result2;
				}*/
				//ͱ׼
				AOM_lock(attachments[i]);
				AOM_set_value_string(attachments[i], "object_desc", objectDesc);
				AOM_set_value_string(attachments[i], "ml8_StdDesc", objectDesc);
				AOM_save(attachments[i]);
				AOM_unlock(attachments[i]);
				AOM_refresh(attachments[i], false);

				DOFREE(dba_mbrs);

			result2:
				/*DOFREE(voltage);
				DOFREE(frequency);*/
				DOFREE(exportCode);
			}

		loop:
			DOFREE(itemObjectType);
			DOFREE(propertyValue);
			DOFREE(objectName);
			DOFREE(productType);
			DOFREE(colour);
			DOFREE(domesticSales);
			DOFREE(place);
			DOFREE(productCode);

		}
		else if ((strcmp(itemType, "ML8_PartRevision") == 0) || (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
		{
			int releaseCount = 0;
			tag_t * releaseTag = NULL_TAG;
			//жӼǷ񷢲
			AOM_ask_value_tags(attachments[i], "release_status_list", &releaseCount, &releaseTag);
			if (releaseCount > 0 && !isRelease)
			{
				DOFREE(releaseTag);
				continue;
			}
			DOFREE(releaseTag);
			//ȡ
			tag_t item = NULLTAG;
			ITEM_ask_item_of_rev(attachments[i], &item);
			char * itemObjectType = NULL;
			AOM_ask_value_string(item, "object_type", &itemObjectType);
			//ȡͨûʶ
			/*char * generalIdentify = NULL;
			AOM_ask_value_string(attachments[i], "ml8_GeneralIdentify", &generalIdentify);
			if (strcmp(generalIdentify, "׼") != 0)
			{
				DOFREE(itemObjectType);
				DOFREE(generalIdentify);
				continue;
			}*/
			//ȡΣԼ
			char * propertyValue = NULL;
			AOM_ask_value_string(attachments[i], "ml8_HazardConstraint", &propertyValue);

			if (propertyValue == NULL)
			{
				DOFREE(itemObjectType);
				DOFREE(propertyValue);
				continue;
			}

			char objectDesc[50] = "";

			//ȡƴҪ
			char * itemId = NULL;//
			char * objectName = NULL;//
			char * externalWorking = NULL;//ӹ״̬
			char * colour = NULL;//ɫ
			char * figureNum = NULL;//ͼ
			char * identification = NULL;//ʶ
			char * specifications = NULL;//ͺ
			AOM_ask_value_string(attachments[i], "item_id", &itemId);
			AOM_ask_value_string(attachments[i], "object_name", &objectName);
			AOM_ask_value_string(attachments[i], "ml8_ExternalWorking", &externalWorking);
			AOM_ask_value_string(attachments[i], "ml8_Colour", &colour);
			if ((strcmp(itemType, "ML8_PartRevision") == 0))
			{
				AOM_ask_value_string(attachments[i], "ml8_FigureNum", &figureNum);
				AOM_ask_value_string(attachments[i], "ml8_Identification", &identification);
			}
			AOM_ask_value_string(attachments[i], "ml8_Specifications", &specifications);
			string err = "";
			//жϺԼǷΪRoHSָRoHSָ
			if ((strcmp(propertyValue, "RoHSָ") == 0))
			{
				strcat(objectDesc, "R-");
				if (objectName != NULL && strcmp(objectName, "") != 0 && strcmp(objectName, "/") != 0)
				{
					strcat(objectDesc, objectName);
				}
				else if (objectName == NULL || strcmp(objectName, "") == 0)
				{
					printf("Ϊ\n");
					err += "Ϊ ";
				}
				bool isHaveExternalWorking = false;
				if (externalWorking != NULL && strcmp(externalWorking, "") != 0 && strcmp(externalWorking, "/") != 0)
				{
					isHaveExternalWorking = true;
					strcat(objectDesc, "(");
					strcat(objectDesc, externalWorking);
				}
				if (colour != NULL && strcmp(colour, "") != 0 && strcmp(colour, "/") != 0)
				{
					if (!isHaveExternalWorking)
					{
						strcat(objectDesc, "(");
					}
					//ɫ⴦ȡɫPCMʰ_˿(ML-C1072)
					if (strstr(colour, "(") != NULL)
					{
						//_в֡
						int valueCount = 0;
						char ** valueChar = new char *[64];
						//ַָ
						split(colour, "(", valueChar, &valueCount);
						//ڶַ(
						if (strstr(valueChar[1], ")") != NULL)
						{
							//_в֡
							int colorNameCount = 0;
							char ** colorNameChar = new char *[64];
							//ַָ
							split(valueChar[1], ")", colorNameChar, &colorNameCount);
							if (strstr(colorNameChar[0], "-") != NULL)
							{
								//_в֡
								int colorName = 0;
								char ** colorChar = new char *[64];
								//ַָ
								split(colorNameChar[0], "-", colorChar, &colorName);
								char colorChars[256] = "";
								for (int kkk = 0; kkk < colorName; kkk++)
								{
									if (kkk == 0 && strcmp(colorChar[kkk], "ML") == 0)
									{
										continue;
									}
									strcat(colorChars, colorChar[kkk]);
									if (kkk < (colorName - 1))
									{
										strcat(colorChars, "-");
									}
								}
								colour = colorChars;
							}
							else
							{
								colour = colorNameChar[0];
							}
						}
					}
					strcat(objectDesc, colour);
					strcat(objectDesc, ")");
				}
				else if(colour == NULL || strcmp(colour, "") == 0)
				{
					printf("ɫΪ\n");
					err += "ɫΪ ";
				}
				else if (isHaveExternalWorking)
				{
					strcat(objectDesc, ")");
				}


				if ((figureNum != NULL && strcmp(figureNum, "") != 0 && strcmp(figureNum, "/") != 0) ||
					(identification != NULL && strcmp(identification, "") != 0 && strcmp(identification, "/") != 0) ||
					(specifications != NULL && strcmp(specifications, "") != 0 && strcmp(specifications, "/") != 0))
				{
					strcat(objectDesc, "_");
				}
				if (figureNum != NULL && strcmp(figureNum, "") != 0 && strcmp(figureNum, "/") != 0)
				{
					strcat(objectDesc, figureNum);
				}
				if (identification != NULL && strcmp(identification, "") != 0 && strcmp(identification, "/") != 0)
				{
					strcat(objectDesc, identification);
				}
				if (specifications != NULL && strcmp(specifications, "") != 0 && strcmp(specifications, "/") != 0)
				{
					strcat(objectDesc, specifications);
				}
				////жǷ񳬹40ַ
				//int len = gbk_strlen(objectDesc);
				//if (len > 40)
				//{
				//	strcat(resultString, "");
				//	strcat(resultString, objectDesc);
				//	strcat(resultString, "ѳ40ַ");
				//	strcat(resultString, "/n");

				//	goto loop2;
				//}

				//ǿжʾ
				if (strcmp(err.c_str(), "") != 0) {
					EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
					return 1;
				}


				char * desc = NULL;
				char * stdDesc = NULL;

				AOM_ask_value_string(attachments[i], "object_desc", &desc);
				AOM_ask_value_string(attachments[i], "ml8_StdDesc", &stdDesc);
				////жǷҪ
				//if (strcmp(itemObjectDesc, objectDesc) == 0 && desc != NULL && stdDesc != NULL && strcmp(desc, "") != 0 && strcmp(stdDesc, "") != 0)
				//{
				//	DOFREE(desc);
				//	DOFREE(stdDesc);
				//	goto loop2;
				//}
				DOFREE(desc);
				DOFREE(stdDesc);

				


				//
				int n_entries = 1;
				char *qry_entries[1] = { "" }, *qry_values[1] = { objectDesc };
				int n_found = 0;
				tag_t * dba_mbrs = NULLTAG;
				char queryName[256] = "";
				//strcat(queryName, itemObjectType);
				strcat(queryName, "ѯ");
				TCFindItem(queryName, n_entries, qry_entries, qry_values, &n_found, &dba_mbrs);
				//˵ǰ
				bool isHaveItem = false;
				for (int ii = 0; ii < n_found; ii++)
				{
					char* checkId;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &checkId);
					//idк"-"
					if (strstr(checkId, "-") != NULL)
					{
						continue;
					}
					int releaseCount = 0;
					tag_t* releaseTag = NULL_TAG;
					//ȡӼķ״̬
					AOM_ask_value_tags(dba_mbrs[ii], "release_status_list", &releaseCount, &releaseTag);
					if (releaseCount > 0) {
						bool flag = false;
						for (int a = 0; a < releaseCount; a++) {
							char* releaseName;
							AOM_ask_value_string(releaseTag[a], "object_name", &releaseName);
							if (strcmp(releaseName, "ȡ") == 0 || strcmp(releaseName, "ML8_Replaced") == 0) {
								//һѭ
								flag = true;
								break;
							}
						}
						if (flag) {
							isHaveItem = false;
							continue;
						}
					}


					char * otherItemId = NULL;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &otherItemId);
					printf("ԱItem_id:%s---%s Start===================\n", otherItemId, itemId);
					if (strcmp(otherItemId, itemId) == 0)
					{
						DOFREE(otherItemId);
						continue;
					}
					isHaveItem = true;
					strcat(resultString, otherItemId);
					strcat(resultString, "");
					strcat(resultString, "Ѵ");
					strcat(resultString, objectDesc);
					strcat(resultString, "\n");
					DOFREE(otherItemId);
					//break;
				}
				if (strlen(resultString)==0) {
					AOM_lock(attachments[i]);
					AOM_set_value_string(attachments[i], "object_desc", objectDesc);
					AOM_set_value_string(attachments[i], "ml8_StdDesc", objectDesc);
					AOM_save(attachments[i]);
					AOM_unlock(attachments[i]);
					AOM_refresh(attachments[i], false);
				}
				//ͱ׼
				

				DOFREE(dba_mbrs);
			}
			else
			{
				if (objectName != NULL && strcmp(objectName, "") != 0 && strcmp(objectName, "/") != 0)
				{
					strcat(objectDesc, objectName);
				}
				else if(objectName == NULL || strcmp(objectName, "") == 0)
				{
					printf("ƷΪ\n");
					err += "ƷΪ";
				}
				bool isHaveExternalWorking = false;
				if (externalWorking != NULL && strcmp(externalWorking, "") != 0 && strcmp(externalWorking, "/") != 0)
				{
					isHaveExternalWorking = true;
					strcat(objectDesc, "(");
					strcat(objectDesc, externalWorking);
				}
				if (colour != NULL && strcmp(colour, "") != 0 && strcmp(colour, "/") != 0)
				{
					if (!isHaveExternalWorking)
					{
						strcat(objectDesc, "(");
					}
					//ɫ⴦ȡɫPCMʰ_˿(ML-C1072)
					if (strstr(colour, "(") != NULL)
					{
						//_в֡
						int valueCount = 0;
						char ** valueChar = new char *[64];
						//ַָ
						split(colour, "(", valueChar, &valueCount);
						//ڶַ(
						if (strstr(valueChar[1], ")") != NULL)
						{
							//_в֡
							int colorNameCount = 0;
							char ** colorNameChar = new char *[64];
							//ַָ
							split(valueChar[1], ")", colorNameChar, &colorNameCount);

							if (strstr(colorNameChar[0], "-") != NULL)
							{
								//_в֡
								int colorName = 0;
								char ** colorChar = new char *[64];
								//ַָ
								split(colorNameChar[0], "-", colorChar, &colorName);
								char colorChars[256] = "";
								for (int kkk = 0; kkk < colorName; kkk++)
								{
									if (kkk == 0 && strcmp(colorChar[kkk], "ML") == 0)
									{
										continue;
									}
									strcat(colorChars, colorChar[kkk]);
									if (kkk < (colorName - 1))
									{
										strcat(colorChars, "-");
									}
								}
								colour = colorChars;
							}
							else
							{
								colour = colorNameChar[0];
							}

						}
					}
					strcat(objectDesc, colour);
					strcat(objectDesc, ")");
				}
				else if (colour == NULL || strcmp(colour, "") == 0)
				{
					printf("ɫΪ\n");
					err += "ɫΪ ";
				}
				else if (isHaveExternalWorking)
				{
					strcat(objectDesc, ")");
				}
				if ((figureNum != NULL && strcmp(figureNum, "") != 0 && strcmp(figureNum, "/") != 0) ||
					(identification != NULL && strcmp(identification, "") != 0 && strcmp(identification, "/") != 0) ||
					(specifications != NULL && strcmp(specifications, "") != 0 && strcmp(specifications, "/") != 0))
				{
					strcat(objectDesc, "_");
				}
				if (figureNum != NULL && strcmp(figureNum, "") != 0 && strcmp(figureNum, "/") != 0)
				{
					strcat(objectDesc, figureNum);
				}
				if (identification != NULL && strcmp(identification, "") != 0 && strcmp(identification, "/") != 0)
				{
					strcat(objectDesc, identification);
				}
				if (specifications != NULL && strcmp(specifications, "") != 0 && strcmp(specifications, "/") != 0)
				{
					strcat(objectDesc, specifications);
				}
				////жǷ񳬹40ַ
				//int len = gbk_strlen(objectDesc);
				//if (len > 40)
				//{
				//	strcat(resultString, "");
				//	strcat(resultString, objectDesc);
				//	strcat(resultString, "ѳ40ַ");
				//	strcat(resultString, "/n");

				//	goto loop2;
				//}
				//ǿжʾ
				printf("err%s\n", err.c_str());
				if (strcmp(err.c_str(), "") != 0) {
					EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, err.c_str());
					return 1;
				}
				char * desc = NULL;
				char * stdDesc = NULL;

				AOM_ask_value_string(attachments[i], "object_desc", &desc);
				AOM_ask_value_string(attachments[i], "ml8_StdDesc", &stdDesc);
				//жǷҪ
				if (strcmp(itemObjectDesc, objectDesc) == 0 && desc != NULL && stdDesc != NULL && strcmp(desc, "") != 0 && strcmp(stdDesc, "") != 0)
				{
					
					//
					int n_entries = 1;
					char* qry_entries[1] = { "" }, * qry_values[1] = { objectDesc };
					int n_found = 0;
					tag_t* dba_mbrs = NULLTAG;
					char queryName[256] = "";
					strcat(queryName, "ѯ");
					TCFindItem(queryName, n_entries, qry_entries, qry_values, &n_found, &dba_mbrs);

					bool isHaveItem = false;
					for (int ii = 0; ii < n_found; ii++)
					{
						char* checkId;
						AOM_ask_value_string(dba_mbrs[ii], "item_id", &checkId);
						//idк"-"
						if (strstr(checkId, "-") != NULL)
						{
							continue;
						}
						int releaseCount = 0;
						tag_t* releaseTag = NULL_TAG;
						//ȡӼķ״̬
						AOM_ask_value_tags(dba_mbrs[ii], "release_status_list", &releaseCount, &releaseTag);
						if (releaseCount > 0) {
							bool flag = false;
							for (int a = 0; a < releaseCount; a++) {
								char* releaseName;
								AOM_ask_value_string(releaseTag[a], "object_name", &releaseName);
								if (strcmp(releaseName, "ȡ") == 0 || strcmp(releaseName, "ML8_Replaced") == 0) {
									//һѭ
									flag = true;
									break;
								}
							}
							if (flag) {
								isHaveItem = false;
								continue;
							}
						}

						char* otherItemId = NULL;
						AOM_ask_value_string(dba_mbrs[ii], "item_id", &otherItemId);
						printf("ԱItem_id:%s---%s Start===================\n", otherItemId, itemId);
						if (strcmp(otherItemId, itemId) == 0)
						{
							DOFREE(otherItemId);
							continue;
						}
						isHaveItem = true;
						strcat(resultString, otherItemId);
						strcat(resultString, "");
						strcat(resultString, "Ѵ");
						strcat(resultString, objectDesc);
						strcat(resultString, "\n");
						DOFREE(otherItemId);
						//break;
					}

					DOFREE(desc);
					DOFREE(stdDesc);
					goto loop2;
				}
				DOFREE(desc);
				DOFREE(stdDesc);

				//
				int n_entries = 1;
				char *qry_entries[1] = { "" }, *qry_values[1] = { objectDesc };
				int n_found = 0;
				tag_t * dba_mbrs = NULLTAG;
				char queryName[256] = "";
				strcat(queryName, "ѯ");
				TCFindItem(queryName, n_entries, qry_entries, qry_values, &n_found, &dba_mbrs);

				bool isHaveItem = false;
				for (int ii = 0; ii < n_found; ii++)
				{
					char* checkId;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &checkId);
					//idк"-"
					if (strstr(checkId, "-") != NULL)
					{
						continue;
					}
					int releaseCount = 0;
					tag_t* releaseTag = NULL_TAG;
					//ȡӼķ״̬
					AOM_ask_value_tags(dba_mbrs[ii], "release_status_list", &releaseCount, &releaseTag);
					if (releaseCount > 0) {
						bool flag = false;
						for (int a = 0; a < releaseCount; a++) {
							char* releaseName;
							AOM_ask_value_string(releaseTag[a], "object_name", &releaseName);
							if (strcmp(releaseName, "ȡ") == 0 || strcmp(releaseName, "ML8_Replaced") == 0) {
								//һѭ
								flag = true;
								break;
							}
						}
						if (flag) {
							isHaveItem = false;
							continue;
						}
					}

					char * otherItemId = NULL;
					AOM_ask_value_string(dba_mbrs[ii], "item_id", &otherItemId);
					printf("ԱItem_id:%s---%s Start===================\n", otherItemId, itemId);
					if (strcmp(otherItemId, itemId) == 0)
					{
						DOFREE(otherItemId);
						continue;
					}
					isHaveItem = true;
					strcat(resultString, otherItemId);
					strcat(resultString, "");
					strcat(resultString, "Ѵ");
					strcat(resultString, objectDesc);
					strcat(resultString, "\n");
					DOFREE(otherItemId);
					//break;
				}
				if (isHaveItem)
				{
					goto loop2;
				}

				/*if (n_found > 0)
				{
					strcat(resultString, "ϵͳѴ");
					strcat(resultString, objectDesc);
					strcat(resultString, "/n");

					DOFREE(dba_mbrs);
					goto loop2;
				}*/
				//ͱ׼
				if (strlen(resultString) == 0) {
					AOM_lock(attachments[i]);
					AOM_set_value_string(attachments[i], "object_desc", objectDesc);
					AOM_set_value_string(attachments[i], "ml8_StdDesc", objectDesc);
					AOM_save(attachments[i]);
					AOM_unlock(attachments[i]);
					AOM_refresh(attachments[i], false);
				}
				

				DOFREE(dba_mbrs);
			}

		loop2:
			DOFREE(itemObjectType);
			DOFREE(propertyValue);
			DOFREE(objectName);
			DOFREE(externalWorking);
			DOFREE(colour);
			DOFREE(figureNum);
			DOFREE(identification);
			DOFREE(specifications);
		}

		DOFREE(itemType);
		DOFREE(itemObjectDesc);
	}
	DOFREE(attachments);
	if (gbk_strlen(resultString) > 2)
	{
		ifail = 1;
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ChangeObjectDescʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ChangeObjectDescʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("========================= End===================\n");
	return ifail;
}