#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

void getTCMMesSpecialProcessJson(int index, tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000]);
void getTCMMesSpecialProcessProperty(tag_t topLine, tag_t BomLine, char * prodOrderNo, char * ERPCode, map<string, string> typePropertyType, char parameters[100000]);

bool isMesSpecialProcessStart = true;

void getTCMMesSpecialProcessProperty(tag_t item, map<string, string> typePropertyType, char parameters[100000])
{
	char *itemType = NULL;
	AOM_ask_value_string(item, "object_type", &itemType);

	printf("itemType%s Start===================\n", itemType);

	//˵ǰ汾Ķ
	if ((strstr(itemType, "Revision") == NULL) || (strstr(itemType, "Master") != NULL)
		|| (strstr(itemType, "master") != NULL) || (strstr(itemType, "BOM") != NULL) || (strstr(itemType, "bom") != NULL) || (strstr(itemType, "Bom") != NULL))
	{
		DOFREE(itemType);
		return;
	}
	//ȡ
	tag_t top_line = NULLTAG, window = NULLTAG;
	BOM_create_window(&window);
	//öBOM
	BOM_set_window_top_line(window, NULLTAG, item, NULLTAG, &top_line);
	//ȡjsonַ
	if (isMesSpecialProcessStart)
	{
		getTCMMesSpecialProcessJson(-1, top_line, NULLTAG, typePropertyType, parameters);
		isMesSpecialProcessStart = false;
	}
	else
	{
		getTCMMesSpecialProcessJson(-1, top_line, NULLTAG, typePropertyType, parameters);
	}

	BOM_close_window(window);
	MEM_free(itemType);
}

int ML_TCMSendMesSpecialProcess(EPM_action_message_t msg)
{
	printf("=========================TCM BOM·SAP Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	//POM_AM__set_application_bypass(true);
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	//ȡ
	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char messageUser[1024] = "", messageResult[1024] = "";
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "ownerId") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageUser, argvalue);
				}
			}
			else if (stricmp(argflag, "messageResult") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageResult, argvalue);
				}
			}
		}
	}

	vector<char *> messageUserValues;

	if (strstr(messageUser, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(messageUser, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			messageUserValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		messageUserValues.push_back(messageUser);
	}

	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("ML_TCMBOMSendSapProperty", &pref_cnt, &pref_vals);
	map<string, string> typePropertyType;
	for (int j = 0; j < pref_cnt; j++)
	{
		if (strstr(pref_vals[j], "-") != NULL)
		{
			//-в֡
			int valueCount = 0;
			char ** valueChar = new char *[64];
			//ַָ
			split(pref_vals[j], "-", valueChar, &valueCount);
			typePropertyType[valueChar[0]] = valueChar[1];// .insert(std::pair<char*, char*>(valueChar[0], valueChar[1]));
		}
	}

	char *tc_root_file = getenv("tc_root");		//C:\Siemens\Teamcenter11
	char parameters[100000] = "";//д뵽ļֵ
	strcat(parameters, "getTCMMesSpecialProcessPropertys}}");
	strcat(parameters, messageUser);
	strcat(parameters, "}}");
	//strcat(parameters, "<soapenv:Envelope xmlns:soapenv=\"http://schemas.xmlsoap.org/soap/envelope/\" xmlns:tem=\"http://tempuri.org/\">");
	//strcat(parameters, "<soapenv:Header/>");
	//strcat(parameters, "<soapenv:Body>");
	//strcat(parameters, "<tem:PostSpecialProcessData>");
	//strcat(parameters, "<tem:dataList>");
	strcat(parameters, "[");

	for (int i = 0; i < attachments_num; i++)
	{
		getTCMMesSpecialProcessProperty(attachments[i], typePropertyType, parameters);
	}
	strcat(parameters, "]");
	/*strcat(parameters, "</tem:dataList>");
	strcat(parameters, "</tem:PostSpecialProcessData>");
	strcat(parameters, "</soapenv:Body>");
	strcat(parameters, "</soapenv:Envelope>");*/

	isMesSpecialProcessStart = true;
	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	//дļ
	char data_file[SS_MAXPATHLEN] = "";
	strcat(data_file, tc_root_file);
	strcat(data_file, "\\");
	strcat(data_file, date);
	strcat(data_file, ".txt");

	ofstream file;
	file.open(data_file);
	file << parameters << endl; // ʹcoutͬķʽд
	file.close();

	string strResult;

	//cmdָ
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, tc_root_file);
	strcat(cmd, "\\portal\\plugins\\");
	strcat(cmd, "ML_SendSap.jar");
	strcat(cmd, "\" ");
	//
	cout << data_file << endl;
	strcat(cmd, data_file);
	//ݱ̵(@ָ)
	//strcat(cmd,"@");
	//strcat(cmd,handler_name);
	printf("·:\n%s\n", cmd);
	char buf[8000] = { 0 };
	FILE *pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}

	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);

	cout << strResult << endl;
	unsigned int iSize = strResult.size();
	if (iSize > 0 && strResult[iSize - 1] == '\n' && strlen(parameters) > 0)
	{
		strResult = strResult.substr(0, iSize - 1);
		printf("·ʧ\n");
		cout << strResult << endl;
		//Ϣҵ΢
		for (auto messageUserValue : messageUserValues) {
			BOMSendToWeixin(messageUserValue, rootTask, strResult);
		}
		if (strcmp(messageResult, "1") == 0)
		{
			ifail = 1;
		}
	}
	else
	{
		POM_AM__set_application_bypass(TRUE);
		//ȡ״ηʱ
		for (int i = 0; i < attachments_num; i++)
		{
			char *itemType = NULL;
			AOM_ask_value_string(attachments[i], "object_type", &itemType);
			//˵ǰ汾Ķ
			if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
				|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
				|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
			{
				//ȡǰʱ
				time_t now = time(0);
				tm *p = localtime(&now);

				char dateNow[128] = "";
				sprintf_s(dateNow, "%04d-%02d-%02d %02d:%02d:%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

				AOM_lock(attachments[i]);
				/*if (sendTime == NULL || strcmp(sendTime, "") == 0)
				{
				AOM_set_value_string(attachments[i], "ml8_BOMFirstTime", dateNow);
				}
				else
				{
				AOM_set_value_string(attachments[i], "ml8_BOMNewTime", dateNow);
				}*/
				AOM_save(attachments[i]);
				AOM_unlock(attachments[i]);
				AOM_refresh(attachments[i], false);
				DOFREE(sendTime);
			}
			DOFREE(itemType);
		}
		POM_AM__set_application_bypass(FALSE);
	}
	messageUserValues.clear();
	vector<char *>().swap(messageUserValues);
	MEM_free(attachments);
	tc_root_file = NULL;
	pref_vals = NULL;
	if (ifail == 1)
	{
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, strResult.c_str());
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_TCMSendMesSpecialProcessʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_TCMSendMesSpecialProcessʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================TCM BOM·SAP End===================\n");
	return ifail;
}

void getTCMMesSpecialProcessJson(int index, tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000])
{
	//ȡBOM
	char * prodOrderNo = NULL;//
	char * ERPCode = NULL;//ERP

	tag_t revisions = NULLTAG;

	AOM_ask_value_tag(topLine, "bl_line_object", &revisions);

	//AOM_ask_value_string(revisions, "ml8_ProdOrderNo", &prodOrderNo);
	//AOM_ask_value_string(revisions, "ml8_ERPCode", &ERPCode);

	getTCMMesSpecialProcessProperty(topLine, BomLine, prodOrderNo, ERPCode, typePropertyType, parameters);

	DOFREE(prodOrderNo);
	DOFREE(ERPCode);
}

void getTCMMesSpecialProcessProperty(tag_t topLine, tag_t BomLine, char * prodOrderNo, char * ERPCode, map<string, string> typePropertyType, char parameters[100000])
{
	//ȡרµר
	int  count;
	tag_t *children_line = NULLTAG;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		//жǷΪר
		char * itemType = NULL;
		AOM_ask_value_string(children_line[i], "fnd0bl_line_object_type", &itemType);

		if (strcmp(itemType, "ML8_SpecOpRevision") != 0)
		{
			DOFREE(itemType);
			continue;
		}
		tag_t opRevisions = NULLTAG;
		AOM_ask_value_tag(children_line[i], "bl_line_object", &opRevisions);
		char * itemId = NULL;
		AOM_ask_value_string(children_line[i], "bl_item_item_id", &itemId);
		char * objectName = NULL;
		AOM_ask_value_string(children_line[i], "bl_item_object_name", &objectName);
		char * line = NULL;
		AOM_ask_value_string(opRevisions, "ml8_Line", &line);
		if (line == NULL || strcmp(line, "") == 0)
		{
			line = "ALL";
		}
		else
		{
			line = getLineCode(line);
		}

		//ȡרµĹϢ
		int  stepCount;
		tag_t * step_Bomline = NULLTAG;

		BOM_line_ask_all_child_lines(children_line[i], &stepCount, &step_Bomline);

		for (int j = 0; j < count; j++)
		{
			//ж͹
			char * stepItemType = NULL;
			AOM_ask_value_string(step_Bomline[j], "fnd0bl_line_object_type", &stepItemType);
			tag_t revisions = NULLTAG;
			AOM_ask_value_tag(step_Bomline[j], "bl_line_object", &revisions);

			map<char *, char *> propertyMap;

			if (strcmp(stepItemType, "ML8_FPStepRevision") == 0)
			{
				//ȡ汾ǹͷѹޡǹͷѹޡѹޡѹޡޡ
				char * spearHeadPressureMax = NULL;
				char * spearHeadPressureMin = NULL;
				char * pressureScopeMax = NULL;
				char * pressureScopeMin = NULL;
				char * materialCMax = NULL;
				char * materialCMin = NULL;

				AOM_ask_value_string(revisions, "ml8_SpearHeadPressureMax", &spearHeadPressureMax);
				AOM_ask_value_string(revisions, "ml8_SpearHeadPressureMin", &spearHeadPressureMin);
				AOM_ask_value_string(revisions, "ml8_PressureScopeMax", &pressureScopeMax);
				AOM_ask_value_string(revisions, "ml8_PressureScopeMin", &pressureScopeMin);
				AOM_ask_value_string(revisions, "ml8_MaterialCMax", &materialCMax);
				AOM_ask_value_string(revisions, "ml8_MaterialCMin", &materialCMin);

				propertyMap["ǹͷѹޣbar"] = spearHeadPressureMax;
				propertyMap["ǹͷѹޣbar"] = spearHeadPressureMin;
				propertyMap["ѹޣbar"] = pressureScopeMax;
				propertyMap["ѹޣbar"] = pressureScopeMin;
				propertyMap["ޣ棩"] = materialCMax;
				propertyMap["ޣ棩"] = materialCMin;

				DOFREE(spearHeadPressureMax);
				DOFREE(spearHeadPressureMin);
				DOFREE(pressureScopeMax);
				DOFREE(pressureScopeMin);
				DOFREE(materialCMax);
				DOFREE(materialCMin);
			}
			else if (strcmp(stepItemType, "ML8_GZStepRevision") == 0)
			{
				//ȡ汾Թעޡע
				char * fillToleranceMax = NULL;
				char * fillToleranceMin = NULL;

				AOM_ask_value_string(revisions, "ml8_FillToleranceMax", &fillToleranceMax);
				AOM_ask_value_string(revisions, "ml8_FillToleranceMin", &fillToleranceMin);

				propertyMap["ע"] = fillToleranceMax;
				propertyMap["ע"] = fillToleranceMin;

				DOFREE(fillToleranceMax);
				DOFREE(fillToleranceMax);
			}

			//MAPƴַ
			for (map<char*, char*>::iterator ii = propertyMap.begin(); ii != propertyMap.end(); ii++)
			{
				//ƴjsonַ
				if (isMesSpecialProcessStart)
				{
					strcat(parameters, "{");
					isMesSpecialProcessStart = FALSE;
				}
				else
				{
					strcat(parameters, ",{");
				}

				strcat(parameters, "\"");
				strcat(parameters, "LineCode");
				strcat(parameters, "\"");
				strcat(parameters, ":");
				strcat(parameters, "\"");
				strcat(parameters, line);
				strcat(parameters, "\",");
				strcat(parameters, "\"");
				strcat(parameters, "ProcessCode");
				strcat(parameters, "\"");
				strcat(parameters, ":");
				strcat(parameters, "\"");
				strcat(parameters, itemId);
				strcat(parameters, "\",");
				strcat(parameters, "\"");
				strcat(parameters, "ProcessName");
				strcat(parameters, "\"");
				strcat(parameters, ":");
				strcat(parameters, "\"");
				strcat(parameters, objectName);
				strcat(parameters, "\",");
				strcat(parameters, "\"");
				strcat(parameters, "ParameterName");
				strcat(parameters, "\"");
				strcat(parameters, ":");
				strcat(parameters, "\"");
				strcat(parameters, ii->first);
				strcat(parameters, "\",");
				strcat(parameters, "\"");
				strcat(parameters, "ParameterValue");
				strcat(parameters, "\"");
				strcat(parameters, ":");
				strcat(parameters, "\"");
				strcat(parameters, ii->second);
				strcat(parameters, "\"");

				strcat(parameters, "}");
			}

			propertyMap.clear();
			map<char*, char*>().swap(propertyMap);
			DOFREE(stepItemType);
		}

		DOFREE(step_Bomline);
		DOFREE(objectName);
		DOFREE(itemType);
		DOFREE(itemId);
		DOFREE(line);
	}

	DOFREE(children_line);
}