#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

void getTCMMonolayerBomLineReplaceItem(tag_t topLine, vector<tag_t> &bomLine);
void getTCMMonolayerItemJson(int index,tag_t topLine, tag_t BomLine, bool isStart, map<string, string> typePropertyType, char parameters[100000]);
void getTCMMonolayerBomLineProperty(tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char * bomBaseNum, char parameters[100000]);

int ML_TCMSendSapBomMonolayer(EPM_action_message_t msg)
{
	printf("=========================BOM·SAP Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	//POM_AM__set_application_bypass(true);
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	//ȡ
	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char messageUser[1024] = "", messageResult[1024] = "";
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "ownerId") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageUser, argvalue);
				}
			}
			else if (stricmp(argflag, "messageResult") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageResult, argvalue);
				}
			}
		}
	}

	vector<char *> messageUserValues;

	if (strstr(messageUser, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(messageUser, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			messageUserValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		messageUserValues.push_back(messageUser);
	}

	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("ML_BOMSendSapProperty", &pref_cnt, &pref_vals);
	map<string, string> typePropertyType;
	for (int j = 0; j < pref_cnt; j++)
	{
		if (strstr(pref_vals[j], "-") != NULL)
		{
			//-в֡
			int valueCount = 0;
			char ** valueChar = new char *[64];
			//ַָ
			split(pref_vals[j], "-", valueChar, &valueCount);
			typePropertyType[valueChar[0]] = valueChar[1];// .insert(std::pair<char*, char*>(valueChar[0], valueChar[1]));
		}
	}

	bool isStart = true;
	char *tc_root_file = getenv("tc_root");		//C:\Siemens\Teamcenter11
	char parameters[100000] = "";//д뵽ļֵ
	strcat(parameters, "getTCMBomPropertys}}");
	strcat(parameters, messageUser);
	strcat(parameters, "}}");
	strcat(parameters, "<n0:MT_TCM2SAP_CS01 xmlns:n0=\"urn:changhong.com:TCM:mlsc\">");
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;
		AOM_ask_value_string(attachments[i], "object_type", &itemType);

		printf("itemType%s Start===================\n", itemType);

		//˵ǰ汾Ķ
		if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
			|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
			|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
		{
			//жml8_AddTradeΪml8_ProcessingModeΪЭ⹺ҰӼ򲻴
			//char * addTrade = NULL, * processingMode = NULL;
			//AOM_ask_value_string(attachments[i], "ml8_AddTrade", &addTrade);
			//AOM_ask_value_string(attachments[i], "ml8_ProcessingMode", &processingMode);
			//int childNum = 0;
			//tag_t * childItem = NULLTAG;
			////ȡӼ
			//AOM_ask_value_tags(attachments[i], "ps_children", &childNum, &childItem);
			//if (strcmp(addTrade, "") == 0 && strcmp(processingMode, "Э⹺") == 0 && childNum > 0)
			//{
			//	MEM_free(addTrade);
			//	MEM_free(processingMode);
			//	MEM_free(childItem);
			//	continue;
			//}

			//ȡаĿBOM
			vector<tag_t> bomLines;
			//ȡ
			tag_t top_line = NULLTAG, window = NULLTAG;
			BOM_create_window(&window);
			//öBOM
			BOM_set_window_top_line(window, NULLTAG, attachments[i], NULLTAG, &top_line);
			getTCMMonolayerBomLineReplaceItem(top_line, bomLines);
			if (bomLines.size() > 0)
			{
				for (int j = 0; j < bomLines.size(); j++)
				{
					tag_t bomLine = bomLines.at(j);
					//ȡjsonַ
					if (isStart)
					{
						getTCMMonolayerItemJson(j + 1,top_line, bomLine, isStart, typePropertyType, parameters);
						isStart = false;
					}
					else
					{
						getTCMMonolayerItemJson(j + 1, top_line, bomLine, isStart, typePropertyType, parameters);
					}
				}
			}
			else
			{
				//ȡjsonַ
				if (isStart)
				{
					getTCMMonolayerItemJson(-1,top_line, NULLTAG, isStart, typePropertyType, parameters);
					isStart = false;
				}
				else
				{
					getTCMMonolayerItemJson(-1, top_line, NULLTAG, isStart, typePropertyType, parameters);
				}
			}


			BOM_close_window(window);
			/*MEM_free(addTrade);
			MEM_free(processingMode);
			MEM_free(childItem);*/
		}

		MEM_free(itemType);
	}

	strcat(parameters, "</n0:MT_TCM2SAP_CS01>");
	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	//дļ
	char data_file[SS_MAXPATHLEN] = "";
	strcat(data_file, tc_root_file);
	strcat(data_file, "\\");
	strcat(data_file, date);
	strcat(data_file, ".txt");

	ofstream file;
	file.open(data_file);
	file << parameters << endl; // ʹcoutͬķʽд
	file.close();

	string strResult;

	//cmdָ
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, tc_root_file);
	strcat(cmd, "\\portal\\plugins\\");
	strcat(cmd, "ML_SendSap.jar");
	strcat(cmd, "\" ");
	//
	cout << data_file << endl;
	strcat(cmd, data_file);
	//ݱ̵(@ָ)
	//strcat(cmd,"@");
	//strcat(cmd,handler_name);
	printf("·:\n%s\n", cmd);
	char buf[8000] = { 0 };
	FILE *pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}

	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);

	cout << strResult << endl;
	unsigned int iSize = strResult.size();
	if (iSize > 0 && strResult[iSize - 1] == '\n' && strlen(parameters) > 0)
	{
		strResult = strResult.substr(0, iSize - 1);
		printf("·ʧ\n");
		cout << strResult << endl;
		//Ϣҵ΢
		for (auto messageUserValue : messageUserValues) {
			BOMSendToWeixin(messageUserValue, rootTask, strResult);
		}
		if (strcmp(messageResult, "1") == 0)
		{
			ifail = 1;
		}
	}
	else
	{
		POM_AM__set_application_bypass(TRUE);
		//ȡ״ηʱ
		for (int i = 0; i < attachments_num; i++)
		{
			char *itemType = NULL;
			AOM_ask_value_string(attachments[i], "object_type", &itemType);
			//˵ǰ汾Ķ
			if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
				|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
				|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
			{
				char * sendTime = NULL;

				AOM_ask_value_string(attachments[i], "ml8_BOMFirstTime", &sendTime);

				//ȡǰʱ
				time_t now = time(0);
				tm *p = localtime(&now);

				char dateNow[128] = "";
				sprintf_s(dateNow, "%04d-%02d-%02d %02d:%02d:%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

				AOM_lock(attachments[i]);
				if (sendTime == NULL || strcmp(sendTime, "") == 0)
				{
					AOM_set_value_string(attachments[i], "ml8_BOMFirstTime", dateNow);
				}
				else
				{
					AOM_set_value_string(attachments[i], "ml8_BOMNewTime", dateNow);
				}
				AOM_save(attachments[i]);
				AOM_unlock(attachments[i]);
				AOM_refresh(attachments[i], false);
				DOFREE(sendTime);
			}
			DOFREE(itemType);
		}
		POM_AM__set_application_bypass(FALSE);
	}
	messageUserValues.clear();
	vector<char *>().swap(messageUserValues);
	MEM_free(attachments);
	tc_root_file = NULL;
	pref_vals = NULL;
	if (ifail == 1)
	{
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, strResult.c_str());
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_TCMSendSapBomMonolayerʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_TCMSendSapBomMonolayerʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================BOM·SAP End===================\n");
	return ifail;
}

void getTCMMonolayerBomLineReplaceItem(tag_t topLine, vector<tag_t> &bomLine)
{
	int  count;
	tag_t *children_line;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		char * replaceProject = NULL;
		AOM_ask_value_string(children_line[i], "ML8_ProjectTeam", &replaceProject);
		printf("ML8_ProjectTeam%s===================\n", replaceProject);
		if (replaceProject != NULL && strcmp(replaceProject, "") != 0)
		{
			bomLine.push_back(children_line[i]);
		}
		DOFREE(replaceProject);
	}
	DOFREE(children_line);
}

void getTCMMonolayerItemJson(int index,tag_t topLine, tag_t BomLine, bool isStart, map<string, string> typePropertyType, char parameters[100000])
{
	//ȡ
	char * matnr = NULL;//ϱ
	char * werks = NULL;//
	char * lineCode = NULL;//ߴ,BOM汾Ϊߴż1λˮ
	char * bomusage = "1";//BOM;
	char * alternative = NULL;//BOM汾
	char * validdate = "20200101";//Ч
	char * description = NULL;//ѡBOMı
	char * basequan = "1000";//

	tag_t revisions = NULLTAG;

	AOM_ask_value_tag(topLine, "bl_line_object", &revisions);

	AOM_ask_value_string(topLine, "bl_item_item_id", &matnr);
	if (strstr(matnr, "-") != NULL)
	{
		//,в֡
		int matnrCount = 0;
		char ** matnrChar = new char *[64];
		//ַָ
		split(matnr, "-", matnrChar, &matnrCount);

		matnr = matnrChar[0];
	}
	AOM_ask_value_string(revisions, "ml8_Factory", &werks);
	AOM_ask_value_string(revisions, "ml8_LineCode", &lineCode);
	if (index > -1)
	{
		char itc[10];
		_itoa(index, itc, 10);
		alternative = itc;
	}
	else
	{
		alternative = "1";
		//AOM_ask_value_string(revisions, "ml8_SAPBOMRevision", &alternative);
	}
	AOM_ask_value_string(topLine, "bl_item_object_name", &description);
	AOM_ask_value_string(revisions, "ml8_BOMBasicQuantity", &basequan);


	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	strcat(parameters, "<MSG_HDR>");
	strcat(parameters, "<MSGID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</MSGID>");
	strcat(parameters, "<BUSID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</BUSID>");
	strcat(parameters, "<TLGID>");
	strcat(parameters, "JT0001");
	strcat(parameters, "</TLGID>");
	strcat(parameters, "<TLGNAME>");
	strcat(parameters, "άMOBMӿ");
	strcat(parameters, "</TLGNAME>");
	strcat(parameters, "<DTSEND>");
	strcat(parameters, date);
	strcat(parameters, "</DTSEND>");
	strcat(parameters, "<SENDER>");
	strcat(parameters, "TCM");
	strcat(parameters, "</SENDER>");
	strcat(parameters, "<RECEIVER>");
	strcat(parameters, "SAP");
	strcat(parameters, "</RECEIVER>");
	strcat(parameters, "<FREEUSE>");
	strcat(parameters, matnr);
	strcat(parameters, "</FREEUSE>");
	strcat(parameters, "</MSG_HDR>");
	strcat(parameters, "<MSG_BODY>");
	strcat(parameters, "<HEADER>");
	strcat(parameters, "<MATNR>");
	strcat(parameters, matnr);
	strcat(parameters, "</MATNR>");
	strcat(parameters, "<WERKS>");
	strcat(parameters, werks);
	strcat(parameters, "</WERKS>");
	strcat(parameters, "<STLAN>");
	strcat(parameters, bomusage);
	strcat(parameters, "</STLAN>");
	strcat(parameters, "<STLAL>");
	strcat(parameters, lineCode);
	strcat(parameters, alternative);
	strcat(parameters, "</STLAL>");
	strcat(parameters, "<BMENG>");
	strcat(parameters, basequan);
	strcat(parameters, "</BMENG>");
	strcat(parameters, "<DATUV>");
	strcat(parameters, validdate);
	strcat(parameters, "</DATUV>");
	strcat(parameters, "<STKTX>");
	strcat(parameters, description);
	strcat(parameters, "</STKTX>");
	strcat(parameters, "</HEADER>");

	getTCMMonolayerBomLineProperty(topLine, BomLine, typePropertyType, basequan, parameters);

	strcat(parameters, "</MSG_BODY>");

	DOFREE(matnr);
	DOFREE(werks);
	DOFREE(bomusage);
	DOFREE(alternative);
	DOFREE(validdate);
	DOFREE(description);
	DOFREE(basequan);
}

void getTCMMonolayerBomLineProperty(tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char * bomBaseNum, char parameters[100000])
{
	//char parameters[100000] = "";//д뵽ļֵ
	bool isStart = true;
	int  count;
	tag_t *children_line = NULLTAG;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		char * replaceProject = NULL;
		AOM_ask_value_string(children_line[i], "ML8_ProjectTeam", &replaceProject);

		if (replaceProject != NULL && strcmp(replaceProject, "") != 0 && BomLine != NULLTAG)
		{
			//жǷڴBOM
			char * itemId = NULL;
			AOM_ask_value_string(children_line[i], "bl_item_item_id", &itemId);
			char * inputItemId = NULL;
			AOM_ask_value_string(BomLine, "bl_item_item_id", &inputItemId);
			if (strcmp(itemId, inputItemId) != 0)
			{
				continue;
			}
		}

		char *itemType = NULL;
		AOM_ask_value_string(children_line[i], "fnd0bl_line_object_type", &itemType);
		char * puid = NULL;
		//ȡPUID
		ITK__convert_tag_to_uid(children_line[i], &puid);
		//˵ǰ汾Ķ
		string propertyNames = typePropertyType[itemType];
		if (propertyNames.c_str() != NULL)
		{
			const char * constName = propertyNames.c_str();
			char* name = new char[2048];//㹻
			strcpy(name, constName);

			if (strstr(name, ",") != NULL)
			{
				//,в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, ",", valueChar, &valueCount);
				strcat(parameters, "<ITEM>");
				for (int k = 0; k < valueCount; k++)
				{
					if (strstr(valueChar[k], "=") != NULL)
					{
						//-в֡
						int valueNum = 0;
						char ** values = new char *[64];
						//ַָ
						split(valueChar[k], "=", values, &valueNum);

						strcat(parameters, "<");
						strcat(parameters, values[1]);
						strcat(parameters, ">");

						char * item_rev_value = NULL;
						TCGetPropertyValue(children_line[i], "BOMLine", values[0], &item_rev_value);
						if (strcmp(values[1], "itemno") == 0)
						{
							//Ҫ*10󣬸ʽΪ4λȺд
							int number = std::atoi(item_rev_value);
							stringToLenth(number * 10, 4, &item_rev_value);
						}
						else if (strcmp(values[1], "compqty") == 0)
						{
							//BOMϵ*SAP BOM
							double bomNum = atof(item_rev_value);
							double bomBase = atof(bomBaseNum);
							double sum = bomNum*bomBase;
							char * sumChar = new char[20];
							sprintf(sumChar, "%.3f", sum);
							cout << "bomNum" << bomNum << "bomBaseNum" << bomBaseNum << "bomBase" << bomBase << "sum" << sum << "sumChar" << sumChar << "\n" << endl;
							//printf("bomNum%dbomBaseNum%sbomBase%dsum%dsumChar%s\n", bomNum, bomBaseNum,bomBase, sum, sumChar);
							item_rev_value = sumChar;
						}

						strcat(parameters, "/<");
						strcat(parameters, item_rev_value);
						strcat(parameters, ">");

						DOFREE(item_rev_value);
					}
				}

				strcat(parameters, "</ITEM>");
			}
			else
			{
				//-в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, "=", valueChar, &valueCount);


				strcat(parameters, "<ITEM>");

				strcat(parameters, "<");
				strcat(parameters, valueChar[1]);
				strcat(parameters, ">");

				char * item_rev_value = NULL;
				TCGetPropertyValue(children_line[i], "BOMLine", valueChar[0], &item_rev_value);

				if (strcmp(valueChar[1], "itemno") == 0)
				{
					//Ҫ*10󣬸ʽΪ4λȺд
					int number = std::atoi(item_rev_value);
					stringToLenth(number * 10, 4, &item_rev_value);
				}
				else if (strcmp(valueChar[1], "compqty") == 0)
				{
					//BOMϵ*SAP BOM
					double bomNum = atof(item_rev_value);
					double bomBase = atof(bomBaseNum);
					double sum = bomNum*bomBase;
					char * sumChar = new char[20];
					sprintf(sumChar, "%.3f", sum);
					cout << "bomNum" << bomNum << "bomBaseNum" << bomBaseNum << "bomBase" << bomBase << "sum" << sum << "sumChar" << sumChar << "\n" << endl;
					item_rev_value = sumChar;
				}

				strcat(parameters, "/<");
				strcat(parameters, item_rev_value);
				strcat(parameters, ">");

				strcat(parameters, "</ITEM>");

				DOFREE(item_rev_value);
			}

			DOFREE(constName);
		}


		DOFREE(replaceProject);
		DOFREE(itemType);
		DOFREE(puid);
	}

	DOFREE(children_line);
}