#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"


bool isItemStart = true;

void getItemProperty(tag_t bomLine, map<string, string> typePropertyType, char parameters[100000]);
void getTCMItemBom(tag_t item, map<string, string> typePropertyType, char parameters[100000]);

int ML_TCMSendSapItem(EPM_action_message_t msg)
{
	printf("=========================·SAP Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	//POM_AM__set_application_bypass(true);
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	//ȡ
	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char messageUser[1024] = "", messageResult[1024] = "";
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "ownerId") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageUser, argvalue);
				}
			}
			else if (stricmp(argflag, "messageResult") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(messageResult, argvalue);
				}
			}
		}
	}

	vector<char *> messageUserValues;

	if (strstr(messageUser, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(messageUser, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			messageUserValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		messageUserValues.push_back(messageUser);
	}

	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("ML_ItemSendSapProperty", &pref_cnt, &pref_vals);
	map<string, string> typePropertyType;
	for (int j = 0; j < pref_cnt; j++)
	{
		if (strstr(pref_vals[j], "-") != NULL)
		{
			//-в֡
			int valueCount = 0;
			char ** valueChar = new char *[64];
			//ַָ
			split(pref_vals[j], "-", valueChar, &valueCount);
			typePropertyType[valueChar[0]] = valueChar[1];// .insert(std::pair<char*, char*>(valueChar[0], valueChar[1]));
		}
	}

	bool isStart = true;
	char *tc_root_file = getenv("tc_root");		//C:\Siemens\Teamcenter11
	isItemStart = true;
	char parameters[100000] = "";//д뵽ļֵ
	strcat(parameters, "getItemPropertys}}");
	strcat(parameters, "[");
	for (int i = 0; i < attachments_num; i++)
	{
		getTCMItemBom(attachments[i], typePropertyType, parameters);
	}
	strcat(parameters, "]");
	//ȡǰʱ
	time_t now = time(0); 
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	//дļ
	char data_file[SS_MAXPATHLEN] = "";
	strcat(data_file, tc_root_file);
	strcat(data_file, "\\");
	strcat(data_file, date);
	strcat(data_file, ".txt");
	ofstream file;
	file.open(data_file);
	file << parameters << endl; // ʹcoutͬķʽд
	file.close();

	string strResult;

	//cmdָ
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, tc_root_file);
	strcat(cmd, "\\portal\\plugins\\");
	strcat(cmd, "ML_SendSap.jar");
	strcat(cmd, "\" ");
	//
	cout << data_file << endl;
	strcat(cmd, data_file);
	//ݱ̵(@ָ)
	//strcat(cmd,"@");
	//strcat(cmd,handler_name);
	printf("·:\n%s\n", cmd);
	char buf[8000] = { 0 };
	FILE *pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}

	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);

	cout << strResult << endl;
	unsigned int iSize = strResult.size();
	if (iSize > 0 && strResult[iSize - 1] == '\n' && strlen(parameters) > 0)
	{

		strResult = strResult.substr(0, iSize - 1);
		printf("·ʧ\n");
		cout << strResult << endl;
		//Ϣҵ΢
		for (auto messageUserValue : messageUserValues) {
			itemSendToWeixin(messageUserValue, rootTask, strResult);
		}
		if (strcmp(messageResult, "1") == 0)
		{
			ifail = 1;
		}
	}
	else
	{
		POM_AM__set_application_bypass(TRUE);
		//ȡ״ηʱ
		for (int i = 0; i < attachments_num; i++)
		{
			char *itemType = NULL;
			AOM_ask_value_string(attachments[i], "object_type", &itemType);
			//˵ǰ汾Ķ
			if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
				|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
				|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0) || (strcmp(itemType, "ML8_UnProductRevision") == 0) || (strcmp(itemType, "ML8_ProductOthRevision") == 0))
			{
				
			}
			DOFREE(itemType);
		}
		POM_AM__set_application_bypass(FALSE);
	}
	messageUserValues.clear();
	vector<char *>().swap(messageUserValues);
	MEM_free(attachments);
	tc_root_file = NULL;
	pref_vals = NULL;
	if (ifail == 1)
	{
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, strResult.c_str());
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_TCMSendSapItemʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_TCMSendSapItemʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================·SAP End===================\n");
	return ifail;
}

void getTCMItemBom(tag_t item, map<string, string> typePropertyType, char parameters[100000])
{
	char *itemType = NULL;
	AOM_ask_value_string(item, "object_type", &itemType);

	printf("itemType%s Start===================\n", itemType);

	//˵ǰ汾Ķ
	if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
		|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
		|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
	{
		//ȡаĿBOM
		vector<tag_t> bomLines;
		//ȡ
		tag_t top_line = NULLTAG, window = NULLTAG;
		BOM_create_window(&window);
		//öBOM
		BOM_set_window_top_line(window, NULLTAG, item, NULLTAG, &top_line);
		int  count;
		tag_t *children_line;

		BOM_line_ask_all_child_lines(top_line, &count, &children_line);
		if (count > 0)
		{
			for (int i = 0; i < count; i++)
			{
				getItemProperty(children_line[i], typePropertyType, parameters);
			}
		}
		BOM_close_window(window);
		/*MEM_free(addTrade);
		MEM_free(processingMode);
		MEM_free(childItem);*/
	}

	MEM_free(itemType);
}

void getItemProperty(tag_t bomLine, map<string, string> typePropertyType, char parameters[100000])
{
	tag_t item = NULLTAG;

	AOM_ask_value_tag(bomLine, "bl_line_object", &item);

	char *itemType = NULL;
	AOM_ask_value_string(item, "object_type", &itemType);

	printf("itemType%s\n", itemType);
	//˵ǰ汾Ķ
	if ((strcmp(itemType, "ML8_PrMidItemRevision") == 0))
	{
		string propertyNames = typePropertyType[itemType];
		if (propertyNames.c_str() != NULL)
		{
			if (isItemStart)
			{
				strcat(parameters, "{");
				isItemStart = false;
			}
			else
			{
				strcat(parameters, ",{");
			}

			const char * constName = propertyNames.c_str();
			char* name = new char[2048];//㹻
			strcpy(name, constName);
			if (strstr(name, ",") != NULL)
			{
				//,в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, ",", valueChar, &valueCount);
				for (int k = 0; k < valueCount; k++)
				{
					if (strstr(valueChar[k], "=") != NULL)
					{
						//-в֡
						int valueNum = 0;
						char ** values = new char *[64];
						//ַָ
						split(valueChar[k], "=", values, &valueNum);

						strcat(parameters, "\"");
						strcat(parameters, values[1] == NULL || strlen(values[1]) == 0 ? "" : values[1]);
						strcat(parameters, "\"");
						strcat(parameters, ":");

						char * item_rev_value = NULL;
						TCGetPropertyValue(item, "Revision", values[0], &item_rev_value);
						if (strcmp(values[1], "matltype") == 0)
						{
							//⴦жǷԭ
							if ((strcmp(itemType, "ML8_PartRevision") == 0) || (strcmp(itemType, "ML8_RawMaterialRevision") == 0) || (strcmp(itemType, "ML8_UnProductRevision") == 0))
							{
								char * processingMode = NULL;
								//ȡӹʽ
								TCGetPropertyValue(item, "Revision", "rev.ml8_ProcessingMode", &processingMode);
								if (strcmp(processingMode, "") == 0)
								{
									item_rev_value = "HALB";
								}
								else
								{
									item_rev_value = "ROH";
								}
								DOFREE(processingMode);
							}
						}

						if (strcmp(values[1], "uom") == 0)
						{
							if (item_rev_value == NULL || strcmp(item_rev_value, "") == 0)
							{
								item_rev_value = "ea";
							}
							else
							{
								if (strcmp(item_rev_value, "Eac") == 0 || strcmp(item_rev_value, "Each.") == 0)
								{
									item_rev_value = "ea";
								}
							}
						}

						if (strstr(item_rev_value, "\"") != NULL)
						{
							string resultString = replace_all_distinct(item_rev_value, "\"", "\\\"");

							char resultChar[256] = "";

							strcpy(resultChar, resultString.c_str());

							*(resultChar + strlen(resultString.c_str())) = '\0';

							item_rev_value = resultChar;

						}

						strcat(parameters, "\"");
						strcat(parameters, item_rev_value);
						strcat(parameters, "\"");
						if (k < valueCount - 1)
						{
							strcat(parameters, ",");
						}

						DOFREE(item_rev_value);
						values = NULL;
					}
					printf("parameters%s\n", parameters);
				}
				valueChar = NULL;
			}
			else
			{
				//-в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, "=", valueChar, &valueCount);

				strcat(parameters, "\"");
				strcat(parameters, valueChar[1] == NULL || strlen(valueChar[1]) == 0 ? "" : valueChar[1]);
				strcat(parameters, "\"");
				strcat(parameters, ":");

				char * item_rev_value = NULL;
				TCGetPropertyValue(item, "Revision", valueChar[0], &item_rev_value);
				if (strcmp(valueChar[1], "matltype") == 0)
				{
					//⴦жǷԭ
					if ((strcmp(itemType, "ML8_PartRevision") == 0) || (strcmp(itemType, "ML8_RawMaterialRevision") == 0) || (strcmp(itemType, "ML8_UnProductRevision") == 0))
					{
						char * processingMode = NULL;
						//ȡӹʽ
						TCGetPropertyValue(item, "Revision", "rev.ml8_ProcessingMode", &processingMode);

						if (strcmp(processingMode, "") == 0)
						{
							item_rev_value = "HALB";
						}
						else
						{
							item_rev_value = "ROH";
						}
						DOFREE(processingMode);
					}
				}
				if (strcmp(valueChar[1], "uom") == 0)
				{
					if (item_rev_value == NULL || strcmp(item_rev_value, "") == 0)
					{
						item_rev_value = "ea";
					}
					else
					{
						if (strcmp(item_rev_value, "Eac") == 0 || strcmp(item_rev_value, "Each.") == 0)
						{
							item_rev_value = "ea";
						}
					}
				}

				if (strstr(item_rev_value, "\"") != NULL)
				{
					string resultString = replace_all_distinct(item_rev_value, "\"", "\\\"");

					char resultChar[256] = "";

					strcpy(resultChar, resultString.c_str());

					*(resultChar + strlen(resultString.c_str())) = '\0';

					item_rev_value = resultChar;

				}

				strcat(parameters, "\"");
				strcat(parameters, item_rev_value);
				strcat(parameters, "\"");
				DOFREE(item_rev_value);
				valueChar = NULL;
			}

			strcat(parameters, "}");

			DOFREE(constName);
			name = NULL;

		}
	}
	else
	{
		getTCMItemBom(item, typePropertyType, parameters);
	}

	DOFREE(itemType);
	
}
