#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

void getTCMUserBomLineReplaceItem(tag_t topLine, vector<tag_t> &bomLine);
void getTCMUserItemJson(int index,tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000]);
void getTCMUserBomLineProperty(tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char * bomBaseNum, char parameters[100000]);
void getTCMUserBomLineChildProperty(tag_t topLine, map<string, string> typePropertyType, char parameters[100000]);

bool isUserBomStart = true;

void getTCMUserItemBomProperty(tag_t item, map<string, string> typePropertyType, char parameters[100000])
{

	char * lineCode = NULL;//ߴ,BOM汾Ϊߴż1λˮ
	AOM_ask_value_string(item, "ml8_LineCode", &lineCode);
	if (lineCode == NULL || strcmp(lineCode, "") == 0)
	{
		MEM_free(lineCode);
		return;
	}
	char *itemType = NULL;
	AOM_ask_value_string(item, "object_type", &itemType);

	printf("itemType%s Start===================\n", itemType);

	//˵ǰ汾Ķ
	if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
		|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
		|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
	{
		//жǷ񷢲
		int releaseCount = 0;
		tag_t * releaseTag = NULL_TAG;
		//жӼǷ񷢲
		AOM_ask_value_tags(item, "release_status_list", &releaseCount, &releaseTag);

		printf("״̬%d===================\n", releaseCount);
		if (releaseCount <= 0)
		{
			MEM_free(releaseTag);
			MEM_free(itemType);
			return;
		}
		//ȡаĿBOM
		vector<tag_t> bomLines;
		//ȡ
		tag_t top_line = NULLTAG, window = NULLTAG;
		BOM_create_window(&window);
		//öBOM
		BOM_set_window_top_line(window, NULLTAG, item, NULLTAG, &top_line);
		getTCMUserBomLineReplaceItem(top_line, bomLines);
		if (bomLines.size() > 0)
		{
			for (int j = 0; j < bomLines.size(); j++)
			{
				tag_t bomLine = bomLines.at(j);
				//ȡjsonַ
				if (isUserBomStart)
				{
					getTCMUserItemJson(j + 1, top_line, bomLine, typePropertyType, parameters);
					isUserBomStart = false;
				}
				else
				{
					getTCMUserItemJson(j + 1, top_line, bomLine, typePropertyType, parameters);
				}
			}

			//ȡBOM
			//getTCMUserBomLineChildProperty(top_line, typePropertyType, parameters);
		}
		else
		{
			//ȡjsonַ
			if (isUserBomStart)
			{
				getTCMUserItemJson(-1, top_line, NULLTAG, typePropertyType, parameters);
				isUserBomStart = false;
			}
			else
			{
				getTCMUserItemJson(-1, top_line, NULLTAG, typePropertyType, parameters);
			}

			//ȡBOM
			//getTCMUserBomLineChildProperty(top_line, typePropertyType, parameters);
		}

		BOM_close_window(window);
		MEM_free(releaseTag);
	}
	MEM_free(lineCode);
	MEM_free(itemType);
}

int ML_TCMUserSendSapBom(void * returnValue)
{
	printf("=========================TCM User BOM·SAP Start===================\n");
	//POM_AM__set_application_bypass(true);
	int ifail = ITK_ok;
	tag_t item = NULLTAG;
	char * messageUser = NULL;
	USERARG_get_tag_argument(&item);
	USERARG_get_string_argument(&messageUser);
	
	vector<char *> messageUserValues;

	if (strstr(messageUser, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(messageUser, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			messageUserValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		messageUserValues.push_back(messageUser);
	}

	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("ML_TCMBOMSendSapProperty", &pref_cnt, &pref_vals);
	map<string, string> typePropertyType;
	for (int j = 0; j < pref_cnt; j++)
	{
		if (strstr(pref_vals[j], "-") != NULL)
		{
			//-в֡
			int valueCount = 0;
			char ** valueChar = new char *[64];
			//ַָ
			split(pref_vals[j], "-", valueChar, &valueCount);
			typePropertyType[valueChar[0]] = valueChar[1];// .insert(std::pair<char*, char*>(valueChar[0], valueChar[1]));
		}
	}

	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	char *tc_root_file = getenv("tc_root");		//C:\Siemens\Teamcenter11
	char parameters[100000] = "";//д뵽ļֵ
	strcat(parameters, "getTCMBomPropertys}}");
	strcat(parameters, messageUser);
	strcat(parameters, "}}");
	strcat(parameters, "<n0:MT_TCM2SAP_CS01 xmlns:n0=\"urn:changhong.com:TCM:mlsc\">");
	getTCMUserItemBomProperty(item, typePropertyType, parameters);

	strcat(parameters, "</n0:MT_TCM2SAP_CS01>");

	isUserBomStart = true;
	
	//дļ
	char data_file[SS_MAXPATHLEN] = "";
	strcat(data_file, tc_root_file);
	strcat(data_file, "\\");
	strcat(data_file, date);
	strcat(data_file, ".txt");

	ofstream file;
	file.open(data_file);
	file << parameters << endl; // ʹcoutͬķʽд
	file.close();

	string strResult;

	//cmdָ
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, tc_root_file);
	strcat(cmd, "\\portal\\plugins\\");
	strcat(cmd, "ML_SendSap.jar");
	strcat(cmd, "\" ");
	//
	cout << data_file << endl;
	strcat(cmd, data_file);
	//ݱ̵(@ָ)
	//strcat(cmd,"@");
	//strcat(cmd,handler_name);
	printf("·:\n%s\n", cmd);
	char buf[8000] = { 0 };
	FILE *pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}

	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);

	cout << strResult << endl;
	unsigned int iSize = strResult.size();
	if (iSize > 0 && strResult[iSize - 1] == '\n' && strlen(parameters) > 0)
	{
		strResult = strResult.substr(0, iSize - 1);
		printf("·ʧ\n");
		cout << strResult << endl;
		//Ϣҵ΢
		for (auto messageUserValue : messageUserValues) {
			BOMSendToWeixin(messageUserValue, NULLTAG, strResult);
		}
	}
	else
	{
		POM_AM__set_application_bypass(TRUE);
		//ȡ״ηʱ
		char *itemType = NULL;
		AOM_ask_value_string(item, "object_type", &itemType);
		//˵ǰ汾Ķ
		if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
			|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0)
			|| (strcmp(itemType, "ML8_RawMaterialRevision") == 0))
		{
			//ȡǰʱ
			time_t now = time(0);
			tm *p = localtime(&now);

			char dateNow[128] = "";
			sprintf_s(dateNow, "%04d-%02d-%02d %02d:%02d:%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

			AOM_lock(item);
			/*if (sendTime == NULL || strcmp(sendTime, "") == 0)
			{
				AOM_set_value_string(item, "ml8_BOMFirstTime", dateNow);
			}
			else
			{
				AOM_set_value_string(item, "ml8_BOMNewTime", dateNow);
			}*/
			AOM_save(item);
			AOM_unlock(item);
			AOM_refresh(item, false);
		}
		DOFREE(itemType);
		POM_AM__set_application_bypass(FALSE);
	}
	messageUserValues.clear();
	vector<char *>().swap(messageUserValues);
	tc_root_file = NULL;
	pref_vals = NULL;
	if (ifail == 1)
	{
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, strResult.c_str());
	}
	printf("=========================TCM User BOM·SAP End===================\n");
	return ifail;
}

void getTCMUserBomLineReplaceItem(tag_t topLine, vector<tag_t> &bomLine)
{
	int  count;
	tag_t *children_line;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		char * replaceProject = NULL;
		AOM_ask_value_string(children_line[i], "ML8_ProjectTeam", &replaceProject);
		printf("ML8_ProjectTeam%s===================\n", replaceProject);
		if (replaceProject != NULL && strcmp(replaceProject, "A0") == 0)
		{
			bomLine.push_back(children_line[i]);
		}
		DOFREE(replaceProject);
	}
	DOFREE(children_line);
}

void getTCMUserItemJson(int index,tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000])
{

	/*if (isUserBomStart)
	{
		strcat(parameters, "{");
	}
	else
	{
		strcat(parameters, ",{");
	}*/
	//ȡ
	char * matnr = NULL;//ϱ
	char * werks = NULL;//
	char * lineCode = NULL;//ߴ,BOM汾Ϊߴż1λˮ
	char * bomusage = "1";//BOM;
	char * alternative = NULL;//BOM汾
	char * validdate = "20200101";//Ч
	char * description = NULL;//ѡBOMı
	char * basequan = "1000";//

	tag_t revisions = NULLTAG;

	AOM_ask_value_tag(topLine, "bl_line_object", &revisions);

	char * puid = NULL;
	//ȡPUID
	ITK__convert_tag_to_uid(revisions, &puid);

	AOM_ask_value_string(topLine, "bl_item_item_id", &matnr);
	if (strstr(matnr, "-") != NULL)
	{
		//,в֡
		int matnrCount = 0;
		char ** matnrChar = new char *[64];
		//ַָ
		split(matnr, "-", matnrChar, &matnrCount);

		matnr = matnrChar[0];
	}
	AOM_ask_value_string(revisions, "ml8_Factory", &werks);
	AOM_ask_value_string(revisions, "ml8_LineCode", &lineCode);
	if (index > -1)
	{
		char itc[10];
		_itoa(index, itc, 10);
		alternative = itc;
	}
	else
	{
		alternative = "1";
		//AOM_ask_value_string(revisions, "ml8_SAPBOMRevision", &alternative);
	}
	AOM_ask_value_string(topLine, "bl_item_object_name", &description);
	AOM_ask_value_string(revisions, "ml8_BOMBasicQuantity", &basequan);


	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	strcat(parameters, "<DATA>");
	strcat(parameters, "<MSG_HDR>");
	strcat(parameters, "<MSGID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</MSGID>");
	strcat(parameters, "<BUSID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</BUSID>");
	strcat(parameters, "<TLGID>");
	strcat(parameters, "JT0001");
	strcat(parameters, "</TLGID>");
	strcat(parameters, "<TLGNAME>");
	strcat(parameters, "άMOBMӿ");
	strcat(parameters, "</TLGNAME>");
	strcat(parameters, "<DTSEND>");
	strcat(parameters, date);
	strcat(parameters, "</DTSEND>");
	strcat(parameters, "<SENDER>");
	strcat(parameters, "TCM");
	strcat(parameters, "</SENDER>");
	strcat(parameters, "<RECEIVER>");
	strcat(parameters, "SAP");
	strcat(parameters, "</RECEIVER>");
	strcat(parameters, "<FREEUSE>");
	strcat(parameters, matnr);
	strcat(parameters, "</FREEUSE>");
	strcat(parameters, "</MSG_HDR>");
	strcat(parameters, "<MSG_BODY>");
	strcat(parameters, "<HEADER>");
	strcat(parameters, "<MATNR>");
	strcat(parameters, matnr);
	strcat(parameters, "</MATNR>");
	strcat(parameters, "<WERKS>");
	strcat(parameters, werks);
	strcat(parameters, "</WERKS>");
	strcat(parameters, "<STLAN>");
	strcat(parameters, bomusage);
	strcat(parameters, "</STLAN>");
	strcat(parameters, "<STLAL>");
	strcat(parameters, lineCode);
	strcat(parameters, alternative);
	strcat(parameters, "</STLAL>");
	strcat(parameters, "<BMENG>");
	strcat(parameters, basequan);
	strcat(parameters, "</BMENG>");
	strcat(parameters, "<DATUV>");
	strcat(parameters, validdate);
	strcat(parameters, "</DATUV>");
	strcat(parameters, "<STKTX>");
	strcat(parameters, description);
	strcat(parameters, "</STKTX>");
	strcat(parameters, "<UID>");
	strcat(parameters, puid);
	strcat(parameters, "</UID>");
	strcat(parameters, "</HEADER>");

	getTCMUserBomLineProperty(topLine, BomLine, typePropertyType, basequan, parameters);


	strcat(parameters, "</MSG_BODY>");
	strcat(parameters, "</DATA>");

	DOFREE(matnr);
	DOFREE(werks);
	DOFREE(bomusage);
	DOFREE(alternative);
	DOFREE(validdate);
	DOFREE(description);
	DOFREE(basequan);
	DOFREE(puid);
}

void getTCMUserBomLineChildProperty(tag_t topLine, map<string, string> typePropertyType, char parameters[100000])
{
	int  count;
	tag_t *children_line = NULLTAG;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		int  childCount;
		tag_t *children_bomLine = NULLTAG;

		BOM_line_ask_all_child_lines(children_line[i], &childCount, &children_bomLine);
		if (childCount > 0)
		{
			tag_t revisions = NULLTAG;

			AOM_ask_value_tag(children_line[i], "bl_line_object", &revisions);

			getTCMUserItemBomProperty(revisions, typePropertyType, parameters);
		}
		DOFREE(children_bomLine);
	}

	DOFREE(children_line);
}

void getTCMUserBomLineProperty(tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char * bomBaseNum, char parameters[100000])
{
	//char parameters[100000] = "";//д뵽ļֵ
	bool isStart = true;
	int  count;
	tag_t *children_line = NULLTAG;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		char * replaceProject = NULL;
		AOM_ask_value_string(children_line[i], "ML8_ProjectTeam", &replaceProject);

		if (replaceProject != NULL && strcmp(replaceProject, "A0") == 0 && BomLine != NULLTAG)
		{
			//жǷڴBOM
			char * itemId = NULL;
			AOM_ask_value_string(children_line[i], "bl_item_item_id", &itemId);
			char * inputItemId = NULL;
			AOM_ask_value_string(BomLine, "bl_item_item_id", &inputItemId);
			if (strcmp(itemId, inputItemId) != 0)
			{
				continue;
			}
		}

		char *itemType = NULL;
		AOM_ask_value_string(children_line[i], "fnd0bl_line_object_type", &itemType);
		char * puid = NULL;
		//ȡPUID
		ITK__convert_tag_to_uid(children_line[i], &puid);
		//˵ǰ汾Ķ
		string propertyNames = typePropertyType[itemType];
		if (propertyNames.c_str() != NULL)
		{
			/*if (isStart)
			{
				strcat(parameters, "{");
				isStart = false;
			}
			else
			{
				strcat(parameters, ",{");
			}*/

			const char * constName = propertyNames.c_str();
			char* name = new char[2048];//㹻
			strcpy(name, constName);

			if (strstr(name, ",") != NULL)
			{
				//,в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, ",", valueChar, &valueCount);

				strcat(parameters, "<ITEM>");
				for (int k = 0; k < valueCount; k++)
				{
					if (strstr(valueChar[k], "=") != NULL)
					{
						//-в֡
						int valueNum = 0;
						char ** values = new char *[64];
						//ַָ
						split(valueChar[k], "=", values, &valueNum);


						strcat(parameters, "<");
						strcat(parameters, values[1]);
						strcat(parameters, ">");

						char * item_rev_value = NULL;
						TCGetPropertyValue(children_line[i], "BOMLine", values[0], &item_rev_value);
						if (strcmp(values[1], "POSNR") == 0)
						{
							char itc[10];
							sprintf(itc, "%d", i);
							item_rev_value = itc;
						}



						strcat(parameters, item_rev_value);


						strcat(parameters, "</");
						strcat(parameters, values[1]);
						strcat(parameters, ">");


						DOFREE(item_rev_value);
					}
				}

				strcat(parameters, "</ITEM>");
			}
			else
			{
				//-в֡
				int valueCount = 0;
				char ** valueChar = new char *[64];
				//ַָ
				split(name, "=", valueChar, &valueCount);


				strcat(parameters, "<ITEM>");

				strcat(parameters, "<");
				strcat(parameters, valueChar[1]);
				strcat(parameters, ">");

				char * item_rev_value = NULL;
				TCGetPropertyValue(children_line[i], "BOMLine", valueChar[0], &item_rev_value);

				if (strcmp(valueChar[1], "POSNR") == 0)
				{
					char itc[10];
					sprintf(itc, "%d", i);
					item_rev_value = itc;
				}

				strcat(parameters, item_rev_value);

				strcat(parameters, "</");
				strcat(parameters, valueChar[1]);
				strcat(parameters, ">");

				strcat(parameters, "</ITEM>");

				DOFREE(item_rev_value);
			}

			DOFREE(constName);
		}


		DOFREE(replaceProject);
		DOFREE(itemType);
		DOFREE(puid);
	}

	DOFREE(children_line);
}