
#include <server_exits/user_server_exits.h>
#include <epm/epm.h>


#include <time.h>
#include <bom/bom_msg.h>
#include <tccore/item_msg.h>
#include <vector>
#include <string.h>
/**
* @headerfile			user's header files
*/
#include "epm_register_handler.h"
#include "epm_handler_common.h"

using namespace std;

// Method and Workflow Handler
extern DLLAPI int CUST_init_module(int *decision, va_list args)
{
	int ifail = ITK_ok;
	METHOD_id_t mth_tag;

	//жӼǷȫ
	ifail = EPM_register_action_handler("ML_ChildIsRelease", "ML_ChildIsRelease",
		(EPM_action_handler_t)ML_ChildIsRelease);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChildIsRelease completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChildIsRelease failed %d!\n", ifail);
	}
	//̽ڵ㸺
	ifail = EPM_register_action_handler("ML_SetProcessNodeOwner", "ML_SetProcessNodeOwner",
		(EPM_action_handler_t)ML_SetProcessNodeOwner);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_SetProcessNodeOwner completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_SetProcessNodeOwner failed %d!\n", ifail);
	}
	//Զ
	ifail = EPM_register_action_handler("ML_CreateSumProcess", "ML_CreateSumProcess",
		(EPM_action_handler_t)ML_CreateSumProcess);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_CreateSumProcess completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_CreateSumProcess failed %d!\n", ifail);
	}
	//жǷάݼ
	ifail = EPM_register_action_handler("ML_HaveDataSet", "ML_HaveDataSet",
		(EPM_action_handler_t)ML_HaveDataSet);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_HaveDataSet completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_HaveDataSet failed %d!\n", ifail);
	}
	//ɾʱ
	ifail = EPM_register_action_handler("Cut_ScheduleTask", "Cut_ScheduleTask",
		(EPM_action_handler_t)Cut_ScheduleTask);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler Cut_ScheduleTask completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler Cut_ScheduleTask failed %d!\n", ifail);
	}
	//ǷBOM
	ifail = EPM_register_action_handler("ML_HaveBomLine", "ML_HaveBomLine",
		(EPM_action_handler_t)ML_HaveBomLine);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_HaveBomLine completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_HaveBomLine failed %d!\n", ifail);
	}
	//ӵĿ
	ifail = EPM_register_action_handler("ML_AddItemToAttachments", "ML_AddItemToAttachments",
		(EPM_action_handler_t)ML_AddItemToAttachments);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_AddItemToAttachments completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_AddItemToAttachments failed %d!\n", ifail);
	}
	//Ķ
	ifail = EPM_register_action_handler("ML_ChangOwning", "ML_ChangOwning",
		(EPM_action_handler_t)ML_ChangOwning);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChangOwning completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChangOwning failed %d!\n", ifail);
	}
	//ı
	ifail = EPM_register_action_handler("ML_ChangeFormProperty", "ML_ChangeFormProperty",
		(EPM_action_handler_t)ML_ChangeFormProperty);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChangeFormProperty completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChangeFormProperty failed %d!\n", ifail);
	}
	//ƶָļ
	ifail = EPM_register_action_handler("ML_ChangeItemFolder", "ML_ChangeItemFolder",
		(EPM_action_handler_t)ML_ChangeItemFolder);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChangeItemFolder completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChangeItemFolder failed %d!\n", ifail);
	}
	//Ƴļж
	ifail = EPM_register_action_handler("ML_RemoveFolderItem", "ML_RemoveFolderItem",
		(EPM_action_handler_t)ML_RemoveFolderItem);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_RemoveFolderItem completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_RemoveFolderItem failed %d!\n", ifail);
	}
	//״̬
	ifail = EPM_register_action_handler("ML_ChangeStatus", "ML_ChangeStatus",
		(EPM_action_handler_t)ML_ChangeStatus);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChangeStatus completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChangeStatus failed %d!\n", ifail);
	}
	//FormĿ
	ifail = EPM_register_action_handler("ML_AddFormToAttachments", "ML_AddFormToAttachments",
		(EPM_action_handler_t)ML_AddFormToAttachments);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_AddFormToAttachments completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_AddFormToAttachments failed %d!\n", ifail);
	}
	//̲˾
	ifail = EPM_register_action_handler("ML_ElevateTask", "ML_ElevateTask",
		(EPM_action_handler_t)ML_ElevateTask);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ElevateTask completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ElevateTask failed %d!\n", ifail);
	}
	//жϹϵǷͬ
	ifail = EPM_register_action_handler("ML_ReferencedIsHaveItem", "ML_ReferencedIsHaveItem",
		(EPM_action_handler_t)ML_ReferencedIsHaveItem);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ReferencedIsHaveItem completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ReferencedIsHaveItem failed %d!\n", ifail);
	}
	//ͬ
	ifail = EPM_register_action_handler("ML_ChangeObjectDesc", "ML_ChangeObjectDesc",
		(EPM_action_handler_t)ML_ChangeObjectDesc);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChangeObjectDesc completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChangeObjectDesc failed %d!\n", ifail);
	}
	//Ƿ񳬹40ַ
	ifail = EPM_register_action_handler("ML_CheckCharLenth", "ML_CheckCharLenth",
		(EPM_action_handler_t)ML_CheckCharLenth);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_CheckCharLenth completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_CheckCharLenth failed %d!\n", ifail);
	}
	//Ƿ񳬹40ַ
	ifail = EPM_register_action_handler("ML_CheckCharLenthMessage", "ML_CheckCharLenthMessage",
		(EPM_action_handler_t)ML_CheckCharLenthMessage);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_CheckCharLenthMessage completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_CheckCharLenthMessage failed %d!\n", ifail);
	}
	//·SAP
	ifail = EPM_register_action_handler("ML_SendSapItem", "ML_SendSapItem",
		(EPM_action_handler_t)ML_SendSapItem);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_SendSapItem completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_SendSapItem failed %d!\n", ifail);
	}
	//BOM·SAP
	ifail = EPM_register_action_handler("ML_SendSapBom", "ML_SendSapBom",
		(EPM_action_handler_t)ML_SendSapBom);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_SendSapBom completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_SendSapBom failed %d!\n", ifail);
	}
	//жļ¶Ƿ񷢲
	ifail = EPM_register_action_handler("ML_ItemIsRelease", "ML_ItemIsRelease",
		(EPM_action_handler_t)ML_ItemIsRelease);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ItemIsRelease completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ItemIsRelease failed %d!\n", ifail);
	}
	//ʱ
	ifail = EPM_register_action_handler("ML_SetScheduleTaskProperty", "ML_SetScheduleTaskProperty",
		(EPM_action_handler_t)ML_SetScheduleTaskProperty);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_SetScheduleTaskProperty completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_SetScheduleTaskProperty failed %d!\n", ifail);
	}
	//δƶĿ
	ifail = EPM_register_action_handler("ML_AddReleaseItemToAttachments", "ML_AddReleaseItemToAttachments",
		(EPM_action_handler_t)ML_AddReleaseItemToAttachments);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_AddReleaseItemToAttachments completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_AddReleaseItemToAttachments failed %d!\n", ifail);
	}
	//жǷΪ
	ifail = EPM_register_rule_handler("Judge_attribute", "Judge_attribute", (EPM_rule_handler_t)Judge_attribute);
	if (ifail == 0) {
		printf("Registering rule handler Judge_attribute successful\n");
	}
	else {
		printf("Registering rule handler Judge_attribute failed %d\n", ifail);
	}
	//ǷPDF
	ifail = EPM_register_action_handler("ML_ItemIsHavePDF", "ML_ItemIsHavePDF",
		(EPM_action_handler_t)ML_ItemIsHavePDF);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ItemIsHavePDF completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ItemIsHavePDF failed %d!\n", ifail);
	}
	//BOMͼ
	ifail = EPM_register_action_handler("ML_CreateBomView", "ML_CreateBomView",
		(EPM_action_handler_t)ML_CreateBomView);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_CreateBomView completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_CreateBomView failed %d!\n", ifail);
	}

	//TCM·BOMSAP
	ifail = EPM_register_action_handler("ML_TCMSendSapBomMonolayer", "ML_TCMSendSapBomMonolayer",
		(EPM_action_handler_t)ML_TCMSendSapBomMonolayer);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapBomMonolayer completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapBomMonolayer failed %d!\n", ifail);
	}
	//TCM·BOMSAP
	ifail = EPM_register_action_handler("ML_TCMSendSapBom", "ML_TCMSendSapBom",
		(EPM_action_handler_t)ML_TCMSendSapBom);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapBom completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapBom failed %d!\n", ifail);
	}
	//TCM·MBOMSAP
	ifail = EPM_register_action_handler("ML_TCMSendSapMBom", "ML_TCMSendSapMBom",
		(EPM_action_handler_t)ML_TCMSendSapMBom);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapMBom completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapMBom failed %d!\n", ifail);
	}
	//TCM·мSAP
	ifail = EPM_register_action_handler("ML_TCMSendSapItem", "ML_TCMSendSapItem",
		(EPM_action_handler_t)ML_TCMSendSapItem);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapItem completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapItem failed %d!\n", ifail);
	}
	//TCM·ɱռSAP
	ifail = EPM_register_action_handler("ML_TCMSendSapCostCollector", "ML_TCMSendSapCostCollector",
		(EPM_action_handler_t)ML_TCMSendSapCostCollector);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapCostCollector completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSapCostCollector failed %d!\n", ifail);
	}
	//λBOM·MES
	ifail = EPM_register_action_handler("ML_TCMSendMesBom", "ML_TCMSendMesBom",
		(EPM_action_handler_t)ML_TCMSendMesBom);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesBom completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesBom failed %d!\n", ifail);
	}
	//λSOP·MES
	ifail = EPM_register_action_handler("ML_TCMSendMesSop", "ML_TCMSendMesSop",
		(EPM_action_handler_t)ML_TCMSendMesSop);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesSop completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesSop failed %d!\n", ifail);
	}
	//BOMSRMϵͳ
	ifail = EPM_register_action_handler("ML_TCMSendSrmBom", "ML_TCMSendSrmBom",
		(EPM_action_handler_t)ML_TCMSendSrmBom);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSrmBom completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendSrmBom failed %d!\n", ifail);
	}
	//רղ·MES
	ifail = EPM_register_action_handler("ML_TCMSendMesSpecialProcess", "ML_TCMSendMesSpecialProcess",
		(EPM_action_handler_t)ML_TCMSendMesSpecialProcess);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesSpecialProcess completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_TCMSendMesSpecialProcess failed %d!\n", ifail);
	}
	//жӼ
	ifail = EPM_register_action_handler("ML_ChildGeneralIdentify", "ML_ChildGeneralIdentify",
		(EPM_action_handler_t)ML_ChildGeneralIdentify);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ChildGeneralIdentify completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ChildGeneralIdentify failed %d!\n", ifail);
	}
	//жǷظ
	ifail = EPM_register_action_handler("ML_CheckObjectDesc", "ML_CheckObjectDesc",
		(EPM_action_handler_t)ML_CheckObjectDesc);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_CheckObjectDesc completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_CheckObjectDesc failed %d!\n", ifail);
	}
	//жļ¶ӼǷ񶳽
	ifail = EPM_register_action_handler("ML_ItemChildIsRelease", "ML_ItemChildIsRelease",
		(EPM_action_handler_t)ML_ItemChildIsRelease);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ItemChildIsRelease completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ItemChildIsRelease failed %d!\n", ifail);
	}
	//жļ¶ĸǷ񶳽
	ifail = EPM_register_action_handler("ML_ItemParentIsRelease", "ML_ItemParentIsRelease",
		(EPM_action_handler_t)ML_ItemParentIsRelease);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_ItemParentIsRelease completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_ItemParentIsRelease failed %d!\n", ifail);
	}
	
	//
	ifail = EPM_register_action_handler("ML_Test", "ML_Test",
		(EPM_action_handler_t)ML_Test);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_Test completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_Test failed %d!\n", ifail);
	}

	//MBOMУ
	ifail = EPM_register_action_handler("ML_CheckMBOM", "ML_CheckMBOM", (EPM_action_handler_t)ML_CheckMBOM);
	if (ifail == 0) {
		printf("Registering action handler ML_CheckMBOM successful\n");
	}
	else {
		printf("Registering action handler ML_CheckMBOM failed %d\n", ifail);
	}
	//ж
	ifail = EPM_register_action_handler("ML_ChideIsEnabled", "ML_ChideIsEnabled", (EPM_action_handler_t)ML_ChideIsEnabled);
	if (ifail == 0) {
		printf("Registering action handler ML_ChideIsEnabled successful\n");
	}
	else {
		printf("Registering action handler ML_ChideIsEnabled failed %d\n", ifail);
	}
	//BOM·SAP tcm
	ifail = EPM_register_action_handler("ML_SendSapBom_TCM", "ML_SendSapBom_TCM",
		(EPM_action_handler_t)ML_SendSapBom_TCM);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_SendSapBom_TCM completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_SendSapBom_TCM failed %d!\n", ifail);
	}

	//жߵ·
	ifail = EPM_register_action_handler("ML_Check_Route", "ML_Check_Route",
		(EPM_action_handler_t)ML_Check_Route);
	if (ifail == ITK_ok)
	{
		fprintf(stdout, "Registering action handler ML_Check_Route completed!\n");
	}
	else
	{
		fprintf(stdout, "Registering action handler ML_Check_Route failed %d!\n", ifail);
	}

	//20240702ȡע ܿ
	ifail = METHOD_find_method("ItemRevision", ITEM_deep_copy_msg, &mth_tag);
	if (mth_tag.id != 0) {
		METHOD_add_action(mth_tag, METHOD_pre_action_type, ML_ItemRevPreUpdate, NULL);
		printf("עItemRevisionɹ\n");
	}

	ifail = METHOD_find_method("ItemRevision", ITEM_copy_rev_msg, &mth_tag);
	if (mth_tag.id != 0) {
		METHOD_add_action(mth_tag, METHOD_post_action_type, ML_ItemRevUpdate, NULL);
		printf("עItemRevisionɹ\n");
	}

	//20250307 - ѡļĿΪĶļԶָĿ
	/*ifail = METHOD_find_method("ItemRevision", ITEM_create_rev_msg, &mth_tag);
	if (mth_tag.id != 0) {
		METHOD_add_action(mth_tag, METHOD_post_action_type, ML_Automatic_Assignment_Item, NULL);
		printf("עML_Automatic_Assignment_Item0ɹ\n");
	}
	else
	{
		printf("עML_Automatic_Assignment_Item0ʧܣ\n");
	}*/
	/*ifail = METHOD_find_method("Item", ITEM_create_msg, &mth_tag);
	if (mth_tag.id != 0) {
		METHOD_add_action(mth_tag, METHOD_post_action_type, ML_Automatic_Assignment_Item, NULL);
		printf("עML_Automatic_Assignment_Item1ɹ\n");
	}
	else
	{
		printf("עML_Automatic_Assignment_Item1ʧܣ\n");
	}*/
	/*ifail = METHOD_find_method("Folder", ITEM_create_msg, &mth_tag);
    if (mth_tag.id != 0) {
        METHOD_add_action(mth_tag, METHOD_post_action_type, ML_Automatic_Assignment_Item, NULL);
        printf("עML_Automatic_Assignment_Item2ɹ\n");
	}
	else
	{
		printf("עML_Automatic_Assignment_Item2ʧܣ\n");
	}*/



	METHOD_id_t mth2_tag;
	//ifail = METHOD_find_method("ItemRevision", PROP_set_value_tags_msg, &mth_tag);
	ITKCALL(METHOD_find_prop_method("ML8_DesignRevision", "representation_for", PROP_set_value_tags_msg, &mth2_tag));
	if (mth2_tag.id != 0) {
		METHOD_add_action(mth2_tag, METHOD_pre_action_type, ML_DesignPartCopy, NULL);
		printf("עDesign-Partɹ\n");
	}

	return ifail;
}
//
////register service method
extern DLLAPI int USERSERVICE_custom_register_methods()
{
	int
		status = ITK_ok,
		numberOfArguments = 0,
		returnValueType = USERARG_STRING_TYPE,
		*argumentList = NULL;
	USER_function_t functionPtr;

	METHOD_id_t mth_tag;

	

	//涨javaҪݹĸ
	numberOfArguments = 1;
	//Ҫõĺַַ
	functionPtr = ORIGIN_set_bypass;
	//javaҪݵĲ
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_STRING_TYPE;
	//巵ֵ
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ORIGIN_set_bypass", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ORIGIN_set_bypass finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ORIGIN_set_bypass failed %d\n", status);
	}


	//===========================================

	numberOfArguments = 1;
	functionPtr = ORIGIN_close_bypass;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ORIGIN_close_bypass", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ORIGIN_close_bypass finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ORIGIN_close_bypass failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 3;
	functionPtr = connor_set_prop_value;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE + USERARG_ARRAY_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	argumentList[2] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("connor_set_prop_value", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering connor_set_prop_value finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering connor_set_prop_value failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 2;
	functionPtr = ML_TCMUserSendSapBom;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ML_TCMUserSendSapBom", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendSapBom finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendSapBom failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 2;
	functionPtr = ML_TCMUserSendSapCostCollector;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ML_TCMUserSendSapCostCollector", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendSapCostCollector finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendSapCostCollector failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 2;
	functionPtr = ML_TCMUserSendMesBom;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ML_TCMUserSendMesBom", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesBom finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesBom failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 2;
	functionPtr = ML_TCMUserSendMesSop;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ML_TCMUserSendMesSop", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesSop finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesSop failed %d\n", status);
	}

	//===========================================

	numberOfArguments = 2;
	functionPtr = ML_TCMUserSendMesSpecialProcess;
	argumentList = (int*)MEM_alloc(numberOfArguments * sizeof(int));
	argumentList[0] = USERARG_TAG_TYPE;
	argumentList[1] = USERARG_STRING_TYPE;
	//argumentList[1] = USERARG_STRING_TYPE + USERARG_ARRAY_TYPE;
	//returnValueType = USERARG_STRING_TYPE;
	returnValueType = USERARG_VOID_TYPE;
	status = USERSERVICE_register_method("ML_TCMUserSendMesSpecialProcess", functionPtr, numberOfArguments,
		argumentList, returnValueType);
	MEM_free(argumentList);
	if (status == ITK_ok)
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesSpecialProcess finished\n");
	}
	else
	{
		fprintf(stdout, "\n Registering ML_TCMUserSendMesSpecialProcess failed %d\n", status);
	}
	
	//===========================================

	/*METHOD_find_method("ScheduleTask", ITEM_create_msg, &mth_tag);
	if (mth_tag.id)
	{
		status = METHOD_add_action(mth_tag, METHOD_post_action_type, (METHOD_function_t)ML_Test, NULL);
		if (status == ITK_ok)
		{
			printf("register  wx3_tzcpxh_check successfully\n ");
		}
		else
		{
			printf("register wx3_tzcpxh_check failed\n ");
		}

	}*/

	//===========================================

	return(status);
}


