//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Att0attrtargetmgmt

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libAtt0attrtargetmgmt

#if !defined(LIBATT0ATTRTARGETMGMT) && !defined(IPLIB)
#   error IPLIB or LIBATT0ATTRTARGETMGMT is not defined
#endif

/* Handwritten code should use ATT0ATTRTARGETMGMT_API, not ATT0ATTRTARGETMGMTEXPORT */

#define ATT0ATTRTARGETMGMT_API ATT0ATTRTARGETMGMTEXPORT

#if IPLIB==libAtt0attrtargetmgmt || defined(LIBATT0ATTRTARGETMGMT)
#   if defined(__lint)
#       define ATT0ATTRTARGETMGMTEXPORT       __export(Att0attrtargetmgmt)
#       define ATT0ATTRTARGETMGMTGLOBAL       extern __global(Att0attrtargetmgmt)
#       define ATT0ATTRTARGETMGMTPRIVATE      extern __private(Att0attrtargetmgmt)
#   elif defined(_WIN32)
#       define ATT0ATTRTARGETMGMTEXPORT       __declspec(dllexport)
#       define ATT0ATTRTARGETMGMTGLOBAL       extern __declspec(dllexport)
#       define ATT0ATTRTARGETMGMTPRIVATE      extern
#   else
#       define ATT0ATTRTARGETMGMTEXPORT
#       define ATT0ATTRTARGETMGMTGLOBAL       extern
#       define ATT0ATTRTARGETMGMTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ATT0ATTRTARGETMGMTEXPORT       __export(Att0attrtargetmgmt)
#       define ATT0ATTRTARGETMGMTGLOBAL       extern __global(Att0attrtargetmgmt)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ATT0ATTRTARGETMGMTEXPORT      __declspec(dllimport)
#       define ATT0ATTRTARGETMGMTGLOBAL       extern __declspec(dllimport)
#   else
#       define ATT0ATTRTARGETMGMTEXPORT
#       define ATT0ATTRTARGETMGMTGLOBAL       extern
#   endif
#endif
