//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Clr0colorappearance

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libClr0colorappearance

#if !defined(LIBCLR0COLORAPPEARANCE) && !defined(IPLIB)
#   error IPLIB or LIBCLR0COLORAPPEARANCE is not defined
#endif

/* Handwritten code should use CLR0COLORAPPEARANCE_API, not CLR0COLORAPPEARANCEEXPORT */

#define CLR0COLORAPPEARANCE_API CLR0COLORAPPEARANCEEXPORT

#if IPLIB==libClr0colorappearance || defined(LIBCLR0COLORAPPEARANCE)
#   if defined(__lint)
#       define CLR0COLORAPPEARANCEEXPORT       __export(Clr0colorappearance)
#       define CLR0COLORAPPEARANCEGLOBAL       extern __global(Clr0colorappearance)
#       define CLR0COLORAPPEARANCEPRIVATE      extern __private(Clr0colorappearance)
#   elif defined(_WIN32)
#       define CLR0COLORAPPEARANCEEXPORT       __declspec(dllexport)
#       define CLR0COLORAPPEARANCEGLOBAL       extern __declspec(dllexport)
#       define CLR0COLORAPPEARANCEPRIVATE      extern
#   else
#       define CLR0COLORAPPEARANCEEXPORT
#       define CLR0COLORAPPEARANCEGLOBAL       extern
#       define CLR0COLORAPPEARANCEPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CLR0COLORAPPEARANCEEXPORT       __export(Clr0colorappearance)
#       define CLR0COLORAPPEARANCEGLOBAL       extern __global(Clr0colorappearance)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CLR0COLORAPPEARANCEEXPORT      __declspec(dllimport)
#       define CLR0COLORAPPEARANCEGLOBAL       extern __declspec(dllimport)
#   else
#       define CLR0COLORAPPEARANCEEXPORT
#       define CLR0COLORAPPEARANCEGLOBAL       extern
#   endif
#endif
