//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Fnd0FastenerMgmtBvr

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libFnd0FastenerMgmtBvr

#if !defined(LIBFND0FASTENERMGMTBVR) && !defined(IPLIB)
#   error IPLIB or LIBFND0FASTENERMGMTBVR is not defined
#endif

/* Handwritten code should use FND0FASTENERMGMTBVR_API, not FND0FASTENERMGMTBVREXPORT */

#define FND0FASTENERMGMTBVR_API FND0FASTENERMGMTBVREXPORT

#if IPLIB==libFnd0FastenerMgmtBvr || defined(LIBFND0FASTENERMGMTBVR)
#   if defined(__lint)
#       define FND0FASTENERMGMTBVREXPORT       __export(Fnd0FastenerMgmtBvr)
#       define FND0FASTENERMGMTBVRGLOBAL       extern __global(Fnd0FastenerMgmtBvr)
#       define FND0FASTENERMGMTBVRPRIVATE      extern __private(Fnd0FastenerMgmtBvr)
#   elif defined(_WIN32)
#       define FND0FASTENERMGMTBVREXPORT       __declspec(dllexport)
#       define FND0FASTENERMGMTBVRGLOBAL       extern __declspec(dllexport)
#       define FND0FASTENERMGMTBVRPRIVATE      extern
#   else
#       define FND0FASTENERMGMTBVREXPORT
#       define FND0FASTENERMGMTBVRGLOBAL       extern
#       define FND0FASTENERMGMTBVRPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define FND0FASTENERMGMTBVREXPORT       __export(Fnd0FastenerMgmtBvr)
#       define FND0FASTENERMGMTBVRGLOBAL       extern __global(Fnd0FastenerMgmtBvr)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define FND0FASTENERMGMTBVREXPORT      __declspec(dllimport)
#       define FND0FASTENERMGMTBVRGLOBAL       extern __declspec(dllimport)
#   else
#       define FND0FASTENERMGMTBVREXPORT
#       define FND0FASTENERMGMTBVRGLOBAL       extern
#   endif
#endif
