//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  Lis0lisfmwrk

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libLis0lisfmwrk

#if !defined(LIBLIS0LISFMWRK) && !defined(IPLIB)
#   error IPLIB or LIBLIS0LISFMWRK is not defined
#endif

/* Handwritten code should use LIS0LISFMWRK_API, not LIS0LISFMWRKEXPORT */

#define LIS0LISFMWRK_API LIS0LISFMWRKEXPORT

#if IPLIB==libLis0lisfmwrk || defined(LIBLIS0LISFMWRK)
#   if defined(__lint)
#       define LIS0LISFMWRKEXPORT       __export(Lis0lisfmwrk)
#       define LIS0LISFMWRKGLOBAL       extern __global(Lis0lisfmwrk)
#       define LIS0LISFMWRKPRIVATE      extern __private(Lis0lisfmwrk)
#   elif defined(_WIN32)
#       define LIS0LISFMWRKEXPORT       __declspec(dllexport)
#       define LIS0LISFMWRKGLOBAL       extern __declspec(dllexport)
#       define LIS0LISFMWRKPRIVATE      extern
#   else
#       define LIS0LISFMWRKEXPORT
#       define LIS0LISFMWRKGLOBAL       extern
#       define LIS0LISFMWRKPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LIS0LISFMWRKEXPORT       __export(Lis0lisfmwrk)
#       define LIS0LISFMWRKGLOBAL       extern __global(Lis0lisfmwrk)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LIS0LISFMWRKEXPORT      __declspec(dllimport)
#       define LIS0LISFMWRKGLOBAL       extern __declspec(dllimport)
#   else
#       define LIS0LISFMWRKEXPORT
#       define LIS0LISFMWRKGLOBAL       extern
#   endif
#endif
