//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  aed0automationelectricdesigndispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libaed0automationelectricdesigndispatch

#if !defined(LIBAED0AUTOMATIONELECTRICDESIGNDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBAED0AUTOMATIONELECTRICDESIGNDISPATCH is not defined
#endif

/* Handwritten code should use AED0AUTOMATIONELECTRICDESIGNDISPATCH_API, not AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT */

#define AED0AUTOMATIONELECTRICDESIGNDISPATCH_API AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT

#if IPLIB==libaed0automationelectricdesigndispatch || defined(LIBAED0AUTOMATIONELECTRICDESIGNDISPATCH)
#   if defined(__lint)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT       __export(aed0automationelectricdesigndispatch)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern __global(aed0automationelectricdesigndispatch)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHPRIVATE      extern __private(aed0automationelectricdesigndispatch)
#   elif defined(_WIN32)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT       __declspec(dllexport)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern __declspec(dllexport)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHPRIVATE      extern
#   else
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT       __export(aed0automationelectricdesigndispatch)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern __global(aed0automationelectricdesigndispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT      __declspec(dllimport)
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHEXPORT
#       define AED0AUTOMATIONELECTRICDESIGNDISPATCHGLOBAL       extern
#   endif
#endif
