//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  att0attrtargetmgmtdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libatt0attrtargetmgmtdispatch

#if !defined(LIBATT0ATTRTARGETMGMTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBATT0ATTRTARGETMGMTDISPATCH is not defined
#endif

/* Handwritten code should use ATT0ATTRTARGETMGMTDISPATCH_API, not ATT0ATTRTARGETMGMTDISPATCHEXPORT */

#define ATT0ATTRTARGETMGMTDISPATCH_API ATT0ATTRTARGETMGMTDISPATCHEXPORT

#if IPLIB==libatt0attrtargetmgmtdispatch || defined(LIBATT0ATTRTARGETMGMTDISPATCH)
#   if defined(__lint)
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT       __export(att0attrtargetmgmtdispatch)
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern __global(att0attrtargetmgmtdispatch)
#       define ATT0ATTRTARGETMGMTDISPATCHPRIVATE      extern __private(att0attrtargetmgmtdispatch)
#   elif defined(_WIN32)
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT       __declspec(dllexport)
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define ATT0ATTRTARGETMGMTDISPATCHPRIVATE      extern
#   else
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern
#       define ATT0ATTRTARGETMGMTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT       __export(att0attrtargetmgmtdispatch)
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern __global(att0attrtargetmgmtdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT      __declspec(dllimport)
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define ATT0ATTRTARGETMGMTDISPATCHEXPORT
#       define ATT0ATTRTARGETMGMTDISPATCHGLOBAL       extern
#   endif
#endif
