// @< COPYRIGHT>@
// ==================================================
// Copyright 2013.
// Siemens Product Lifecycle Management Software Inc.
// All Rights Reserved.
// ==================================================
// @< COPYRIGHT>@

/**
   @file
   This is just a forward of STL shared pointer.  It was at one point a Teamcenter
   implementation of the shared_ptr but has since changed.
*/

#ifndef TEAMCENTER_BASE_UTILS_SHARED_PTR_HXX
#define TEAMCENTER_BASE_UTILS_SHARED_PTR_HXX

#include <memory>               // for std::auto_ptr
namespace Teamcenter
{
    using std::shared_ptr;
    using std::static_pointer_cast;
    using std::dynamic_pointer_cast;
    using std::const_pointer_cast;
}

#endif // TEAMCENTER_BASE_UTILS_SHARED_PTR_HXX
