//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  bhv0branchfoundation

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbhv0branchfoundation

#if !defined(LIBBHV0BRANCHFOUNDATION) && !defined(IPLIB)
#   error IPLIB or LIBBHV0BRANCHFOUNDATION is not defined
#endif

/* Handwritten code should use BHV0BRANCHFOUNDATION_API, not BHV0BRANCHFOUNDATIONEXPORT */

#define BHV0BRANCHFOUNDATION_API BHV0BRANCHFOUNDATIONEXPORT

#if IPLIB==libbhv0branchfoundation || defined(LIBBHV0BRANCHFOUNDATION)
#   if defined(__lint)
#       define BHV0BRANCHFOUNDATIONEXPORT       __export(bhv0branchfoundation)
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern __global(bhv0branchfoundation)
#       define BHV0BRANCHFOUNDATIONPRIVATE      extern __private(bhv0branchfoundation)
#   elif defined(_WIN32)
#       define BHV0BRANCHFOUNDATIONEXPORT       __declspec(dllexport)
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern __declspec(dllexport)
#       define BHV0BRANCHFOUNDATIONPRIVATE      extern
#   else
#       define BHV0BRANCHFOUNDATIONEXPORT
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern
#       define BHV0BRANCHFOUNDATIONPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BHV0BRANCHFOUNDATIONEXPORT       __export(bhv0branchfoundation)
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern __global(bhv0branchfoundation)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BHV0BRANCHFOUNDATIONEXPORT      __declspec(dllimport)
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern __declspec(dllimport)
#   else
#       define BHV0BRANCHFOUNDATIONEXPORT
#       define BHV0BRANCHFOUNDATIONGLOBAL       extern
#   endif
#endif
