//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  bhv0branchfoundationdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbhv0branchfoundationdispatch

#if !defined(LIBBHV0BRANCHFOUNDATIONDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBBHV0BRANCHFOUNDATIONDISPATCH is not defined
#endif

/* Handwritten code should use BHV0BRANCHFOUNDATIONDISPATCH_API, not BHV0BRANCHFOUNDATIONDISPATCHEXPORT */

#define BHV0BRANCHFOUNDATIONDISPATCH_API BHV0BRANCHFOUNDATIONDISPATCHEXPORT

#if IPLIB==libbhv0branchfoundationdispatch || defined(LIBBHV0BRANCHFOUNDATIONDISPATCH)
#   if defined(__lint)
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT       __export(bhv0branchfoundationdispatch)
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern __global(bhv0branchfoundationdispatch)
#       define BHV0BRANCHFOUNDATIONDISPATCHPRIVATE      extern __private(bhv0branchfoundationdispatch)
#   elif defined(_WIN32)
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT       __declspec(dllexport)
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern __declspec(dllexport)
#       define BHV0BRANCHFOUNDATIONDISPATCHPRIVATE      extern
#   else
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern
#       define BHV0BRANCHFOUNDATIONDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT       __export(bhv0branchfoundationdispatch)
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern __global(bhv0branchfoundationdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT      __declspec(dllimport)
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define BHV0BRANCHFOUNDATIONDISPATCHEXPORT
#       define BHV0BRANCHFOUNDATIONDISPATCHGLOBAL       extern
#   endif
#endif
