//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  bom0bommanagementdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libbom0bommanagementdispatch

#if !defined(LIBBOM0BOMMANAGEMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBBOM0BOMMANAGEMENTDISPATCH is not defined
#endif

/* Handwritten code should use BOM0BOMMANAGEMENTDISPATCH_API, not BOM0BOMMANAGEMENTDISPATCHEXPORT */

#define BOM0BOMMANAGEMENTDISPATCH_API BOM0BOMMANAGEMENTDISPATCHEXPORT

#if IPLIB==libbom0bommanagementdispatch || defined(LIBBOM0BOMMANAGEMENTDISPATCH)
#   if defined(__lint)
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT       __export(bom0bommanagementdispatch)
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern __global(bom0bommanagementdispatch)
#       define BOM0BOMMANAGEMENTDISPATCHPRIVATE      extern __private(bom0bommanagementdispatch)
#   elif defined(_WIN32)
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT       __declspec(dllexport)
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define BOM0BOMMANAGEMENTDISPATCHPRIVATE      extern
#   else
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern
#       define BOM0BOMMANAGEMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT       __export(bom0bommanagementdispatch)
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern __global(bom0bommanagementdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT      __declspec(dllimport)
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define BOM0BOMMANAGEMENTDISPATCHEXPORT
#       define BOM0BOMMANAGEMENTDISPATCHGLOBAL       extern
#   endif
#endif
