//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cip0controlinspplandispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcip0controlinspplandispatch

#if !defined(LIBCIP0CONTROLINSPPLANDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCIP0CONTROLINSPPLANDISPATCH is not defined
#endif

/* Handwritten code should use CIP0CONTROLINSPPLANDISPATCH_API, not CIP0CONTROLINSPPLANDISPATCHEXPORT */

#define CIP0CONTROLINSPPLANDISPATCH_API CIP0CONTROLINSPPLANDISPATCHEXPORT

#if IPLIB==libcip0controlinspplandispatch || defined(LIBCIP0CONTROLINSPPLANDISPATCH)
#   if defined(__lint)
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT       __export(cip0controlinspplandispatch)
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern __global(cip0controlinspplandispatch)
#       define CIP0CONTROLINSPPLANDISPATCHPRIVATE      extern __private(cip0controlinspplandispatch)
#   elif defined(_WIN32)
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT       __declspec(dllexport)
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CIP0CONTROLINSPPLANDISPATCHPRIVATE      extern
#   else
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern
#       define CIP0CONTROLINSPPLANDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT       __export(cip0controlinspplandispatch)
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern __global(cip0controlinspplandispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT      __declspec(dllimport)
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CIP0CONTROLINSPPLANDISPATCHEXPORT
#       define CIP0CONTROLINSPPLANDISPATCHGLOBAL       extern
#   endif
#endif
