//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  contmgmts1000ddispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcontmgmts1000ddispatch

#if !defined(LIBCONTMGMTS1000DDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCONTMGMTS1000DDISPATCH is not defined
#endif

/* Handwritten code should use CONTMGMTS1000DDISPATCH_API, not CONTMGMTS1000DDISPATCHEXPORT */

#define CONTMGMTS1000DDISPATCH_API CONTMGMTS1000DDISPATCHEXPORT

#if IPLIB==libcontmgmts1000ddispatch || defined(LIBCONTMGMTS1000DDISPATCH)
#   if defined(__lint)
#       define CONTMGMTS1000DDISPATCHEXPORT       __export(contmgmts1000ddispatch)
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern __global(contmgmts1000ddispatch)
#       define CONTMGMTS1000DDISPATCHPRIVATE      extern __private(contmgmts1000ddispatch)
#   elif defined(_WIN32)
#       define CONTMGMTS1000DDISPATCHEXPORT       __declspec(dllexport)
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CONTMGMTS1000DDISPATCHPRIVATE      extern
#   else
#       define CONTMGMTS1000DDISPATCHEXPORT
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern
#       define CONTMGMTS1000DDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CONTMGMTS1000DDISPATCHEXPORT       __export(contmgmts1000ddispatch)
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern __global(contmgmts1000ddispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CONTMGMTS1000DDISPATCHEXPORT      __declspec(dllimport)
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CONTMGMTS1000DDISPATCHEXPORT
#       define CONTMGMTS1000DDISPATCHGLOBAL       extern
#   endif
#endif
