//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  cpa0capadatamodeldispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcpa0capadatamodeldispatch

#if !defined(LIBCPA0CAPADATAMODELDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCPA0CAPADATAMODELDISPATCH is not defined
#endif

/* Handwritten code should use CPA0CAPADATAMODELDISPATCH_API, not CPA0CAPADATAMODELDISPATCHEXPORT */

#define CPA0CAPADATAMODELDISPATCH_API CPA0CAPADATAMODELDISPATCHEXPORT

#if IPLIB==libcpa0capadatamodeldispatch || defined(LIBCPA0CAPADATAMODELDISPATCH)
#   if defined(__lint)
#       define CPA0CAPADATAMODELDISPATCHEXPORT       __export(cpa0capadatamodeldispatch)
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern __global(cpa0capadatamodeldispatch)
#       define CPA0CAPADATAMODELDISPATCHPRIVATE      extern __private(cpa0capadatamodeldispatch)
#   elif defined(_WIN32)
#       define CPA0CAPADATAMODELDISPATCHEXPORT       __declspec(dllexport)
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CPA0CAPADATAMODELDISPATCHPRIVATE      extern
#   else
#       define CPA0CAPADATAMODELDISPATCHEXPORT
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern
#       define CPA0CAPADATAMODELDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CPA0CAPADATAMODELDISPATCHEXPORT       __export(cpa0capadatamodeldispatch)
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern __global(cpa0capadatamodeldispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CPA0CAPADATAMODELDISPATCHEXPORT      __declspec(dllimport)
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CPA0CAPADATAMODELDISPATCHEXPORT
#       define CPA0CAPADATAMODELDISPATCHGLOBAL       extern
#   endif
#endif
