//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  crt0validationcontractdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libcrt0validationcontractdispatch

#if !defined(LIBCRT0VALIDATIONCONTRACTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBCRT0VALIDATIONCONTRACTDISPATCH is not defined
#endif

/* Handwritten code should use CRT0VALIDATIONCONTRACTDISPATCH_API, not CRT0VALIDATIONCONTRACTDISPATCHEXPORT */

#define CRT0VALIDATIONCONTRACTDISPATCH_API CRT0VALIDATIONCONTRACTDISPATCHEXPORT

#if IPLIB==libcrt0validationcontractdispatch || defined(LIBCRT0VALIDATIONCONTRACTDISPATCH)
#   if defined(__lint)
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT       __export(crt0validationcontractdispatch)
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern __global(crt0validationcontractdispatch)
#       define CRT0VALIDATIONCONTRACTDISPATCHPRIVATE      extern __private(crt0validationcontractdispatch)
#   elif defined(_WIN32)
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT       __declspec(dllexport)
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define CRT0VALIDATIONCONTRACTDISPATCHPRIVATE      extern
#   else
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern
#       define CRT0VALIDATIONCONTRACTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT       __export(crt0validationcontractdispatch)
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern __global(crt0validationcontractdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT      __declspec(dllimport)
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define CRT0VALIDATIONCONTRACTDISPATCHEXPORT
#       define CRT0VALIDATIONCONTRACTDISPATCHGLOBAL       extern
#   endif
#endif
