//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  dia0diagrammingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libdia0diagrammingdispatch

#if !defined(LIBDIA0DIAGRAMMINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBDIA0DIAGRAMMINGDISPATCH is not defined
#endif

/* Handwritten code should use DIA0DIAGRAMMINGDISPATCH_API, not DIA0DIAGRAMMINGDISPATCHEXPORT */

#define DIA0DIAGRAMMINGDISPATCH_API DIA0DIAGRAMMINGDISPATCHEXPORT

#if IPLIB==libdia0diagrammingdispatch || defined(LIBDIA0DIAGRAMMINGDISPATCH)
#   if defined(__lint)
#       define DIA0DIAGRAMMINGDISPATCHEXPORT       __export(dia0diagrammingdispatch)
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern __global(dia0diagrammingdispatch)
#       define DIA0DIAGRAMMINGDISPATCHPRIVATE      extern __private(dia0diagrammingdispatch)
#   elif defined(_WIN32)
#       define DIA0DIAGRAMMINGDISPATCHEXPORT       __declspec(dllexport)
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define DIA0DIAGRAMMINGDISPATCHPRIVATE      extern
#   else
#       define DIA0DIAGRAMMINGDISPATCHEXPORT
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern
#       define DIA0DIAGRAMMINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define DIA0DIAGRAMMINGDISPATCHEXPORT       __export(dia0diagrammingdispatch)
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern __global(dia0diagrammingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define DIA0DIAGRAMMINGDISPATCHEXPORT      __declspec(dllimport)
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define DIA0DIAGRAMMINGDISPATCHEXPORT
#       define DIA0DIAGRAMMINGDISPATCHGLOBAL       extern
#   endif
#endif
