/*==================================================================================================

                    Copyright (c) 2003 UGS PLM Solutions
                             Unpublished - All rights reserved

====================================================================================================
File description:

    Filename: ifail.hxx
    Module  : fclasses

    @file 
    A throwable ifail class which stacks an error (or uses the last one on the stack )

    @deprecated It will be removed from Tc11.
    <br/>The new format of inclusion is #include <base_utils/IFail.hxx> instead of #include <fclasses/ifail.hxx>.

==================================================================================================
   Date      Name                    Description of Change
01-Dec-2003  Nigel Morse             created
05-Mar-2004  Brendan Brolly          Rework of the extern C linkage as part of the NX3 rebase.
20-Sep-2004  Dan J Archer            Integration with ResultStatus class
24-Sep-2004  Dan J Archer            Integration with ResultStatus class
13-Oct-2004  Jeff Currier            added getAndClearErrorStack
05-Nov-2004  Dan J Archer            Merge out from sdlint_v10.0
$HISTORY$
==================================================================================================*/

#ifndef FCLASSES_IFAIL_HXX_INCLUDED
#define FCLASSES_IFAIL_HXX_INCLUDED

#include <common/tc_deprecation_macros.h>
#include <fclasses/tc_basic.h>
#include <vector>
#include <string>
#include <ostream>

using std::vector;
using std::string;

class ResultStatus;

/* @deprecated #fclasses/ifail.hxx deprecated in Teamcenter 9.0. Use #base_utils/IFail.hxx instead. */
#define TC_include_fclasses_ifail_hxx_deprecated // define a unique deprecation macro name (having 63 chars or less)
TC_DEPRECATED_PREPROCESSOR( "9.0", TC_include_fclasses_ifail_hxx_deprecated, "base_utils/IFail.hxx" ) 
TC_include_fclasses_ifail_hxx_deprecated // use the deprecated macro so that the compiler issues the deprecation warning

#include <base_utils/IFail.hxx> // forward include the new file location

#endif // FCLASSES_IFAIL_HXX_INCLUDED
