//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  lis0lisfmwrkdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            liblis0lisfmwrkdispatch

#if !defined(LIBLIS0LISFMWRKDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBLIS0LISFMWRKDISPATCH is not defined
#endif

/* Handwritten code should use LIS0LISFMWRKDISPATCH_API, not LIS0LISFMWRKDISPATCHEXPORT */

#define LIS0LISFMWRKDISPATCH_API LIS0LISFMWRKDISPATCHEXPORT

#if IPLIB==liblis0lisfmwrkdispatch || defined(LIBLIS0LISFMWRKDISPATCH)
#   if defined(__lint)
#       define LIS0LISFMWRKDISPATCHEXPORT       __export(lis0lisfmwrkdispatch)
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern __global(lis0lisfmwrkdispatch)
#       define LIS0LISFMWRKDISPATCHPRIVATE      extern __private(lis0lisfmwrkdispatch)
#   elif defined(_WIN32)
#       define LIS0LISFMWRKDISPATCHEXPORT       __declspec(dllexport)
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern __declspec(dllexport)
#       define LIS0LISFMWRKDISPATCHPRIVATE      extern
#   else
#       define LIS0LISFMWRKDISPATCHEXPORT
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern
#       define LIS0LISFMWRKDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define LIS0LISFMWRKDISPATCHEXPORT       __export(lis0lisfmwrkdispatch)
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern __global(lis0lisfmwrkdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define LIS0LISFMWRKDISPATCHEXPORT      __declspec(dllimport)
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define LIS0LISFMWRKDISPATCHEXPORT
#       define LIS0LISFMWRKDISPATCHGLOBAL       extern
#   endif
#endif
