//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  mdc0mdconnectivitydispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libmdc0mdconnectivitydispatch

#if !defined(LIBMDC0MDCONNECTIVITYDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBMDC0MDCONNECTIVITYDISPATCH is not defined
#endif

/* Handwritten code should use MDC0MDCONNECTIVITYDISPATCH_API, not MDC0MDCONNECTIVITYDISPATCHEXPORT */

#define MDC0MDCONNECTIVITYDISPATCH_API MDC0MDCONNECTIVITYDISPATCHEXPORT

#if IPLIB==libmdc0mdconnectivitydispatch || defined(LIBMDC0MDCONNECTIVITYDISPATCH)
#   if defined(__lint)
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT       __export(mdc0mdconnectivitydispatch)
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern __global(mdc0mdconnectivitydispatch)
#       define MDC0MDCONNECTIVITYDISPATCHPRIVATE      extern __private(mdc0mdconnectivitydispatch)
#   elif defined(_WIN32)
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT       __declspec(dllexport)
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern __declspec(dllexport)
#       define MDC0MDCONNECTIVITYDISPATCHPRIVATE      extern
#   else
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern
#       define MDC0MDCONNECTIVITYDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT       __export(mdc0mdconnectivitydispatch)
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern __global(mdc0mdconnectivitydispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT      __declspec(dllimport)
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define MDC0MDCONNECTIVITYDISPATCHEXPORT
#       define MDC0MDCONNECTIVITYDISPATCHGLOBAL       extern
#   endif
#endif
