//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  pdg0ptndesigngdlinesdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libpdg0ptndesigngdlinesdispatch

#if !defined(LIBPDG0PTNDESIGNGDLINESDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPDG0PTNDESIGNGDLINESDISPATCH is not defined
#endif

/* Handwritten code should use PDG0PTNDESIGNGDLINESDISPATCH_API, not PDG0PTNDESIGNGDLINESDISPATCHEXPORT */

#define PDG0PTNDESIGNGDLINESDISPATCH_API PDG0PTNDESIGNGDLINESDISPATCHEXPORT

#if IPLIB==libpdg0ptndesigngdlinesdispatch || defined(LIBPDG0PTNDESIGNGDLINESDISPATCH)
#   if defined(__lint)
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT       __export(pdg0ptndesigngdlinesdispatch)
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern __global(pdg0ptndesigngdlinesdispatch)
#       define PDG0PTNDESIGNGDLINESDISPATCHPRIVATE      extern __private(pdg0ptndesigngdlinesdispatch)
#   elif defined(_WIN32)
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT       __declspec(dllexport)
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PDG0PTNDESIGNGDLINESDISPATCHPRIVATE      extern
#   else
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern
#       define PDG0PTNDESIGNGDLINESDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT       __export(pdg0ptndesigngdlinesdispatch)
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern __global(pdg0ptndesigngdlinesdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT      __declspec(dllimport)
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PDG0PTNDESIGNGDLINESDISPATCHEXPORT
#       define PDG0PTNDESIGNGDLINESDISPATCHGLOBAL       extern
#   endif
#endif
