//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  prg1programplanningapp

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libprg1programplanningapp

#if !defined(LIBPRG1PROGRAMPLANNINGAPP) && !defined(IPLIB)
#   error IPLIB or LIBPRG1PROGRAMPLANNINGAPP is not defined
#endif

/* Handwritten code should use PRG1PROGRAMPLANNINGAPP_API, not PRG1PROGRAMPLANNINGAPPEXPORT */

#define PRG1PROGRAMPLANNINGAPP_API PRG1PROGRAMPLANNINGAPPEXPORT

#if IPLIB==libprg1programplanningapp || defined(LIBPRG1PROGRAMPLANNINGAPP)
#   if defined(__lint)
#       define PRG1PROGRAMPLANNINGAPPEXPORT       __export(prg1programplanningapp)
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern __global(prg1programplanningapp)
#       define PRG1PROGRAMPLANNINGAPPPRIVATE      extern __private(prg1programplanningapp)
#   elif defined(_WIN32)
#       define PRG1PROGRAMPLANNINGAPPEXPORT       __declspec(dllexport)
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern __declspec(dllexport)
#       define PRG1PROGRAMPLANNINGAPPPRIVATE      extern
#   else
#       define PRG1PROGRAMPLANNINGAPPEXPORT
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern
#       define PRG1PROGRAMPLANNINGAPPPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRG1PROGRAMPLANNINGAPPEXPORT       __export(prg1programplanningapp)
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern __global(prg1programplanningapp)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRG1PROGRAMPLANNINGAPPEXPORT      __declspec(dllimport)
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern __declspec(dllimport)
#   else
#       define PRG1PROGRAMPLANNINGAPPEXPORT
#       define PRG1PROGRAMPLANNINGAPPGLOBAL       extern
#   endif
#endif
