//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  prg1programplanningappdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libprg1programplanningappdispatch

#if !defined(LIBPRG1PROGRAMPLANNINGAPPDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBPRG1PROGRAMPLANNINGAPPDISPATCH is not defined
#endif

/* Handwritten code should use PRG1PROGRAMPLANNINGAPPDISPATCH_API, not PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT */

#define PRG1PROGRAMPLANNINGAPPDISPATCH_API PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT

#if IPLIB==libprg1programplanningappdispatch || defined(LIBPRG1PROGRAMPLANNINGAPPDISPATCH)
#   if defined(__lint)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT       __export(prg1programplanningappdispatch)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern __global(prg1programplanningappdispatch)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHPRIVATE      extern __private(prg1programplanningappdispatch)
#   elif defined(_WIN32)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT       __declspec(dllexport)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern __declspec(dllexport)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHPRIVATE      extern
#   else
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern
#       define PRG1PROGRAMPLANNINGAPPDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT       __export(prg1programplanningappdispatch)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern __global(prg1programplanningappdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT      __declspec(dllimport)
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define PRG1PROGRAMPLANNINGAPPDISPATCHEXPORT
#       define PRG1PROGRAMPLANNINGAPPDISPATCHGLOBAL       extern
#   endif
#endif
