//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//e
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  qc0qualitycenterbasedispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libqc0qualitycenterbasedispatch

#if !defined(LIBQC0QUALITYCENTERBASEDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBQC0QUALITYCENTERBASEDISPATCH is not defined
#endif

/* Handwritten code should use QC0QUALITYCENTERBASEDISPATCH_API, not QC0QUALITYCENTERBASEDISPATCHEXPORT */

#define QC0QUALITYCENTERBASEDISPATCH_API QC0QUALITYCENTERBASEDISPATCHEXPORT

#if IPLIB==libqc0qualitycenterbasedispatch || defined(LIBQC0QUALITYCENTERBASEDISPATCH)
#   if defined(__lint)
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT       __export(qc0qualitycenterbasedispatch)
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern __global(qc0qualitycenterbasedispatch)
#       define QC0QUALITYCENTERBASEDISPATCHPRIVATE      extern __private(qc0qualitycenterbasedispatch)
#   elif defined(_WIN32)
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT       __declspec(dllexport)
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern __declspec(dllexport)
#       define QC0QUALITYCENTERBASEDISPATCHPRIVATE      extern
#   else
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern
#       define QC0QUALITYCENTERBASEDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT       __export(qc0qualitycenterbasedispatch)
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern __global(qc0qualitycenterbasedispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT      __declspec(dllimport)
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define QC0QUALITYCENTERBASEDISPATCHEXPORT
#       define QC0QUALITYCENTERBASEDISPATCHGLOBAL       extern
#   endif
#endif
