//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceeventmanagement

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceeventmanagement

#if !defined(LIBSERVICEEVENTMANAGEMENT) && !defined(IPLIB)
#   error IPLIB or LIBSERVICEEVENTMANAGEMENT is not defined
#endif

/* Handwritten code should use SERVICEEVENTMANAGEMENT_API, not SERVICEEVENTMANAGEMENTEXPORT */

#define SERVICEEVENTMANAGEMENT_API SERVICEEVENTMANAGEMENTEXPORT

#if IPLIB==libserviceeventmanagement || defined(LIBSERVICEEVENTMANAGEMENT)
#   if defined(__lint)
#       define SERVICEEVENTMANAGEMENTEXPORT       __export(serviceeventmanagement)
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern __global(serviceeventmanagement)
#       define SERVICEEVENTMANAGEMENTPRIVATE      extern __private(serviceeventmanagement)
#   elif defined(_WIN32)
#       define SERVICEEVENTMANAGEMENTEXPORT       __declspec(dllexport)
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern __declspec(dllexport)
#       define SERVICEEVENTMANAGEMENTPRIVATE      extern
#   else
#       define SERVICEEVENTMANAGEMENTEXPORT
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern
#       define SERVICEEVENTMANAGEMENTPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICEEVENTMANAGEMENTEXPORT       __export(serviceeventmanagement)
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern __global(serviceeventmanagement)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICEEVENTMANAGEMENTEXPORT      __declspec(dllimport)
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICEEVENTMANAGEMENTEXPORT
#       define SERVICEEVENTMANAGEMENTGLOBAL       extern
#   endif
#endif
