//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  serviceschedulingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libserviceschedulingdispatch

#if !defined(LIBSERVICESCHEDULINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSERVICESCHEDULINGDISPATCH is not defined
#endif

/* Handwritten code should use SERVICESCHEDULINGDISPATCH_API, not SERVICESCHEDULINGDISPATCHEXPORT */

#define SERVICESCHEDULINGDISPATCH_API SERVICESCHEDULINGDISPATCHEXPORT

#if IPLIB==libserviceschedulingdispatch || defined(LIBSERVICESCHEDULINGDISPATCH)
#   if defined(__lint)
#       define SERVICESCHEDULINGDISPATCHEXPORT       __export(serviceschedulingdispatch)
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern __global(serviceschedulingdispatch)
#       define SERVICESCHEDULINGDISPATCHPRIVATE      extern __private(serviceschedulingdispatch)
#   elif defined(_WIN32)
#       define SERVICESCHEDULINGDISPATCHEXPORT       __declspec(dllexport)
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SERVICESCHEDULINGDISPATCHPRIVATE      extern
#   else
#       define SERVICESCHEDULINGDISPATCHEXPORT
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern
#       define SERVICESCHEDULINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SERVICESCHEDULINGDISPATCHEXPORT       __export(serviceschedulingdispatch)
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern __global(serviceschedulingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SERVICESCHEDULINGDISPATCHEXPORT      __declspec(dllimport)
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SERVICESCHEDULINGDISPATCHEXPORT
#       define SERVICESCHEDULINGDISPATCHGLOBAL       extern
#   endif
#endif
