//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  ssm0systemsynthesismodelingdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libssm0systemsynthesismodelingdispatch

#if !defined(LIBSSM0SYSTEMSYNTHESISMODELINGDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBSSM0SYSTEMSYNTHESISMODELINGDISPATCH is not defined
#endif

/* Handwritten code should use SSM0SYSTEMSYNTHESISMODELINGDISPATCH_API, not SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT */

#define SSM0SYSTEMSYNTHESISMODELINGDISPATCH_API SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT

#if IPLIB==libssm0systemsynthesismodelingdispatch || defined(LIBSSM0SYSTEMSYNTHESISMODELINGDISPATCH)
#   if defined(__lint)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT       __export(ssm0systemsynthesismodelingdispatch)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern __global(ssm0systemsynthesismodelingdispatch)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHPRIVATE      extern __private(ssm0systemsynthesismodelingdispatch)
#   elif defined(_WIN32)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT       __declspec(dllexport)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern __declspec(dllexport)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHPRIVATE      extern
#   else
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT       __export(ssm0systemsynthesismodelingdispatch)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern __global(ssm0systemsynthesismodelingdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT      __declspec(dllimport)
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHEXPORT
#       define SSM0SYSTEMSYNTHESISMODELINGDISPATCHGLOBAL       extern
#   endif
#endif
