//Copyright 2020 Siemens Digital Industries Software
//==================================================
//Copyright $2020.
//Siemens Product Lifecycle Management Software Inc.
//All Rights Reserved.
//==================================================
//Copyright 2020 Siemens Digital Industries Software

/** 
    @file 

    This file contains the declaration for the Dispatch Library  vendormanagementdispatch

*/

#include <common/library_indicators.h>

#ifdef EXPORTLIBRARY
#define EXPORTLIBRARY something else
#error ExportLibrary was already defined
#endif

#define EXPORTLIBRARY            libvendormanagementdispatch

#if !defined(LIBVENDORMANAGEMENTDISPATCH) && !defined(IPLIB)
#   error IPLIB or LIBVENDORMANAGEMENTDISPATCH is not defined
#endif

/* Handwritten code should use VENDORMANAGEMENTDISPATCH_API, not VENDORMANAGEMENTDISPATCHEXPORT */

#define VENDORMANAGEMENTDISPATCH_API VENDORMANAGEMENTDISPATCHEXPORT

#if IPLIB==libvendormanagementdispatch || defined(LIBVENDORMANAGEMENTDISPATCH)
#   if defined(__lint)
#       define VENDORMANAGEMENTDISPATCHEXPORT       __export(vendormanagementdispatch)
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern __global(vendormanagementdispatch)
#       define VENDORMANAGEMENTDISPATCHPRIVATE      extern __private(vendormanagementdispatch)
#   elif defined(_WIN32)
#       define VENDORMANAGEMENTDISPATCHEXPORT       __declspec(dllexport)
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllexport)
#       define VENDORMANAGEMENTDISPATCHPRIVATE      extern
#   else
#       define VENDORMANAGEMENTDISPATCHEXPORT
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern
#       define VENDORMANAGEMENTDISPATCHPRIVATE      extern
#   endif
#else
#   if defined(__lint)
#       define VENDORMANAGEMENTDISPATCHEXPORT       __export(vendormanagementdispatch)
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern __global(vendormanagementdispatch)
#   elif defined(_WIN32) && !defined(WNT_STATIC_LINK)
#       define VENDORMANAGEMENTDISPATCHEXPORT      __declspec(dllimport)
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern __declspec(dllimport)
#   else
#       define VENDORMANAGEMENTDISPATCHEXPORT
#       define VENDORMANAGEMENTDISPATCHGLOBAL       extern
#   endif
#endif
