#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int Cut_ScheduleTask(EPM_action_message_t msg) {
	printf("=========================ɾʱ Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char resultString[1024] = "";

	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//˵ʱĶ
		if ((strstr(itemType, "Schedule") == NULL))
		{
			DOFREE(itemType);
			continue;
		}

		//ȡʱӦĻʱ
		tag_t bakScheduleTaskTags = NULLTAG;
		//ȡʱ
		AOM_ask_value_tag(attachments[i], "fnd0SummaryTask", &bakScheduleTaskTags);

		tag_t scheduleTaskTags = NULLTAG;
		//ȡʱ
		AOM_ask_value_tag(bakScheduleTaskTags, "original_task_tag", &scheduleTaskTags);
		//ȡ߶Ӧʱ
		tag_t scheduleTags = NULLTAG;
		//ȡʱ
		AOM_ask_value_tag(scheduleTaskTags, "schedule_tag",&scheduleTags);

		POM_AM__set_application_bypass(true);
		cutScheduleTask(bakScheduleTaskTags, scheduleTags);
		POM_AM__set_application_bypass(false);

		DOFREE(itemType);
		DOFREE(itemTags);
	}

	DOFREE(attachments);

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "Cut_ScheduleTaskʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "Cut_ScheduleTaskʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================ɾʱ End===================\n");
	return ifail;
}

void cutScheduleTask(tag_t scheduleTaskTags,tag_t scheduleTags)
{
	//жϱʾµĶǷʱ
	int itemNum = 0;
	tag_t * itemTags = NULLTAG;

	AOM_ask_value_tags(scheduleTaskTags, "child_task_taglist", &itemNum, &itemTags);
	if (itemNum > 0)
	{
		int cutItemNum = 0;
		tag_t * cutItemTags = (tag_t *)MEM_alloc(1024 * sizeof(tag_t));

		//жǷ
		for (int i = 0; i < itemNum; i++)
		{
			char * value = NULL;
			AOM_ask_value_string(itemTags[i], "ml8_CutOrNot", &value);
			if (strcmp(value, "") == 0)
			{
				tag_t scheduleTaskTags = NULLTAG;
				//ȡʱ
				AOM_ask_value_tag(itemTags[i], "original_task_tag", &scheduleTaskTags);
				AOM_lock(scheduleTaskTags);
				AOM_set_value_string(scheduleTaskTags, "ml8_FilingRequirements", "N");
				AOM_save(scheduleTaskTags);
				AOM_unlock(scheduleTaskTags);
				AOM_refresh(scheduleTaskTags, false);

				cutItemTags[cutItemNum] = scheduleTaskTags;
				cutItemNum++;
			}
			else
			{
				cutScheduleTask(itemTags[i], scheduleTags);
			}
		}
		if (cutItemNum > 0)
		{
			int itasks = 0;
			int iOrtasks = 0;
			tag_t* ptTasks = NULL;
			tag_t* ptOrTasks = NULL;

			SCHMGT_delete_tasks_non_interactive(scheduleTags, cutItemNum, cutItemTags, &itasks, &ptTasks, &iOrtasks, &ptOrTasks);
			DOFREE(ptTasks);
			DOFREE(ptOrTasks);
		}
		
		DOFREE(itemTags);
	}


}