#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_CreateBomView(EPM_action_message_t msg)
{
	printf("=========================BOMͼ Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "";
	//ȡ
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				//strcmp("","");
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
		}
		DOFREE(argflag);
		DOFREE(argvalue);
		DOFREE(arg);
	}

	vector<char *> itemTypeValues;

	if (strstr(arg1value, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(arg1value, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			itemTypeValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		itemTypeValues.push_back(arg1value);
	}

	POM_AM__set_application_bypass(TRUE);
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s \r\n", itemType);
		//˵ǰ汾Ķ
		if (!count(itemTypeValues, itemType))
		{
			DOFREE(itemType);
			continue;
		}

		//жӼ
		char * child = NULL;
		//жǷBOMͼ
		AOM_ask_value_string(attachments[i], "ml8_Child", &child);
		if (child == NULL || strcmp(child, "") == 0)
		{
			DOFREE(itemType);
			DOFREE(child);
			continue;
		}
		int viewNum = 0;
		tag_t * viewTag = NULL_TAG;
		//жǷBOMͼ
		AOM_ask_value_tags(attachments[i], "structure_revisions", &viewNum, &viewTag);
		if (viewNum > 0)
		{
			DOFREE(itemType);
			DOFREE(viewTag);
			continue;
		}
		//ȡ
		/*tag_t attOwning_user = NULL_TAG;
		tag_t assign_goup_mem = NULL_TAG;
		tag_t o_group_tag = NULL_TAG;

		AOM_ask_value_tag(rootTask, "owning_user", &attOwning_user);
		AOM_ask_value_tag(attOwning_user, "group_member", &assign_goup_mem);
		if (assign_goup_mem != NULL_TAG) {

			AOM_ask_value_tag(assign_goup_mem, "group", &o_group_tag);

		}*/
		//BOMWindow
		tag_t item = NULLTAG;
		ITEM_ask_item_of_rev(attachments[i], &item);


		tag_t tBv = NULLTAG;
		PS_create_bom_view(NULLTAG, "", "", item, &tBv);
		//Ϊ
		//AOM_lock(tBv);
		//AOM_set_ownership(tBv, attOwning_user, o_group_tag);
		AOM_save(tBv);
		//unlock
		//AOM_unlock(tBv);
		//AOM_refresh(tBv, FALSE);
		tag_t tBvr = NULLTAG;
		PS_create_bvr(tBv, "", "", false, attachments[i], &tBvr);
		//Ϊ
		//AOM_lock(tBvr);
		//AOM_set_ownership(tBvr, attOwning_user, o_group_tag);
		AOM_save(tBvr);
		//unlock
		//AOM_unlock(tBvr);
		//AOM_refresh(tBvr, FALSE);
		AOM_save(item);




		DOFREE(itemType);
		DOFREE(child);
		DOFREE(viewTag);

	}
	POM_AM__set_application_bypass(FALSE);
	DOFREE(attachments);

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_CreateBomViewʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_CreateBomViewʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================BOMͼ End===================\n");
	return ifail;
}
