#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

int ML_ReferencedIsHaveItem(EPM_action_message_t msg)
{
	printf("=========================жϹϵļǷͬ Start===================\n");
	auto startTime = std::chrono::high_resolution_clock::now();
	int ifail = ITK_ok;
	int  attachments_num = 0;
	tag_t  rootTask = NULLTAG, *attachments = NULLTAG;
	//ȡ
	EPM_ask_root_task(msg.task, &rootTask);
	//ȡĿ
	EPM_ask_attachments(rootTask, EPM_target_attachment, &attachments_num, &attachments);

	char *argflag = NULL, *argvalue = NULL, *arg = NULL;
	char arg1value[1024] = "", arg2value[1024] = "", arg3value[1024] = "";
	//ȡ
	int arg_cnt = TC_number_of_arguments(msg.arguments);
	printf("Ϊ%d\n", arg_cnt);
	if (arg_cnt > 0)
	{
		for (int i = 0; i<arg_cnt; i++)
		{
			//ȡһ0ʼ
			arg = TC_next_argument(msg.arguments);
			//ȡƺֵ
			ifail = ITK_ask_argument_named_value((const char*)arg, &argflag, &argvalue);
			if (stricmp(argflag, "itemType") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg1value, argvalue);
				}
			}
			else if (stricmp(argflag, "referenced") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg2value, argvalue);
				}
			}
			else if (stricmp(argflag, "referenced2") == 0)
			{
				if (argvalue != NULL)
				{
					strcpy(arg3value, argvalue);
				}
			}
		}
	}

	char resultString[1024] = "";
	for (int i = 0; i < attachments_num; i++)
	{
		char *itemType = NULL;

		AOM_ask_value_string(attachments[i], "object_type", &itemType);
		printf("type_class : %s,arg1value%s \r\n", itemType, arg1value);
		//˵ǰ汾Ķ
		if ((strcmp(itemType, arg1value) != 0))
		{
			DOFREE(itemType);
			continue;
		}
		vector<char *> puidList;
		int tagNum = 0;
		tag_t * tags = NULLTAG;
		//ȡָϵµĶ
		AOM_ask_value_tags(attachments[i], arg2value, &tagNum, &tags);
		for (int j = 0; j < tagNum; j++)
		{
			char * tag_uid = NULL;
			//Uidȡݼ
			ITK__convert_tag_to_uid(tags[j], &tag_uid);
			puidList.push_back(tag_uid);
		}
		
		int tagNum2 = 0;
		tag_t * tags2 = NULLTAG;
		//ȡָϵµĶ
		AOM_ask_value_tags(attachments[i], arg3value, &tagNum2, &tags2);
		for (int j = 0; j < tagNum2; j++)
		{
			char * tag_uid = NULL;
			//Uidȡݼ
			ITK__convert_tag_to_uid(tags2[j], &tag_uid);

			int count = puidList.size();
			for (int k = 0; k < count; k++)
			{
				if (strcmp(puidList.at(k), tag_uid) == 0)
				{
					char * objectString = NULL;
					AOM_ask_value_string(tags2[j], "object_string", &objectString);

					strcat(resultString, objectString);
					strcat(resultString, "\n");
					ifail = 1;
					DOFREE(objectString);
					break;
				}
			}
			DOFREE(tag_uid);
		}
		puidList.clear();
		vector<char *>().swap(puidList);
		DOFREE(tags);
		DOFREE(tags2);
		DOFREE(itemType);
	}
	DOFREE(attachments); 
	if (ifail == 1)
	{
		strcat(resultString, "ϵ¶ڣ");
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, resultString);
	}

	auto stopTime = std::chrono::high_resolution_clock::now();
	auto duration = std::chrono::duration_cast<std::chrono::microseconds>(stopTime - startTime);
	//std::cout << "ML_ReferencedIsHaveItemʱ:" << duration.count() / 1000 << std::endl;
	string usetime = "ML_ReferencedIsHaveItemʱ:";
	usetime.append(std::to_string(duration.count() / 1000));
	WriteLog(true, usetime.c_str());
	printf("=========================жϹϵļǷͬ End===================\n");
	return ifail;
}