#define _CRT_SECURE_NO_WARNINGS
#include "epm_handler_common.h"

void getTCMUserItemJsonCostCollector(int index,tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000]);
void getTCMUserBomLinePropertyCostCollector(tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char * bomBaseNum, char parameters[100000]);
void getTCMUserBomLineChildPropertyCostCollector(tag_t topLine, map<string, string> typePropertyType, char parameters[100000]);

bool isUserBomCostCollectorStart = true;

void getTCMUserItemBomPropertyCostCollector(tag_t item, map<string, string> typePropertyType, char parameters[100000] = "")
{
	char *itemType = NULL;
	AOM_ask_value_string(item, "object_type", &itemType);

	printf("itemType%s Start===================\n", itemType);

	//˵ǰ汾Ķ
	if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
		|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0))
	{
		//жǷ񷢲
		int releaseCount = 0;
		tag_t * releaseTag = NULL_TAG;
		//жӼǷ񷢲
		AOM_ask_value_tags(item, "release_status_list", &releaseCount, &releaseTag);

		printf("״̬%d===================\n", releaseCount);
		if (releaseCount <= 0)
		{
			MEM_free(releaseTag);
			MEM_free(itemType);
			return;
		}
		char * lineCode = NULL;//ߴ
		AOM_ask_value_string(item, "ml8_LineCode", &lineCode);
		if (lineCode == NULL || strcmp(lineCode, "") == 0)
		{
			MEM_free(lineCode);
			MEM_free(itemType);
			return;
		}
		//ȡаĿBOM
		vector<tag_t> bomLines;
		//ȡ
		tag_t top_line = NULLTAG, window = NULLTAG;
		BOM_create_window(&window);
		//öBOM
		BOM_set_window_top_line(window, NULLTAG, item, NULLTAG, &top_line);
		//ȡjsonַ
		if (isUserBomCostCollectorStart)
		{
			getTCMUserItemJsonCostCollector(-1, top_line, NULLTAG, typePropertyType, parameters);
			isUserBomCostCollectorStart = false;
		}
		else
		{
			getTCMUserItemJsonCostCollector(-1, top_line, NULLTAG, typePropertyType, parameters);
		}
		//ȡBOM
		getTCMUserBomLineChildPropertyCostCollector(top_line, typePropertyType, parameters);


		BOM_close_window(window);
		/*MEM_free(addTrade);
		MEM_free(processingMode);
		MEM_free(childItem);*/
	}

	MEM_free(itemType);
}

int ML_TCMUserSendSapCostCollector(void * returnValue)
{
	printf("=========================TCM ɱռ·SAP Start===================\n");
	int ifail = ITK_ok;
	tag_t item = NULLTAG;
	char * messageUser = NULL;
	USERARG_get_tag_argument(&item);
	USERARG_get_string_argument(&messageUser);

	vector<char *> messageUserValues;

	if (strstr(messageUser, ",") != NULL)
	{
		int vectorValueCount = 0;
		char ** vectorValueChar = new char *[64];
		split(messageUser, ",", vectorValueChar, &vectorValueCount);
		for (int i = 0; i < vectorValueCount; i++)
		{
			messageUserValues.push_back(vectorValueChar[i]);
		}
	}
	else
	{
		messageUserValues.push_back(messageUser);
	}

	int pref_cnt = 0;
	char ** pref_vals = NULL;
	//ȡѡֵ
	PREF_ask_char_values("ML_TCMBOMSendSapProperty", &pref_cnt, &pref_vals);
	map<string, string> typePropertyType;
	for (int j = 0; j < pref_cnt; j++)
	{
		if (strstr(pref_vals[j], "-") != NULL)
		{
			//-в֡
			int valueCount = 0;
			char ** valueChar = new char *[64];
			//ַָ
			split(pref_vals[j], "-", valueChar, &valueCount);
			typePropertyType[valueChar[0]] = valueChar[1];// .insert(std::pair<char*, char*>(valueChar[0], valueChar[1]));
		}
	}

	char *tc_root_file = getenv("tc_root");		//C:\Siemens\Teamcenter11
	char parameters[100000] = "";//д뵽ļֵ
	strcat(parameters, "getTCMBomCostCollectorPropertys}}");
	strcat(parameters, messageUser);
	strcat(parameters, "}}");
	strcat(parameters, "<n0:MT_TCM2SAP_CS01 xmlns:n0=\"urn:changhong.com:TCM:mlsc\">");

	getTCMUserItemBomPropertyCostCollector(item, typePropertyType, parameters);
	strcat(parameters, "</n0:MT_TCM2SAP_CS01>");
	isUserBomCostCollectorStart = true;
	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	//дļ
	char data_file[SS_MAXPATHLEN] = "";
	strcat(data_file, tc_root_file);
	strcat(data_file, "\\");
	strcat(data_file, date);
	strcat(data_file, ".txt");

	ofstream file;
	file.open(data_file);
	file << parameters << endl; // ʹcoutͬķʽд
	file.close();

	string strResult;

	//cmdָ
	char cmd[256] = "";
	strcpy(cmd, "java -jar \"");
	//strcat(cmd, jar_file);
	strcat(cmd, tc_root_file);
	strcat(cmd, "\\portal\\plugins\\");
	strcat(cmd, "ML_SendSap.jar");
	strcat(cmd, "\" ");
	//
	cout << data_file << endl;
	strcat(cmd, data_file);
	//ݱ̵(@ָ)
	//strcat(cmd,"@");
	//strcat(cmd,handler_name);
	printf("·:\n%s\n", cmd);
	char buf[8000] = { 0 };
	FILE *pf = NULL;
	if ((pf = _popen(cmd, "r")) == NULL) {
		printf("ӿڷ:\n%s", "1");
	}

	while (fgets(buf, sizeof buf, pf)) {
		strResult += buf;
	}
	_pclose(pf);

	cout << strResult << endl;
	unsigned int iSize = strResult.size();
	if (iSize > 0 && strResult[iSize - 1] == '\n' && strlen(parameters) > 0)
	{
		strResult = strResult.substr(0, iSize - 1);
		printf("·ʧ\n");
		cout << strResult << endl;
		//Ϣҵ΢
		for (auto messageUserValue : messageUserValues) {
			BOMSendToWeixin(messageUserValue, NULLTAG, strResult);
		}
	}
	else
	{
		POM_AM__set_application_bypass(TRUE);
		//ȡ״ηʱ
		char *itemType = NULL;
		AOM_ask_value_string(item, "object_type", &itemType);
		//˵ǰ汾Ķ
		if ((strcmp(itemType, "ML8_RefrigeratorRevision") == 0) || (strcmp(itemType, "ML8_WashingRevision") == 0)
			|| (strcmp(itemType, "ML8_ColdRevision") == 0) || (strcmp(itemType, "ML8_OthersRevision") == 0) || (strcmp(itemType, "ML8_PartRevision") == 0))
		{
			//ȡǰʱ
			time_t now = time(0);
			tm *p = localtime(&now);

			char dateNow[128] = "";
			sprintf_s(dateNow, "%04d-%02d-%02d %02d:%02d:%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

			AOM_lock(item);
			/*if (sendTime == NULL || strcmp(sendTime, "") == 0)
			{
			AOM_set_value_string(attachments[i], "ml8_BOMFirstTime", dateNow);
			}
			else
			{
			AOM_set_value_string(attachments[i], "ml8_BOMNewTime", dateNow);
			}*/
			AOM_save(item);
			AOM_unlock(item);
			AOM_refresh(item, false);
		}
		DOFREE(itemType);
		POM_AM__set_application_bypass(FALSE);
	}
	messageUserValues.clear();
	vector<char *>().swap(messageUserValues);
	tc_root_file = NULL;
	pref_vals = NULL;

	if (ifail == 1)
	{
		EMH_store_error_s1(EMH_severity_user_error, EMH_USER_error_base, strResult.c_str());
	}
	printf("=========================TCM ɱռ·SAP End===================\n");
	return ifail;
}

void getTCMUserItemJsonCostCollector(int index,tag_t topLine, tag_t BomLine, map<string, string> typePropertyType, char parameters[100000])
{
	//ȡ
	char * matnr = NULL;//ϱ
	char * werks = NULL;//
	
	tag_t revisions = NULLTAG;

	AOM_ask_value_tag(topLine, "bl_line_object", &revisions);

	AOM_ask_value_string(topLine, "bl_item_item_id", &matnr);

	if (strstr(matnr, "-") != NULL)
	{
		//,в֡
		int matnrCount = 0;
		char ** matnrChar = new char *[64];
		//ַָ
		split(matnr, "-", matnrChar, &matnrCount);

		matnr = matnrChar[0];
	}

	AOM_ask_value_string(revisions, "ml8_Factory", &werks);
	
	//ȡǰʱ
	time_t now = time(0);
	tm *p = localtime(&now);

	char date[128] = "";
	sprintf_s(date, "%04d%02d%02d%02d%02d%02d", 1900 + p->tm_year, p->tm_mon + 1, p->tm_mday, p->tm_hour, p->tm_min, p->tm_sec);

	strcat(parameters, "<DATA>");
	strcat(parameters, "<MSG_HDR>");
	strcat(parameters, "<MSGID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</MSGID>");
	strcat(parameters, "<BUSID>");
	strcat(parameters, newGUID());
	strcat(parameters, "</BUSID>");
	strcat(parameters, "<TLGID>");
	strcat(parameters, "JT0001");
	strcat(parameters, "</TLGID>");
	strcat(parameters, "<TLGNAME>");
	strcat(parameters, "ɱռӿ");
	strcat(parameters, "</TLGNAME>");
	strcat(parameters, "<DTSEND>");
	strcat(parameters, date);
	strcat(parameters, "</DTSEND>");
	strcat(parameters, "<SENDER>");
	strcat(parameters, "TCM");
	strcat(parameters, "</SENDER>");
	strcat(parameters, "<RECEIVER>");
	strcat(parameters, "SAP");
	strcat(parameters, "</RECEIVER>");
	strcat(parameters, "<FREEUSE>");
	strcat(parameters, matnr);
	strcat(parameters, "</FREEUSE>");
	strcat(parameters, "</MSG_HDR>");
	strcat(parameters, "<MSG_BODY>");
	strcat(parameters, "<HEADER>");
	strcat(parameters, "<MATNR>");
	strcat(parameters, matnr);
	strcat(parameters, "</MATNR>");
	strcat(parameters, "<WERKS>");
	strcat(parameters, werks);
	strcat(parameters, "</WERKS>");
	strcat(parameters, "</HEADER>");

	strcat(parameters, "</MSG_BODY>");
	strcat(parameters, "</DATA>");

	DOFREE(matnr);
	DOFREE(werks);
	DOFREE(bomusage);
	DOFREE(alternative);
	DOFREE(validdate);
	DOFREE(description);
	DOFREE(basequan);
}

void getTCMUserBomLineChildPropertyCostCollector(tag_t topLine, map<string, string> typePropertyType, char parameters[100000])
{
	int  count;
	tag_t *children_line = NULLTAG;

	BOM_line_ask_all_child_lines(topLine, &count, &children_line);

	for (int i = 0; i < count; i++)
	{
		int  childCount;
		tag_t *children_bomLine = NULLTAG;

		BOM_line_ask_all_child_lines(children_line[i], &childCount, &children_bomLine);
		if (childCount > 0)
		{
			tag_t revisions = NULLTAG;

			AOM_ask_value_tag(children_line[i], "bl_line_object", &revisions);

			getTCMUserItemBomPropertyCostCollector(revisions, typePropertyType, parameters);
		}
		DOFREE(children_bomLine);
	}

	DOFREE(children_line);
}